/*
    Copyright 2007, 2008, 2009 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef COMMANDPARSER_H_
#define COMMANDPARSER_H_


#define DIALOGBLOCK "<dialog"
#define COMMANDBLOCK "<command"
#define OPTIONSBLOCK "<options"

#define KNOWNPREDEFINES {"ThisDirectory","TDIR","OtherDirectory","ODIR","MarkedItems","MI","MarkedItemsUnQuoted","MI_UQ","Home","home", "MarkedItemsWithPath", "MIWP","MarkedItemsWithPathUnQuoted", "MIWP_UQ" }
#define NUMBEROFPREDEFINES 14	//Change this if you add or remove a String to/from KownPredefines
								//Do not forget to change function decryptPredefine <- its the only point to change something

struct predefineStruct{
    GString *ThisDirectory;
    GString *OtherDirectory;
    GString *MarkedItems;
    GString *MarkedItemsUnQuoted;
    GString *MarkedItemsWithPath;
    GString *MarkedItemsWithPathUnQuoted;
};

enum{
	USERCOMMAND_CALLAS_CALLALL = 0,
	USERCOMMAND_CALLAS_CALLEACH,
	USERCOMMAND_CALLAS_LIST
};

int ParseUserCommand(GString *Command, GString *FileList, GString *FileListWithPath, GString *WorkPath, GString *OtherSidePath, GString **ActionNoteText, GString **QuitReplyText, struct updateList **UpdateFolderWhenFinished_List);
int UserCommandCallType(GString *Command, int *ip_CallType, GString **gstrCaption, GString **gstrLabel, GString **gstrCall);


#endif /*COMMANDPARSER_H_*/
