/*
    Copyright 2007, 2008, 2009 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef CONFIGHANDLING_H_
#define CONFIGHANDLING_H_


#define CATSEYEHOMEDIR ".catseye"
#define CONFIG_FILE_TYPES ".catseye/catseye_config_file.conf"
#define SAVE_FILE ".catseye/.catseye_saves"
#define PROGRAMSEPERATOR ";"
#define TYPESEPARATOR ":"

////////!!!!!!!!!!!!!!!!!      ONLY LOW CHARACTERS ARE ALLOWED!!!!!

////////Configfile /////////////
#define STANDARDEDITORKEY "stded"	//Keep in mind, that these keys are not allowde to be bigger than 9-lenof(TYPESEPARATOR) or so!!!!
#define SAVEPATHESONEXIT "svpths"	//Save pathes on exit, this is just for the decision wether to load or not, the pathes are stored in another file
#define TERMINALKEY "trmnl"
#define BOOKMARKS "bkmrk"
#define STANDARDSTARTDIRECTORY "strdd"	//Directory opened when calling new page from popup menue at the notebooks
#define STARTDIRECTORIESLEFTKEY "strtdl"
#define STARTDIRECTORIESRIGHTKEY "strtdr"
#define COUNTSFORALLITEMSKEY "allfls"	//A filetype identifier which defines userprograms which can used on all types of items (e.g. packing)

#define COLOR_ITEMS_DEFAULT "clritm"
#define COLOR_DIRECTORIES   "clrdir"
#define COLOR_LINKS         "clrlnk"
#define COLOR_ITEMS_MISSING "clrmss"
#define DEFAULT_COLOR_ITEMS_DEFAULT "Black"
#define DEFAULT_COLOR_DIRECTORIES   "Blue"
#define DEFAULT_COLOR_LINKS         "CornflowerBlue"
#define DEFAULT_COLOR_ITEMS_MISSING "Red"

#define COMMAND_MOVE "cmdmv"
#define COMMAND_COPY "cmdcp"
#define COMMAND_RENAME "cmdrnm"
#define COMMAND_DELETE "cmddel"
#define COMMAND_MAKEDIR "cmdmkdir"
#define DEFAULT_COMMAND_MOVE "mv -f"
#define DEFAULT_COMMAND_COPY "cp -rf"
#define DEFAULT_COMMAND_RENAME "mv"
#define DEFAULT_COMMAND_DELETE "rm -rf"
#define DEFAULT_COMMAND_MAKEDIR "mkdir"


///////// Savefile //////////
#define ALWAYS_SHOW_HIDDEN "alwshdn"	//Identifier within the savefile. Set or unset from within the internal menu. Uses a global varibale (int g_int_AlwaysShowHidden)

#define LASTPATHESLEFTKEY "lpl"	//in the file where the pathes are stored and loaded again on restart, these are the identifier for left and right
#define LASTPATHESRIGHTKEY "lpr"

#define LASTPATHLEFTID "lpl%dp"	//these are the identifier used in the savedfile to save the pathes ... 
#define LASTPATHRIGHTID "lpr%dp"
#define LASTPATHLEFTHIDDENID "lpl%dh"	//... and hidden property
#define LASTPATHRIGHTHIDDENID "lpr%dh"


struct myFiles_struct{
    FILE *File;
 //   int iWrite;                 //0=read, 1=write,create, 2=append,create
    int allreadystarted;
    GString *gstrFileName;      //including the path
    GString *gstrIdentifier;
    GString *gstrValue;
};


struct myFiles_struct *myFiles_openFile(char *FileName, char *cpMode);
int myFiles_closeFile(struct myFiles_struct *fileInfo);
int myFiles_getValueFromIdentifier(struct myFiles_struct *fileInfo, char *cpIdentifier, int again);
int myFiles_SeparateMultiValue(struct myFiles_struct *fileInfo, GString *name, GString *command, int ModusSingleOrPair);
int myFiles_SaveValueToFile(struct myFiles_struct *fileInfo, char* cpLine);

struct myFiles_struct *myFiles_openConfigTypesFile(char *cpMode);
int myFiles_ConfigFileSimpleGetValue(char *Identifier, GString *Value);

struct myFiles_struct *myFiles_openSaveFile( char *cpMode);
int myFiles_SaveFileSimpleSave(char *cpLine, char *Mode);
int myFiles_SaveFileSimpleGetValue(char *Identifier, GString *Value);


#endif //CONFIGHANDLING_H_













