/*
    Copyright 2007, 2008, 2009 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <string.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <dirent.h>	//Verzeichnis Zeiger und DIR - Struktur


#include "globalDefinitions.h"
#include "helpers.h"
#include "mytrace.h"
#include "listitems.h"


extern GtkTextBuffer *g_TextBuffer_CommandHistory;

void CursorToWait(GtkWidget *widget){

    //    GdkWindow *gdkwindow = GTK_WIDGET (win)->window;

//gint x,y;
//GdkWindow *gdkwindow = gdk_window_at_pointer(&x,&y);
//GdkWindow *gdkwindow = gtk_widget_get_parent_window        (Object->ScrollWindow);  //(GtkWidget *)win
//GdkWindow *gdkwindow = gtk_widget_get_root_window        (VPanedForFileShelf);  //2.2
//gtk_widget_get_window           //2.14

/*
    GdkCursor* cursor;
    cursor = gdk_cursor_new(GDK_WATCH); //GDK_WATCH     GDK_CLOCK
    gdk_window_set_cursor(gdkwindow, cursor);    //set the cursor to clock while we are updating        gdk_get_default_root_window()
    gdk_cursor_destroy(cursor);
*/
    //As long as changing the mouse cursor does not work, we change the text in the Notebooktab
 //   gtk_label_set_text(GTK_LABEL(Object->label),"please wait");



    GdkWindow *gdkwindow = gtk_widget_get_parent_window        (widget);
    if (gdkwindow != NULL){
        GdkCursor* cursor;
        cursor = gdk_cursor_new(GDK_WATCH); //GDK_WATCH     GDK_CLOCK
        gdk_window_set_cursor(gdkwindow, cursor);    //set the cursor to clock while we are updating        gdk_get_default_root_window()
        gdk_cursor_destroy(cursor);
    }
}


void CursorToNormal(GtkWidget *widget){
    GdkWindow *gdkwindow = gtk_widget_get_parent_window        (widget);
    gdk_window_set_cursor(gdkwindow, NULL);
}
/*
char *mine_strnstr(char *big, char *little, int size){
    //because the function strnstr (which is reproduced here) does not exist on Linux but only on FreeBSD I wrote this function
    //used in commandParser.c



}
*/

gboolean checkStringIsPath(char *cpPath){
    TRACEIT(10,"checkStringIsPath		start");
    if (cpPath == NULL){
        TRACEIT(2,"checkStringIsPath		end, Parameter NULL");
        return FALSE;
    }
    gboolean bRet=FALSE;

    bRet = g_file_test( cpPath, G_FILE_TEST_IS_DIR);

/*
    GString *gstrPath = g_string_new(cpPath);
    GString *gstrNames = g_string_new(cpPath);
    struct FileAttributs attribs;

    checkPathForLastCharOtherwise(gstrNames);
    getLastStringInPath(gstrNames);
    GetPathFromPathWithName(gstrPath, 1);
    if (strcmp(gstrNames->str,".")!=0 && strcmp(gstrNames->str,"..")!=0){
        fileAttributesGet(NULL, 0, &attribs, gstrPath->str, gstrNames->str);
        if (4 == attribs.type_d){
            bRet=TRUE;
        }
        else{
            bRet=FALSE;
        }
    }
    else{
        bRet = TRUE;
    }

    g_string_free(gstrPath, TRUE);
    g_string_free(gstrNames, TRUE);
*/
    TRACEIT(10,"checkStringIsPath		end");
    return bRet;
}





char *completionReturnFunction(GString *gstrString){
    return gstrString->str;
}

void *GListFreeGStrings (gpointer data, gpointer user_data){
    TRACEIT(10,"GListFreeGStrings		start");
    if (data == NULL){
        TRACEIT(2,"GListFreeGStrings		end, Parameter NULL");
        return NULL;
    }
    GString *gstrBuf = (GString *)data;
    g_string_free(gstrBuf, TRUE);
    TRACEIT(10,"GListFreeGStrings		end");
    return NULL;
}

int completePath(char *cpText, char **ToComplete){
    //ToComplete has to be freed !!!
    //return: -1:error, 0=all ready path, 1=completed but no directory, 2=completed valid directory
    TRACEIT(10,"completePath		start");

    if (cpText == NULL || ToComplete == NULL){
        TRACEIT(2,"completePath		end, parameter null");
        return -1;
    }
    DIR *Directory;
	struct dirent *dirzeiger;
	int DirectoryOpened=0;
	GString *gstrNames=g_string_sized_new(10);
	GString *gstrPath=g_string_sized_new(10);
    struct FileAttributs attribs;
    GList *listDirs=NULL;
    GCompletion *completion=NULL;

    g_string_assign(gstrPath, cpText);
    if (0 == GetPathFromPathWithName (gstrPath, 0)){ //0=Already Path
        g_string_free(gstrNames,TRUE);
        g_string_free(gstrPath,TRUE);
        TRACEIT(10,"completePath		end");
        return 0;
    }

    openDirectory(&Directory, &DirectoryOpened, gstrPath);
    getNextListItem(Directory, &dirzeiger, DirectoryOpened, gstrNames);

    checkPathForLastChar(gstrPath);
    while ( strlen(gstrNames->str) != 0 ){
        fileAttributesGet(dirzeiger, DirectoryOpened, &attribs, gstrPath->str, gstrNames->str);
        if (attribs.type_d==4 && strcmp(gstrNames->str, ".")!=0 && strcmp(gstrNames->str, "..")!=0){
            g_string_prepend(gstrNames, gstrPath->str);
            listDirs = g_list_append(listDirs, g_string_new(gstrNames->str));
        }
        if (attribs.gstrLinkTarget){
            g_string_free(attribs.gstrLinkTarget, TRUE);
        }
        getNextListItem(Directory, &dirzeiger, DirectoryOpened, gstrNames);
    }
    closeDirectory(&Directory);
    DirectoryOpened=0;
    if (listDirs){
        completion = g_completion_new ( (GCompletionFunc) completionReturnFunction);
        g_completion_add_items (completion, listDirs);
        g_completion_complete (completion, cpText, ToComplete);
        g_completion_clear_items (completion);
        g_completion_free(completion);

        g_list_foreach(listDirs, (GFunc) GListFreeGStrings, NULL);
        g_list_free(listDirs);

        //if (strcmp(cpText,*ToComplete) == 0){   //delete ToComplete, and fill it with NULL, because no match was found, or more than one
        //    g_free(*ToComplete);
        //    *ToComplete=NULL;
        //}
    }
    g_string_free(gstrNames,TRUE);

    if (*ToComplete){
        g_string_assign(gstrPath, *ToComplete);
        openDirectory(&Directory, &DirectoryOpened, gstrPath);
        if (DirectoryOpened == 1){//directory opened, valid
            closeDirectory(&Directory);
            g_string_free(gstrPath,TRUE);
            TRACEIT(10,"completePath		end");
            return 2;
        }
    }
    g_string_free(gstrPath,TRUE);
    TRACEIT(10,"completePath		end");
    return 1;


     //I thought I could use g_filename_completer_get_completion_suffix to complete the string in the Pathentrybox
    //but it did not work (I dont know why, did I something wrong in the code below?)
/*    if ( (event->keyval == GDK_Tab)){

        GFilenameCompleter *completer = g_filename_completer_new ();
        char *cText=NULL;
        g_object_get(PathEntryBox[leftORright],"text",&cText,NULL);
        if (completer == NULL){

        }
        g_filename_completer_set_dirs_only(completer, TRUE);
        gchar *cCompleted = g_filename_completer_get_completion_suffix (completer, cText);
        if (cText){


            g_free(cText);
        }
        if (cCompleted){


            g_free(cCompleted);
        }
        else{

        }
        g_object_unref (completer);
        return TRUE;
    }*/
}




gboolean scrollListStoreToName_Helper (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, struct AllInformationAllUseStruct *stru){
    TRACEIT(10,"scrollListStoreToName_Helper		start");
    int *Column = (int *)stru->Info_2;
    char *NameToFind = (char *)stru->Info_3;
    gchar *Name=NULL;
    GtkTreeSelection	*selection=NULL;

    gtk_tree_model_get(model, iter, *Column, &Name, -1);
    if (Name){
        if (strcmp(Name,NameToFind)==0){
            gtk_tree_view_scroll_to_cell ((GtkTreeView *)stru->Info_4,path,NULL,TRUE,0.0,0.0);
            selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW((GtkTreeView *)stru->Info_4));
            gtk_tree_selection_select_iter(selection, iter);
            g_free(Name);
            TRACEIT(10,"scrollListStoreToName_Helper		ends");
            return TRUE;
        }
    }
    if (Name)
        g_free(Name);
    TRACEIT(10,"scrollListStoreToName_Helper		ends");
    return FALSE;
}


int scrollListStoreToName(GtkTreeView *listView, GtkListStore *listStore, GString *NameToScroll, int ColumnToSearch){
    TRACEIT(10,"scrollListStoreToName		start");
    struct AllInformationAllUseStruct stru;
    int Column = ColumnToSearch;
    stru.Info_2=(void *)&Column;
    stru.Info_3=(void *)NameToScroll->str;
    stru.Info_4=(void *)listView;

    gtk_tree_model_foreach(GTK_TREE_MODEL(listStore),(GtkTreeModelForeachFunc) scrollListStoreToName_Helper,&stru);
    TRACEIT(10,"scrollListStoreToName		end");
    return 1;
}


void getHomeDirectory(GString **HomeDir){
	TRACEIT(10,"getHomeDirectory		start");
	//REMEMBER to free the memory allocated here!!!
	char *buf=NULL;
	if (*HomeDir == NULL){
		*HomeDir = g_string_sized_new(20);
	}
	buf = getenv("HOME");
	g_string_assign(*HomeDir, buf);
	TRACEIT(10,"getHomeDirectory		end");
}


void checkPathForLastChar(GString *Path){
	TRACEIT(10,"checkPathForLastChar		start");
	if (Path->str[strlen(Path->str)-1] != '/'){
		g_string_append_c(Path,'/');
	}
	TRACEIT(10,"checkPathForLastChar		ends");
}


void checkPathForLastCharOtherwise(GString *Path){
	TRACEIT(10,"checkPathForLastCharOtherwise		start");
	if (strlen(Path->str) >1){
		if (Path->str[strlen(Path->str)-1] == '/'){
			g_string_set_size(Path,strlen(Path->str)-1);
		}
	}
	TRACEIT(10,"checkPathForLastCharOtherwise		ends");
}


void cutSpacesFromGString(GString *ToCut){
	TRACEIT(10,"cutSpacesFromGString		start");
	cutCharFromGString(ToCut, ' ',0);
	TRACEIT(10,"cutSpacesFromGString		ends");
}

void cutLeadingSpacesFromGString(GString *ToCut){
    TRACEIT(10,"cutLeadingSpacesFromGString		start");
	cutCharFromGString(ToCut, ' ',1);
	TRACEIT(10,"cutLeadingSpacesFromGString		ends");
}

void cutTapsFromGString(GString *ToCut){
	TRACEIT(10,"cutTapsFromGString		start");
	cutCharFromGString(ToCut, '\t',0);
	TRACEIT(10,"cutTapsFromGString		ends");
}


void cutCharFromGString(GString *ToCut, char thechar, int OnlyLeadingOnes){
	TRACEIT(10,"cutCharFromGString		start");
	int i;
	for (i=0; i<strlen(ToCut->str); i++){
		if (ToCut->str[i] == thechar){
			g_string_erase(ToCut,i,1);
			i--;
		}
		else if (OnlyLeadingOnes == 1){
            return;
		}
	}
	TRACEIT(10,"cutCharFromGString		end");
}


void getLastStringInPath(GString *Path){ //removes the path and leaves the single name
	TRACEIT(10,"getLastStringInPath		start");

	GString *gstrbuf = g_string_new(Path->str);

	if (strcmp(Path->str,"/")==0){
		g_string_free(gstrbuf,TRUE);
		return;
	}
	checkPathForLastCharOtherwise(gstrbuf);
	char *buf = strrchr(Path->str,'/');

	if (buf == NULL){
		TRACEIT(9,"getLastStringInPath		ends NO");
		g_string_free(gstrbuf,TRUE);
		return;
	}

	buf++;
	if (buf == '\0'){
		TRACEIT(3,"getLastStringInPath		ends SHOULD NEVER BE");
		g_string_free(gstrbuf,TRUE);
		return;
	}

	g_string_assign(Path,buf);
	g_string_free(gstrbuf,TRUE);
	TRACEIT(10,"getLastStringInPath		ends");
}

int GetPathFromPathWithName(GString *PathAndName, int iDoIt){
    //if iDoIt == 1, then the last string will be cut off wether or not the string in PathAndName is allready a path (ending /)
    //it iDoIt == 0, then this fuctions does nothing when the last char in PathAndName is a /

    //return: -1: Error, 0: already path, 1: Path written to PathAndName
    //
	TRACEIT(10,"GetPathFromPathWithName		start");
	if (PathAndName == NULL){
		TRACEIT(10,"GetPathFromPathWithName		end 1");
		return -1;
	}
	GString *gstrBuf = g_string_new(PathAndName->str);

	if ( iDoIt == 0 && (gstrBuf->str)[strlen(gstrBuf->str)-1]=='/'){ //last char in PathAndName is a /, so it is all ready a path.
        g_string_free(gstrBuf, TRUE);
        return 0;
	}


	getLastStringInPath(gstrBuf);

	g_string_truncate(PathAndName, strlen(PathAndName->str)-strlen(gstrBuf->str)-1);

    if (strlen(PathAndName->str) == 0){ //we are in the root directory
        g_string_assign(PathAndName, "/");
    }
	g_string_free(gstrBuf, TRUE);
	TRACEIT(10,"GetPathFromPathWithName		end");
	return 1;
}


void cutStringToNChars(GString *Text,int Size){
	TRACEIT(10,"cutStringToNChars		start");
	if (strlen(Text->str)<=Size){
		TRACEIT(10,"cutStringToNChars		ends");
		return;
	}
	g_string_truncate(Text,Size);
	g_string_append(Text, "...");

	TRACEIT(10,"cutStringToNChars		ends");
}


void cleverCutStringToNChars(GString *ToCut, char *textToAddBetween, int Size){
    //textToAddBetween can be NULL
    //devides ToCut into three sections. section 1 and 3 are half the size of Size and are put together to the new string,
    //which ends up not larger than Size in the case textToAddBetween is empty or NULL.
    //Section 1 comes from the beginning of ToCut while section 3 comes from the end.
    //Section 2 are the chars between section 1 and 3, and are deleted or exchanged by textToAddBetween.

	TRACEIT(10,"cleverCutStringToNChars		start");
	if (ToCut==NULL){
	    TRACEIT(10,"cleverCutStringToNChars		ends, parameter NULL");
	    return;
	}
	if (strlen(ToCut->str)<=Size){
		TRACEIT(10,"cleverCutStringToNChars		ends, nothing to do");
		return;
	}
    int wholeSize = strlen(ToCut->str);
    int pos = Size/2;
    int lenToCut = wholeSize-Size;

    g_string_erase (ToCut, pos, lenToCut);
    if (textToAddBetween != NULL){
        g_string_insert (ToCut, pos+1, textToAddBetween);   //not sure about the +1 here.
    }

    TRACEIT(10,"cleverCutStringToNChars		end");
}


int myTokenFunction (GString *gstrCompleteString, int TokenNumber, char *divider, GString *gstrToken){
    TRACEIT(10,"myTokenFunction		start");
    if (strstr(gstrCompleteString->str, divider) == 0){
        g_string_assign(gstrToken, gstrCompleteString->str);
        TRACEIT(10,"myTokenFunction		ends, no divider in string");
        if (TokenNumber == 0){
            return 1;
        }
        else{
            return -1;
        }
    }
    int i;
    char *buf = malloc( sizeof(char *) * (strlen(gstrCompleteString->str)+2) );
    char *start=NULL;
    char *end=NULL;

    strcpy(buf,gstrCompleteString->str);

    start = buf;
    for( i=0; i<TokenNumber; i++){
        start = strstr(start, divider);
        if (start == NULL){
            free(buf);
            TRACEIT(10,"myTokenFunction		ends, no more tokens");
            return -1;
        }
        start += strlen(divider);
    }
    end = strstr(start,divider);
    if (end == NULL){
        end = &(buf[strlen(buf)]);
    }
    *end = '\0';
    g_string_assign(gstrToken, start);

    free(buf);
    TRACEIT(10,"myTokenFunction		ends");
    return 1;
}


int AddNewGStringToDPointer(GString ***gstrTPString,int OldCount, GString *NewOne){
	TRACEIT(10,"AddNewGStringToDPointer		start");
	//allocates new memory and copies all entries from gstrTPString and the NewOne to the new memory
	//and frees the old, THE GSTRING IN NEWONE IS COPIED !!!!!!!! THIS MEANS A NEW GSTRING IS CREATED!!
	int i;
	GString *NewString;
	GString **NewDPointer=NULL;
	NewDPointer	= malloc(sizeof(GString *) * (OldCount +1));
	if (NewDPointer == NULL){
		TRACEIT(1,"AddNewGStringToDPointer		end, NewPointer = NULL, ERROR allocting memory");
		return -1;
	}
	for (i=0;i<OldCount;i++){
		NewDPointer[i] = (*gstrTPString)[i];
	}
	if (NewOne == NULL){
		NewDPointer[OldCount] = NULL;
	}
	else{
		NewString = g_string_new(NewOne->str);
		NewDPointer[OldCount]=NewString;
	}
	if (*gstrTPString != NULL)
		free(*gstrTPString);

	*gstrTPString = NewDPointer;
	TRACEIT(10,"AddNewGStringToDPointer		end");
	return 0;
}


int AddNewGUInt64ToPointerArray(guint64 **intArray, int OldCount, guint64 NewOne){
	TRACEIT(10,"ToPointerArray		start");
	//allocates new memory and copies all entries from intArray and the NewOne to the new memory
	//and frees the old.
	int i;
	guint64 *NewPointer=NULL;
	NewPointer	= malloc(sizeof(guint64) * (OldCount +1));
	if (NewPointer == NULL){
		TRACEIT(1,"ToPointerArray		end, NewPointer, ERROR allocating memory");
		return -1;
	}
	for (i=0;i<OldCount;i++){
		NewPointer[i] = (*intArray)[i];
	}

	NewPointer[OldCount]=NewOne;

	if (*intArray != NULL)
		free(*intArray);

	*intArray = NewPointer;
	TRACEIT(10,"ToPointerArray		end");
	return 0;
}


gboolean KeepWindowOnTop (GtkWidget *widget, GdkEvent  *event, gpointer   user_data){
	TRACEIT(10,"KeepWindowOnTop		start");
	if (event->window_state.type == 32){		//GDK_WINDOW_STATE      = 32
		gtk_window_deiconify ((GtkWindow *)user_data);
	}
	TRACEIT(10,"KeepWindowOnTop		end");
	return TRUE;
}


gboolean DeleteNotification (GtkWidget *widget, GdkEvent  *event, gpointer   user_data){
    int *notification = (int *)user_data;
    *notification = 0;  //dialog destroyed, this, however has nothing to do whith mainloop, but just destroys the widget
    return FALSE;   //when this is TRUE, the widget will stay even when the user tries to close it. And because of our notification we d not close it either
}


GtkWidget *CreateMyWindow(char *title, GtkWindow *parent, int x, int y, gboolean bResizeable, gboolean bDestroyWithParent, gboolean bKeepOnTop, int *iDeleteNotification, gboolean bParentInteraction ){
    //iDeleteNotification becomes 1 when window is running and 0 when it receives the destroy-signal
	TRACEIT(10,"CreateMyWindow		start");
	GtkWidget *dialog;
	dialog = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	//gtk_window_set_destroy_with_parent(GTK_WINDOW(dialog),TRUE);
	gtk_window_set_deletable((GtkWindow *)dialog,FALSE);
	gtk_window_set_title((GtkWindow *)dialog,title);
	gtk_window_set_default_size((GtkWindow *)dialog,x,y);
	gtk_window_set_resizable((GtkWindow *)dialog,bResizeable);

	if (parent != NULL){
	    if (bParentInteraction){
            gtk_window_set_modal((GtkWindow *)dialog,TRUE); //modal dialogs can be connected to other widgets with ..set_transient_for
	    }                                                      //Modal windows prevent interaction with other windows in the same application
		gtk_window_set_transient_for((GtkWindow *)dialog,parent);   //connects, in a way, the window with a parent window

		if (bDestroyWithParent){
            gtk_window_set_destroy_with_parent((GtkWindow *)dialog, TRUE);
		}
	}

    if (bKeepOnTop)
        g_signal_connect (dialog,"window-state-event",G_CALLBACK(KeepWindowOnTop),(void *)dialog);
    if (iDeleteNotification){
        *iDeleteNotification = 1;  //dialog valid
        //g_signal_connect (dialog,"destroy-event",G_CALLBACK(DeleteNotification),(void *)iDeleteNotification); //destroy-eventg hooks to the gdkwindow, but this may be destroyed from the widget automaticaly and so, no windget owns this window. That means that we do not receive this signal
        g_signal_connect (dialog,"delete-event",G_CALLBACK(DeleteNotification),(void *)iDeleteNotification);    //his event hooks to the Widget
    }

	TRACEIT(10,"CreateMyWindow		end");
	return dialog;
}


GtkWidget *CreateMyDialog(char *title, GtkWindow *parent, int iButtons, char *respText1, int resp1, char *respText2, int resp2, gboolean bResizeable){
	TRACEIT(10,"CreateMyDialog		start");
	//has 2 buttons!!
	GtkWidget *dialog=NULL;
	if (iButtons == 1){
		dialog = gtk_dialog_new_with_buttons(title,parent,GTK_DIALOG_DESTROY_WITH_PARENT,respText1,resp1,NULL);
	}
	else{
		dialog = gtk_dialog_new_with_buttons(title,parent,GTK_DIALOG_DESTROY_WITH_PARENT,respText1,resp1,respText2,resp2,NULL);
	}


	//printf("creating dialog: %p, text1:%s--- text2:%s--- \n",dialog, respText1, respText2 );

	gtk_window_set_deletable((GtkWindow *)dialog,FALSE);
	gtk_window_set_resizable((GtkWindow *)dialog,bResizeable);

	g_signal_connect (dialog,"window-state-event",G_CALLBACK(KeepWindowOnTop),(void *)dialog);
	TRACEIT(10,"CreateMyDialog		end");
	return dialog;
}


void MyMessageWidget(GtkWindow *parrent, char *title, char* message){
	TRACEIT(10,"MyMessageWidget		start");
	GtkWidget *label;
	GtkWidget *dialog;
	GtkWidget *scrollwidget;

	dialog = CreateMyDialog(title,parrent,1,"Ok",GTK_RESPONSE_ACCEPT,"Stop execution",GTK_RESPONSE_REJECT,TRUE);
    label = gtk_label_new(message);

    gtk_label_set_selectable ( (GtkLabel *)label, TRUE);
    gtk_label_set_line_wrap ( (GtkLabel *)label, TRUE);

    //gtk_window_set_default_size ( (GtkWindow *)dialog, 300, 200);
    gtk_window_resize ( (GtkWindow *)dialog, 300, 200);
    //gtk_window_set_resizable((GtkWindow *)dialog,FALSE);


    if (strlen(message)>100){
        scrollwidget = gtk_scrolled_window_new(NULL,NULL);
        gtk_scrolled_window_add_with_viewport ( (GtkScrolledWindow *)scrollwidget, label);
        gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),scrollwidget);
    }
    else{
        gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label);
    }

	gtk_widget_show_all(dialog);
	gtk_dialog_run(GTK_DIALOG(dialog));
	gtk_widget_destroy(dialog);
	TRACEIT(10,"MyMessageWidget		end");
}


int MyEasyInputWidget (GtkWindow *parrent, char *title, char *text, GString *gstrUserText){
    // opens a little dialog in which the user can give us a little text, think of the rename - dialog.
    // wahtever stays in gstrUserText is displayed in the input area as a predefined text.
    // return values: 0: User OK     1: User Cancel   <0: Error
    TRACEIT(10,"MyEasyInputWidget		start");
    if (NULL == title || NULL==text || NULL==gstrUserText){
            TRACEIT(3,"MyEasyInputWidget		end, one or more parameters NULL");
            return -1;
    }
	GtkWidget *dialog, *label;
	GtkWidget *EntryBox;
	GString *gstrbuf = g_string_sized_new(10);

    dialog = CreateMyDialog(title, parrent, 2, "Ok",GTK_RESPONSE_ACCEPT,"Cancel",GTK_RESPONSE_REJECT, FALSE);

	label = gtk_label_new(text);
	gtk_misc_set_alignment ( (GtkMisc *)label, 0.0f, 0.0f);
    gtk_misc_set_padding ( (GtkMisc *)label, 4, 0);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label);
	EntryBox = gtk_entry_new();
	gtk_entry_set_max_length(GTK_ENTRY(EntryBox),MAXENTRYBOX);
	gtk_editable_set_editable(GTK_EDITABLE(EntryBox),TRUE);
	g_signal_connect (EntryBox, "activate",G_CALLBACK(MyEasyInputWidget_EntryBoxActivate),dialog);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),EntryBox);
	g_object_set(EntryBox, "text", gstrUserText->str, NULL);

	gtk_widget_show_all(dialog);

	if (gtk_dialog_run(GTK_DIALOG(dialog))== GTK_RESPONSE_ACCEPT){
		g_object_get(EntryBox, "text", gstrbuf, NULL);
		g_string_assign(gstrUserText,gstrbuf->str);

        gtk_widget_destroy(dialog);
        TRACEIT(10,"MyEasyInputWidget		end 0");
        g_string_free(gstrbuf, TRUE);
        return 0;
	}
	gtk_widget_destroy(dialog);
	TRACEIT(10,"MyEasyInputWidget		end 1");
	g_string_free(gstrbuf, TRUE);
    return 1;
}


int MyEasyInputWidget_Two (GtkWindow *parrent, char *title, char *text1, GString *gstrUserText1, char *text2, GString *gstrUserText2, char *button0, char *button1, char *button2, char *button3 ){
    // opens a little dialog in which the user can give us a little text, think of the rename - dialog.
	// but this widget has up to two entry boxes where to enter text.
	// and up to 4 buttons
	// text1 must not be NULL
	// while gstrUserText1, text2 and gstrUserText2 may be NULL, then, there is only one entrybox or none
	// text2 and gstrUserText2 may only be NULL at the same time
    // wahtever stays in gstrUserText is displayed in the input area as a predefined text.

    // when the ENTER is hit in one of the entryboxes 0 (means the first button) is returned.

    //The Gstrings are updated only when first button is pressed
    // return values: 0: User OK     1: User Cancel   2: User Cancel All 	<0: Error
    TRACEIT(10,"MyEasyInputWidget_Two		start");
    if (NULL == title || NULL==text1 /*|| NULL==gstrUserText1*/ ){
            TRACEIT(3,"MyEasyInputWidget_Two		end, one or more parameters NULL");
            return -1;
    }
    if (NULL == button0 || NULL==button1 /*|| NULL==gstrUserText1*/ ){
            TRACEIT(3,"MyEasyInputWidget_Two		end, at lease the first two buttons have to be defined");
            return -1;
    }


	GtkWidget *dialog, *label1, *label2;

	GtkWidget *EntryBox1=NULL, *EntryBox2=NULL;
	GString *gstrbuf1 = g_string_sized_new(10);
	GString *gstrbuf2 = g_string_sized_new(10);
	int iText2Valid=0;
	int iText1Valid=0;

    //dialog = CreateMyDialog(title, parrent, 2, "ok",GTK_RESPONSE_ACCEPT,"cancel",GTK_RESPONSE_REJECT, FALSE);
    if (button0 && button1 && button2 && button3){
        dialog = gtk_dialog_new_with_buttons(title,parrent,GTK_DIALOG_DESTROY_WITH_PARENT, button0, 0, button1, 1, button2, 2, button3, 3, NULL);
    }
    else if (button0 && button1 && button2 && button3==NULL){
        dialog = gtk_dialog_new_with_buttons(title,parrent,GTK_DIALOG_DESTROY_WITH_PARENT, button0, 0, button1, 1, button2, 2, NULL);
    }
    else if(button0 && button1 && button2==NULL && button3==NULL){
        dialog = gtk_dialog_new_with_buttons(title,parrent,GTK_DIALOG_DESTROY_WITH_PARENT, button0, 0, button1, 1, NULL);
    }
    else{
        dialog = gtk_dialog_new_with_buttons(title,parrent,GTK_DIALOG_DESTROY_WITH_PARENT,"Ok",GTK_RESPONSE_ACCEPT,"Cancel all",2,"Cancel",1,NULL);
    }
	gtk_window_set_deletable((GtkWindow *)dialog,FALSE);
	gtk_window_set_resizable((GtkWindow *)dialog,TRUE);
	g_signal_connect (dialog,"window-state-event",G_CALLBACK(KeepWindowOnTop),(void *)dialog);


	label1 = gtk_label_new(text1);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label1);
	gtk_misc_set_alignment ( (GtkMisc *)label1, 0.0f, 0.0f);
    gtk_misc_set_padding ( (GtkMisc *)label1, 4, 0);
	if (gstrUserText1!=NULL){
        EntryBox1 = gtk_entry_new();
        gtk_entry_set_max_length(GTK_ENTRY(EntryBox1),MAXENTRYBOX);
        gtk_editable_set_editable(GTK_EDITABLE(EntryBox1),TRUE);
        g_signal_connect (EntryBox1, "activate",G_CALLBACK(MyEasyInputWidget_EntryBoxActivate),dialog);
        gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),EntryBox1);
        g_object_set(EntryBox1, "text", gstrUserText1->str, NULL);
        iText1Valid=1;
	}

	if (text2 != NULL && gstrUserText2 != NULL){
		label2 = gtk_label_new(text2);
		gtk_misc_set_alignment ( (GtkMisc *)label2, 0.0f, 0.0f);
        gtk_misc_set_padding ( (GtkMisc *)label2, 4, 0);
		gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label2);
		EntryBox2 = gtk_entry_new();
		gtk_entry_set_max_length(GTK_ENTRY(EntryBox2),MAXENTRYBOX);
		gtk_editable_set_editable(GTK_EDITABLE(EntryBox2),TRUE);
		g_signal_connect (EntryBox2, "activate",G_CALLBACK(MyEasyInputWidget_EntryBoxActivate),dialog);
		gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),EntryBox2);
		g_object_set(EntryBox2, "text", gstrUserText2->str, NULL);
		iText2Valid=1;
	}

	gtk_widget_show_all(dialog);
    int ret=gtk_dialog_run(GTK_DIALOG(dialog));
	if (ret == 0 || ret == GTK_RESPONSE_ACCEPT){    //hitting enter in one of the entryboxes returns GTK_RESPONSE_ACCEPT
	    if (iText1Valid==1){
            g_object_get(EntryBox1, "text", gstrbuf1, NULL);
            g_string_assign(gstrUserText1,gstrbuf1->str);
	    }
		if (iText2Valid==1){
		    g_object_get(EntryBox2, "text", gstrbuf2, NULL);
			g_string_assign(gstrUserText2,gstrbuf2->str);
		}

        gtk_widget_destroy(dialog);
        TRACEIT(10,"MyEasyInputWidget_Two		end 0");
        g_string_free(gstrbuf2, TRUE);
        g_string_free(gstrbuf1, TRUE);
        return 0;   //Do not return GTK_RESPONSE_ACCEPT, but 0, this means the first button
	}/*
	else if(ret==2){
        g_string_free(gstrbuf2, TRUE);
        g_string_free(gstrbuf1, TRUE);
        gtk_widget_destroy(dialog);
        return ret;
	}*/

	gtk_widget_destroy(dialog);
	TRACEIT(10,"MyEasyInputWidget_Two		end 1");
	g_string_free(gstrbuf2, TRUE);
    g_string_free(gstrbuf1, TRUE);
    return ret;
}


void AddMyIconsToWindow(GtkWindow *Window){
	TRACEIT(10,"AddMyIconsToWindow		start");
    GString *gstrbuf = g_string_sized_new(20);
    GString *gstrbuf2 = g_string_sized_new(20);
	char *cppSizes[] = {"16x16","48x48","64x64"}; //,"128x128","160x160"};	//Do not forgett to de- or increment for-loop when changing Items in this pointerarray
	int i=0;								//On IceWM: when we add more than 64x64 (or 3 Items) there was no Icon at all

    getHomeDirectory(&gstrbuf);
    checkPathForLastChar(gstrbuf);
    g_string_append(gstrbuf,ICONNAMEWITHOUTSIZE);

	GError *err=NULL;
	GList *pMyIconList=NULL;
	GdkPixbuf *pixMainWindowIcon=NULL;

	for (i=0; i<3; i++){
	    g_string_assign(gstrbuf2, gstrbuf->str);
		g_string_append(gstrbuf2, cppSizes[i]);
		g_string_append(gstrbuf2, ".gif");

		pixMainWindowIcon = gdk_pixbuf_new_from_file (gstrbuf2->str, &err);

		if (err){
			TRACEIT(6,"AddMyIconsToWindow		error Loading Icon from file:");
			TRACEIT(6,gstrbuf2->str);
			g_error_free(err);
			err=NULL;
		}
		if (pixMainWindowIcon != NULL){
			pMyIconList = g_list_append(pMyIconList, (void *)pixMainWindowIcon);
		}
	}
	gtk_window_set_icon_list (Window, pMyIconList);
	g_list_free(pMyIconList);
	g_string_free(gstrbuf,TRUE);
	g_string_free(gstrbuf2,TRUE);

	TRACEIT(10,"AddMyIconsToWindow		end");
}

void MyEasyInputWidget_EntryBoxActivate(GtkEntry *entry, gpointer data){
	TRACEIT(10,"MyEasyInputWidget_EntryBoxActivate		start");

	gtk_dialog_response (GTK_DIALOG(data), GTK_RESPONSE_ACCEPT);

	//This is just when the user hits the enterbutton, then the OKButton is activated
	//!!!!!!!!  Be carefull, this function is called from many functions not only the NewDirectory-thing   !!!!!
	TRACEIT(10,"MyEasyInputWidget_EntryBoxActivate		ends");
}


gboolean myWrapOf__g_spawn_command_line_sync (const gchar *command_line, gchar **standard_output, gchar **standard_error, gint *exit_status, GError **error){
    TRACEIT(10,"myWrapOf__g_spawn_command_line_sync		start");
    gboolean ret;
    time_t currentTime=0;
    GString *gstrBuf=g_string_sized_new(30);
    unsigned int ID;

    ID = time(&currentTime);

    g_string_printf(gstrBuf, "%d: %s: %s",ID, ctime(&currentTime), command_line);
    cutCharFromGString(gstrBuf, '\n',0);
    //g_string_append(gstrBuf, "\n\n");
    gdk_threads_enter();
    textbuffer_commandHistory_addText(gstrBuf->str, NULL);
    gdk_threads_leave();

    //char cbuf[100];
    //getcwd(cbuf,99);
    //printf("current path: %s, command: %s\n",cbuf, command_line);
    ret = g_spawn_command_line_sync(command_line,standard_output,standard_error,exit_status,error);

    if (standard_error != NULL && *standard_error != NULL && strlen(*standard_error) > 1 && (( exit_status != NULL && *exit_status != 0) || exit_status==NULL) ){
        g_string_printf(gstrBuf, "%d: %s: ERROR: %s",ID, ctime(&currentTime), *standard_error);
        cutCharFromGString(gstrBuf, '\n',0);
        //g_string_append(gstrBuf, "\n\n\n");
        gdk_threads_enter();
        textbuffer_commandHistory_addText(gstrBuf->str, "error");
        gdk_threads_leave();
     }
    g_string_free(gstrBuf, TRUE);
    TRACEIT(10,"myWrapOf__g_spawn_command_line_sync		end");
    return ret;
}


void textbuffer_commandHistory_addText (char *text, char *tag){
    TRACEIT(10,"textbuffer_commandHistory_addText		start");
    //return ;
    //adds text to the end of our g_TextBuffer_CommandHistory,
    //tag may be NULL, otherwise the text is added to the buffer with the tag-properties (the tag must be a valid name of an allready connected tag)
    //a valid tag e.g. is "error"

    //when no tag is defined \n\n will be appended to text
    //wehn tag is defined \n\n\n will be appended to text
    if (text == NULL){
        TRACEIT(2,"textbuffer_commandHistory_addText		end, Parameter NULL");
        return;
    }
    if (g_TextBuffer_CommandHistory == NULL){
        TRACEIT(2,"textbuffer_commandHistory_addText		end, buffer null");
        return;
    }
    GtkTextIter iter;
    GString *gstrText = g_string_new(text);
    gtk_text_buffer_get_end_iter (g_TextBuffer_CommandHistory, &iter);

    if (tag == NULL){
        g_string_append(gstrText, "\n\n");
        gtk_text_buffer_insert (g_TextBuffer_CommandHistory, &iter, gstrText->str, -1);
    }
    else{
        g_string_append(gstrText, "\n\n\n");
        //the error text will displayed in red, as defined within the tag (here refered by "error" (tagname)), defined in defineGlobals - function
        gtk_text_buffer_insert_with_tags_by_name (g_TextBuffer_CommandHistory, &iter, gstrText->str, -1, tag, NULL);
    }
    g_string_free(gstrText, TRUE);
    //gtk_text_iter_free (&iter);   //do not free it, iter is on the stack! (its here just for info)
    TRACEIT(10,"textbuffer_commandHistory_addText		end");
}
/*

int VersionCheck_Gtk(){
    //int lkd_mj = gtk_major_version;
    int lkd_min = gtk_minor_version;
    int lkd_mic = gtk_micro_version;
    GTK_MAJOR_VERSION,GTK_MINOR_VERSION,GTK_MICRO_VERSION

    if (lkd_min < 10){
        return -100;    //Cat'sEyE needs at least version 2.10 //the installed version is too little
    }

    if (lkd_min < GTK_MINOR_VERSION){
        return -10;     //compiled versions are highter than linked (minor)
    }
    else if (kd_min = GTK_MINOR_VERSION){
        if (lkd_mic < GTK_MICRO_VERSION){
            return -1;  //compiled versions are highter than linked (micro)
        }
        else if (kd_mic = GTK_MICRO_VERSION){
            return 0;   //compiled and linked versions are equal
        }
        else if (kd_mic > GTK_MICRO_VERSION){
            return 1;   //linked version is newer than compiled version (micro)
        }
    }
    else if (kd_min > GTK_MINOR_VERSION){
        return 10;  //linked version is newer than compiled version (minor)
    }
}
*/

