/*
    Copyright 2007, 2008, 2009 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef HELPERS_H_
#define HELPERS_H_

char *mine_strnstr(char *big, char *little, int size);
void textbuffer_commandHistory_addText (char *text, char *tag);
void *GListFreeGStrings (gpointer data, gpointer user_data);
void getHomeDirectory(GString **HomeDir);
int myTokenFunction (GString *gstrCompleteString, int TokenNumber, char *devider, GString *gstrToken);
void cutSpacesFromGString(GString *ToCut);
void cutLeadingSpacesFromGString(GString *ToCut);
void checkPathForLastChar(GString *Path);
void checkPathForLastCharOtherwise(GString *Path);
void cutTapsFromGString(GString *ToCut);
void cutCharFromGString(GString *ToCut, char thechar, int OnlyLeadingOnes);
void getLastStringInPath(GString *Path);
int GetPathFromPathWithName(GString *PathAndName, int iDoIt);
void cutStringToNChars(GString *Text,int Size);
void cleverCutStringToNChars(GString *ToCut, char *textToAddBetween, int Size);
int completePath(char *cpText, char **ToComplete);
int AddNewGStringToDPointer(GString ***gstrTPString,int OldCount, GString *NewOne);
int AddNewGUInt64ToPointerArray(guint64 **intArray, int OldCount, guint64 NewOne);
gboolean checkStringIsPath(char *cpPath);

void AddMyIconsToWindow(GtkWindow *Window);
GtkWidget *CreateMyWindow(char *title, GtkWindow *parent, int x, int y, gboolean bResizeable, gboolean bDestroyWithParent, gboolean bKeepOnTop, int *iDeleteNotification, gboolean bParentInteraction);
GtkWidget *CreateMyDialog(char *title, GtkWindow *parent, int iButtons, char *respText1, int resp1, char *respText2, int resp2, gboolean bResizeable);
void MyMessageWidget(GtkWindow *parrent, char *title, char* message);
int MyEasyInputWidget (GtkWindow *parrent, char *title, char *text, GString *gstrUserText);
int MyEasyInputWidget_Two (GtkWindow *parrent, char *title, char *text1, GString *gstrUserText1, char *text2, GString *gstrUserText2, char *button0, char *button1, char *button2, char *button3);
void MyEasyInputWidget_EntryBoxActivate(GtkEntry *entry, gpointer data);

int scrollListStoreToName(GtkTreeView *listView, GtkListStore *listStore, GString *NameToScroll, int ColumnToSearch);

gboolean myWrapOf__g_spawn_command_line_sync (const gchar *command_line, gchar **standard_output, gchar **standard_error, gint *exit_status, GError **error);

void CursorToWait(GtkWidget *widget);
void CursorToNormal(GtkWidget *widget);

struct AllInformationAllUseStruct{	//a structure which holds plenty of information for much functions
	//created when working on fileshelf to make use of functions which are ment for the normal Objects
	//and, with the help of this structure, can now be used for the fileshelf too.
	//But this structure can be used everywhere where more information has to be exchanged with only one pointer

	int source;	//filled with one item of the enum above. E.g. SOURCE_FILESHELFT
	void *Info_1;	// this becomes: struct CallUserDataStruct *TheStruct = info->Info_1;
	void *Info_2;	// holds info->Info_2=(void *)ItemList;  (FileList)
	void *Info_3;	// used for fileshelf in special, holds listView from fileshelf
	void *Info_4;	// used for fileshelf, holds the path from the first marked item
    void *Info_5;
    void *Info_6;
};

#endif //HELPERS_H_

