/*
    Copyright 2007, 2008, 2009 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/



#include <glib.h>   //g_thread_init
#include <glib/gstdio.h> //g_rename
#include <gtk/gtk.h>
#include <gio/gio.h> //gfile, monitor, ...
#include <gdk/gdkkeysyms.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>	//Verzeichnis Zeiger und DIR - Struktur
#include <unistd.h> 	//e.g. chdir, usleep
//#include <errno.h>

#include "globalDefinitions.h"
#include "listitems.h"
#include "helpers.h"
#include "confighandling.h"
#include "Lists.h"
#include "threads.h"
#include "myfm.h"
#include "fileshelf.h"
#include "mytrace.h"
#include "internals.h"
#include "userdata.h"
#include "CommandParser.h"
#include "DragnDrop.h"
#include "automaticUpdate.h"
#include "SearchFor.h"


static gint delete_Event(GtkWidget *widget, GdkEvent event, gpointer daten);
static void end (GtkWidget *widget, GdkEvent event, gpointer daten);
int predefine_Main_Objects();
int makeLists(struct SideObjectList *Object, struct updateList **itemlist);
void connectListToView(struct SideObjectList *Object);
void bringAllToTheRightOrder();
void onePathChanged(GtkEntry *entry, gpointer g);
gboolean oneKeyPressed_PathEntry(GtkWidget *widget, GdkEventKey *event, gpointer data);
int checkDirectory(struct SideObjectList *Object, GString *NewPath);
void oneColumnWasClicked(GtkTreeViewColumn *Column, gpointer data);
void formatPathString(GString *NewPath);
void oneOnePathUpButtonClicked(GtkButton *button, gpointer data);
void oneSelectionChanged(GtkTreeSelection *treeselection, gpointer data);
gboolean oneKeyPressedInView(GtkWidget *widget, GdkEventKey *event, gpointer data);
static void deleteSelectedRowsHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data);
static void sizeOfSelected_Helper (GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data);
gboolean oneMouseButtonPressed(GtkWidget *treeview, GdkEventButton *event, gpointer data);
gboolean oneContextMenuReplied(GtkWidget *treeview, gpointer data);
gboolean oneNoteBookContextMenuReplied(GtkWidget *treeview, gpointer data);
void openContextMenu(GtkWidget *treeview, GdkEventButton *event, gpointer data);
void mayDeleteSelectedRows(GtkWidget *menuitem, gpointer data);
void editItems(GtkWidget *menuitem, gpointer data);
gboolean onePageSwitched(GtkNotebook *notebook, GtkNotebookPage *page, guint page_num, gpointer user_data);
void openTabContextMenu(GtkWidget *notebook, GdkEventButton *event, gpointer data);
void onePageAddedToNotebook(GtkNotebook *notebook, GtkWidget *child, guint page_num, gpointer data);
struct SideObjectList *getOtherSideObject(struct SideObjectList *ThisSideObject);
void updatePathEntryBox(GtkNotebook *notebook, guint num);
void loadThings();
void loadStartPathes();
void savePathes();
void saveThings();
void getStandardStartDirectory(GString *gstrCommand, GString *gstrCommandName);
void addNewPage(GtkWidget *menuitem, gpointer data);
void closeActivePage(GtkWidget *menuitem, gpointer data);
void dublicateActivePage(GtkWidget *menuitem, gpointer data);
void moveActivePage(GtkWidget *menuitem, gpointer data);
void copyActivePage(GtkWidget *menuitem, gpointer data);
void AlwaysShowHiddenfilesInAllTabs();
void showHiddenFilesInActivePage(GtkWidget *menuitem, gpointer data);
void addNewPageFromBookmarks(GtkWidget *menuitem, gpointer data);
void goToFromBookmarks(GtkWidget *menuitem, gpointer data);
int AddPathesToNotebook( GtkNotebook *Notebook, GString *gstrPathes, int AllreadyStarted);
static void getSizeOfSelectedItemsRecursive_getItems (GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data);

void CopyPasteCreateList_SideObject(struct SideObjectList *Object, int CopyOrMove);
void CopyPasteProcessList_SideObject(struct SideObjectList *Object);
void defineGlobals();
void clearUpGobals();
void loadGlobals();
int mysortfunctionforNamesLeft(GtkTreeModel *model, GtkTreeIter *a, GtkTreeIter *b, gpointer userdata);
void ShowSplashScreen();
void DestroySplashScreen();
void MenuAddToNewFileshelf(GtkWidget *menuitem, gpointer data);
void searchStringInAndHighlightItems_WraperforSideObject(GtkWidget *menuitem, gpointer data);
void copyToOtherPannel(GtkWidget *menuitem, gpointer data);
void moveToOtherPannel(GtkWidget *menuitem, gpointer data);
void renameItems(GtkWidget *menuitem, gpointer data);
void startItemsWithUserCommand_WraperforSideObject(GtkWidget *menuitem, gpointer data);
void oneRowActivated_SideObjectWrap(GtkTreeView *treeview, GtkTreePath *TreePath, GtkTreeViewColumn *col, gpointer data);
void internalSavePatheAsBookmark_wrap(GtkWidget *menuitem, gpointer data);
void mayNewDirectory(GtkWidget *menuitem, gpointer data);

char *Names[] = {   "filename",
                    "size",
                    "owner",
                    "group",
                    "perm.",
                    "accessed",
                    "changed",
                    "target",
                    "type",
                    "TimeStamp_1",
                    "TimeStamp_2",
                    "type_d",
                    "Color"
                    };
#define COLTYPES    G_TYPE_STRING, G_TYPE_UINT64, G_TYPE_INT, G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_STRING

GtkWindow 		*win;
GtkWindow 		*Splashwin;
GtkWidget 		*HPanedLeftRight;
GtkWidget		*VPanedForFileShelf;
GtkWidget 		*Notebooks[SIDE_BOTH];
GtkWidget       *PathEntryBox[SIDE_BOTH];
GtkVBox         *VBox[SIDE_BOTH];
GtkHBox         *HBoxForButtonsAndPathEntry[SIDE_BOTH];
GtkButton       *OnePathUpButton[SIDE_BOTH];

struct UserDataList TheStandardEditorStruct;
struct UserDataList TheTerminalStruct;

struct CopyReMoveList *g_CopyPasteShortcutStruct;

extern int          g_iFileshelfIsInitialized;
extern GtkNotebook  *g_FileShelfNotebook;
extern struct FileShelfObjectList *FirstFileShelfObject;
extern struct autoUpdateList *g_listAutoUpdateList;

int gint_Starting; //is 1 while startprocess. when program is in mainloop, its 0

GString *g_gstrColorItems;
GString *g_gstrColorDirs;
GString *g_gstrColorLinks;
GString *g_gstrColorNotFound;

GString *g_gstrCommandCopy;
GString *g_gstrCommandMove;
GString *g_gstrCommandRename;
GString *g_gstrCommandRemove;
GString *g_gstrCommandMakedir;

int g_int_AlwaysShowHidden;

GtkTextBuffer *g_TextBuffer_CommandHistory;


int main(int argc, char *argv[]){
	TRACEIT(10,"main		start");
    gint_Starting = 1;
/*	if (argc >= 2){
  		printf("\nThis is %s,\na filebrowser using the GTK.\n\nVersion: %s , %d\tbuild: %s,%s\n\n",MYNAME,VERSION,INTERNALBUILDNUMBER, __DATE__,__TIME__);
		printf("I hope you enjoy to use this program.\n\n");

		#ifdef ITTRACE
		printf("Tracelevel is set to %d, to change this rebuild with '-D ITTRACE=<Num>' where <Num> is the tracelevel you want\n",ITTRACE);
		#endif
		TRACEIT(10,"main		ends");
		return 0;
    }
*/
	g_thread_init(NULL);
	gdk_threads_init();
//	gdk_threads_enter();

	//Create MainWindow
	gtk_init(&argc, &argv);

	//ShowSplashScreen();

	win = g_object_new(GTK_TYPE_WINDOW,
		"title",MYNAME,
		"default-width", 800,
		"default-height", 640,
		"resizable",TRUE,
		"border-width",5,
		NULL);
	gtk_window_maximize(win);

	// Add Icon to Window
	AddMyIconsToWindow(win);

	//Set some global variables
	defineGlobals();

	//Predefine Objects
	predefine_Main_Objects();

	//some Signals
	g_signal_connect (win, "delete-event",G_CALLBACK(delete_Event),NULL);
	g_signal_connect (win, "destroy", G_CALLBACK(end),NULL);

	g_signal_connect (PathEntryBox[SIDE_LEFT], "activate",G_CALLBACK(onePathChanged),GINT_TO_POINTER(SIDE_LEFT));
	g_signal_connect (PathEntryBox[SIDE_RIGHT], "activate",G_CALLBACK(onePathChanged),GINT_TO_POINTER(SIDE_RIGHT));
	g_signal_connect (PathEntryBox[SIDE_LEFT], "key-press-event",G_CALLBACK(oneKeyPressed_PathEntry),GINT_TO_POINTER(SIDE_LEFT));
	g_signal_connect (PathEntryBox[SIDE_RIGHT], "key-press-event",G_CALLBACK(oneKeyPressed_PathEntry),GINT_TO_POINTER(SIDE_RIGHT));

	g_signal_connect (OnePathUpButton[SIDE_LEFT],"clicked",G_CALLBACK(oneOnePathUpButtonClicked),GINT_TO_POINTER(SIDE_LEFT));
	g_signal_connect (OnePathUpButton[SIDE_RIGHT],"clicked",G_CALLBACK(oneOnePathUpButtonClicked),GINT_TO_POINTER(SIDE_RIGHT));

	g_signal_connect (Notebooks[SIDE_LEFT],"page-added",G_CALLBACK(onePageAddedToNotebook),GINT_TO_POINTER(SIDE_LEFT));
	g_signal_connect (Notebooks[SIDE_RIGHT],"page-added",G_CALLBACK(onePageAddedToNotebook),GINT_TO_POINTER(SIDE_RIGHT));
	g_signal_connect (Notebooks[SIDE_LEFT],"button-press-event",G_CALLBACK(oneMouseButtonPressedOnNotebook),GINT_TO_POINTER(SIDE_LEFT));
	g_signal_connect (Notebooks[SIDE_RIGHT],"button-press-event",G_CALLBACK(oneMouseButtonPressedOnNotebook),GINT_TO_POINTER(SIDE_RIGHT));
	g_signal_connect (Notebooks[SIDE_LEFT],"popup-menu",G_CALLBACK(oneNoteBookContextMenuReplied),GINT_TO_POINTER(SIDE_LEFT));
	g_signal_connect (Notebooks[SIDE_RIGHT],"popup-menu",G_CALLBACK(oneNoteBookContextMenuReplied),GINT_TO_POINTER(SIDE_RIGHT));
	g_signal_connect (Notebooks[SIDE_LEFT],"key-press-event",G_CALLBACK(oneKeyPressedOnNotebook),GINT_TO_POINTER(SIDE_LEFT));
	g_signal_connect (Notebooks[SIDE_RIGHT],"key-press-event",G_CALLBACK(oneKeyPressedOnNotebook),GINT_TO_POINTER(SIDE_RIGHT));
	g_signal_connect (Notebooks[SIDE_LEFT],"switch-page",G_CALLBACK(onePageSwitched),GINT_TO_POINTER(SIDE_LEFT));
	g_signal_connect (Notebooks[SIDE_RIGHT],"switch-page",G_CALLBACK(onePageSwitched),GINT_TO_POINTER(SIDE_RIGHT));

	//We want to see the things we created
	bringAllToTheRightOrder();

	//SetStartPathes
	loadThings();

	//gtk_window_set_opacity (win, 0.9);
    //DestroySplashScreen();

	gtk_widget_show_all (GTK_WIDGET (win));

    //MainLOOP
	TRACEIT(10,"main-mainloop		start");
	gint_Starting=0;
	gdk_threads_enter();
	gtk_main();
	//printf("after big MAIN\n");
	gdk_threads_leave();

	//Let us forget this things!
	clearUpGobals();

	TRACEIT(10,"main		ends");
    return 0;
}


static gint delete_Event (GtkWidget *widget, GdkEvent event, gpointer daten){
	//g_printf("delete_Event\n");
	saveThings();
	return FALSE;
}


static void end (GtkWidget *widget, GdkEvent event, gpointer daten){
//	g_printf("end\n");

    gtk_main_quit();

}


void ShowSplashScreen(){
    //funktioniert nicht, weiss aber nicht warum!
    GString *home = NULL;
    struct myFiles_struct *filestru;

    getHomeDirectory(&home);
    checkPathForLastChar(home);
    g_string_append(home, SPASHIMAGENAME);
    filestru = myFiles_openFile(home->str, "r");
    printf("filename: %s\n",home->str);
    if (filestru){
        //gtk_window_set_auto_startup_notification(FALSE);

        myFiles_closeFile(filestru);
        GtkWidget *image = gtk_image_new_from_file (home->str);
        Splashwin = g_object_new(GTK_TYPE_WINDOW,
        /*"allow-grow",FALSE,*/
        /*"allow-shrink",FALSE,*/
        /*"decorated",FALSE,*/
        /*"default-width", 800,*/
		/*"default-height", 640,*/
		"deletable", FALSE,
		/*"opacity",0.4,*/
		"resizable",FALSE,
		/*"skip-pager-hint",TRUE,*/
		/*"skip-taskbar-hint",TRUE,*/
		/*"title",MYNAME,*/
		/*"border-width",5,*/
		"type_hint",GDK_WINDOW_TYPE_HINT_SPLASHSCREEN,
		NULL);
		//gtk_window_set_type_hint(Splashwin,GDK_WINDOW_TYPE_HINT_SPLASHSCREEN);
        printf("File found\n");
        gtk_container_add (GTK_CONTAINER(Splashwin),image);

		gtk_widget_show_all (GTK_WIDGET (Splashwin));

    }
    if (home)
        g_string_free(home, TRUE);
}

void DestroySplashScreen(){
    gtk_widget_destroy(GTK_WIDGET(Splashwin));
    //gtk_window_set_auto_startup_notification(TRUE);
}


void defineGlobals(){
	TheStandardEditorStruct.UserCommand=NULL;
	TheStandardEditorStruct.UserCommandName=NULL;
	TheTerminalStruct.UserCommand=NULL;
	TheTerminalStruct.UserCommandName=NULL;

	g_CopyPasteShortcutStruct = NULL;

	g_gstrColorItems=NULL;
    g_gstrColorDirs=NULL;
    g_gstrColorLinks=NULL;
    g_gstrColorNotFound=NULL;

	g_gstrCommandCopy=NULL;
	g_gstrCommandMove=NULL;
	g_gstrCommandRename=NULL;
	g_gstrCommandRemove=NULL;
	g_gstrCommandMakedir=NULL;

	g_int_AlwaysShowHidden=0;

	UserCommand_InitUserCommandStructOnStartup();

	g_iFileshelfIsInitialized = 0;
	g_FileShelfNotebook = NULL;
	FirstFileShelfObject = NULL;

    //create a TextBuffer which holds the commands send to the shell by catseye
    //and add an tag, wich will be refered to when an error occured while processing a command
    //the text in the error string will be displayed in the color specified here ( "myWrapOf__g_spawn_command_line_sync" )
    g_TextBuffer_CommandHistory = gtk_text_buffer_new(NULL);
    gtk_text_buffer_create_tag (g_TextBuffer_CommandHistory, "error", "foreground", "red", NULL);


    g_listAutoUpdateList=NULL;

}


void clearUpGobals(){
    TRACEIT(10,"clearUpGobals		start");

    SideObjectList_ClearAllForShutdown();

	//Free some of the sturctures, The other structures from the UserCommands are already free from the lines above
	freeTypesAndUserProgrammArrays();

	if (TheStandardEditorStruct.UserCommand != NULL)
		g_string_free(TheStandardEditorStruct.UserCommand,TRUE);
	if (TheStandardEditorStruct.UserCommandName != NULL)
		g_string_free(TheStandardEditorStruct.UserCommandName,TRUE);

	if (TheTerminalStruct.UserCommand != NULL)
		g_string_free(TheTerminalStruct.UserCommand,TRUE);
	if (TheTerminalStruct.UserCommandName != NULL)
		g_string_free(TheTerminalStruct.UserCommandName,TRUE);

    if (g_CopyPasteShortcutStruct != NULL){
        CopyReMoveList_DeleteList(g_CopyPasteShortcutStruct);
        g_CopyPasteShortcutStruct = NULL;
    }

	bookmarklist_DeleteBookmarks();

	if (g_gstrColorItems)
        g_string_free(g_gstrColorItems, TRUE);
    if (g_gstrColorDirs)
        g_string_free(g_gstrColorDirs, TRUE);
    if (g_gstrColorLinks)
        g_string_free(g_gstrColorLinks, TRUE);
    if (g_gstrColorNotFound)
        g_string_free(g_gstrColorNotFound, TRUE);

	if (g_gstrCommandCopy)
       		g_string_free(g_gstrCommandCopy, TRUE);
   	if (g_gstrCommandMove)
        	g_string_free(g_gstrCommandMove, TRUE);
	if (g_gstrCommandRename)
        	g_string_free(g_gstrCommandRename, TRUE);
	if (g_gstrCommandRemove)
        	g_string_free(g_gstrCommandRemove, TRUE);
	if (g_gstrCommandMakedir)
        	g_string_free(g_gstrCommandMakedir, TRUE);


    //if (g_TextBuffer_CommandHistory){   //I dont know if this is necessary or not
    //   gtk_object_unref (GTK_OBJECT (g_TextBuffer_CommandHistory));
    //}

    //Free the fileshelfthings
	DeleteFileshelfThings();

	//free autoUpdateList
	autoUpdateList_deleteList ();

	TRACEIT(10,"clearUpGobals		end");
}


void saveThings(){
	TRACEIT(10,"saveThings		start");
	GString *gstrBuf = g_string_sized_new(20);
	if (0 == myFiles_SaveFileSimpleSave("Cat'sEyE save file, please do not touch unless you really know what to do.\n", "w+")){
        savePathes();
        saveFileShelfs();
		if (1==g_int_AlwaysShowHidden){
			g_string_printf(gstrBuf, "%s%strue\n",ALWAYS_SHOW_HIDDEN,TYPESEPARATOR);
			myFiles_SaveFileSimpleSave(gstrBuf->str, "a+");
		}
	}
	g_string_free(gstrBuf, TRUE);
	TRACEIT(10,"saveThings		ends");
}


void loadThings(){
	TRACEIT(10,"loadThings		start");
	loadGlobals();
	loadStartPathes();
	loadFileShelfs(NULL);
	TRACEIT(10,"loadThings		ends");
}


void loadGlobals(){
	TRACEIT(10,"loadGlobals		start");
    GString *gstrBuf=NULL;
   	struct myFiles_struct *filestru=NULL;
	filestru = myFiles_openConfigTypesFile("r");
	if (filestru == NULL){
	    TRACEIT(3,"loadGlobals		Configfile not found, loading default colors and commands");
	    g_gstrColorItems=g_string_new(DEFAULT_COLOR_ITEMS_DEFAULT);
	    g_gstrColorDirs=g_string_new(DEFAULT_COLOR_DIRECTORIES);
	    g_gstrColorLinks=g_string_new(DEFAULT_COLOR_LINKS);
	    g_gstrColorNotFound=g_string_new(DEFAULT_COLOR_ITEMS_MISSING);
	    g_gstrCommandCopy=g_string_new(DEFAULT_COMMAND_COPY);
	    g_gstrCommandMove=g_string_new(DEFAULT_COMMAND_MOVE);
	    g_gstrCommandRename=g_string_new(DEFAULT_COMMAND_RENAME);
	    g_gstrCommandRemove=g_string_new(DEFAULT_COMMAND_DELETE);
	    g_gstrCommandMakedir=g_string_new(DEFAULT_COMMAND_MAKEDIR);
	    TRACEIT(10,"loadGlobals		end, default");
        return;
	}
	gstrBuf=NULL;
	if (myFiles_getValueFromIdentifier(filestru, COLOR_ITEMS_DEFAULT, 0) == 1){
        	gstrBuf = g_string_new(filestru->gstrValue->str);
        	cutSpacesFromGString(gstrBuf);
        	if (strlen(gstrBuf->str) == 0){   //not valid
        	    g_string_free(gstrBuf,TRUE);
        	    gstrBuf=NULL;
        	}
        	g_gstrColorItems = gstrBuf;
    	}
	if (gstrBuf==NULL){
		g_gstrColorItems=g_string_new(DEFAULT_COLOR_ITEMS_DEFAULT);
	}
	gstrBuf=NULL;
    	if (myFiles_getValueFromIdentifier(filestru, COLOR_DIRECTORIES, 0) == 1){
        	gstrBuf = g_string_new(filestru->gstrValue->str);
        	cutSpacesFromGString(gstrBuf);
        	if (strlen(gstrBuf->str) == 0){   //not valid
        	    g_string_free(gstrBuf,TRUE);
        	    gstrBuf=NULL;
        	}
        	g_gstrColorDirs = gstrBuf;
    	}
	if (gstrBuf==NULL){
		g_gstrColorDirs=g_string_new(DEFAULT_COLOR_DIRECTORIES);
	}
	gstrBuf=NULL;
    	if (myFiles_getValueFromIdentifier(filestru, COLOR_LINKS, 0) == 1){
        	gstrBuf = g_string_new(filestru->gstrValue->str);
        	cutSpacesFromGString(gstrBuf);
        	if (strlen(gstrBuf->str) == 0){   //not valid
        	    g_string_free(gstrBuf,TRUE);
            	    gstrBuf=NULL;
        	}
	        g_gstrColorLinks = gstrBuf;
    	}
	if (gstrBuf==NULL){
		g_gstrColorLinks=g_string_new(DEFAULT_COLOR_LINKS);
	}
	gstrBuf=NULL;
    	if (myFiles_getValueFromIdentifier(filestru, COLOR_ITEMS_MISSING, 0) == 1){
        	gstrBuf = g_string_new(filestru->gstrValue->str);
        	cutSpacesFromGString(gstrBuf);
        	if (strlen(gstrBuf->str) == 0){   //not valid
            		g_string_free(gstrBuf,TRUE);
            		gstrBuf=NULL;
        	}
        	g_gstrColorNotFound = gstrBuf;
    	}
	if (gstrBuf==NULL){
		g_gstrColorNotFound=g_string_new(DEFAULT_COLOR_ITEMS_MISSING);
	}

	//get definitions for some commands
	gstrBuf=NULL;
	if (myFiles_getValueFromIdentifier(filestru, COMMAND_COPY, 0) == 1){
        	gstrBuf = g_string_new(filestru->gstrValue->str);
        	cutSpacesFromGString(gstrBuf);
        	if (strlen(gstrBuf->str) == 0){   //not valid
        	    g_string_free(gstrBuf,TRUE);
        	    gstrBuf=NULL;
        }
		else{
			g_string_assign(gstrBuf,filestru->gstrValue->str);
			g_gstrCommandCopy = gstrBuf;
		}
    }
	if (gstrBuf==NULL){
		g_gstrCommandCopy=g_string_new(DEFAULT_COMMAND_COPY);
	}
	gstrBuf=NULL;
    	if (myFiles_getValueFromIdentifier(filestru, COMMAND_MOVE, 0) == 1){
        	gstrBuf = g_string_new(filestru->gstrValue->str);
        	cutSpacesFromGString(gstrBuf);
        	if (strlen(gstrBuf->str) == 0){   //not valid
        	    g_string_free(gstrBuf,TRUE);
        	    gstrBuf=NULL;
        }
		else{
			g_string_assign(gstrBuf,filestru->gstrValue->str);
        		g_gstrCommandMove = gstrBuf;
		}
    	}
	if (gstrBuf==NULL){
		g_gstrCommandMove=g_string_new(DEFAULT_COMMAND_MOVE);
	}
	gstrBuf=NULL;
    	if (myFiles_getValueFromIdentifier(filestru, COMMAND_RENAME, 0) == 1){
        	gstrBuf = g_string_new(filestru->gstrValue->str);
        	cutSpacesFromGString(gstrBuf);
        	if (strlen(gstrBuf->str) == 0){   //not valid
        	    g_string_free(gstrBuf,TRUE);
            	    gstrBuf=NULL;
        }
		else{
			g_string_assign(gstrBuf,filestru->gstrValue->str);
	        	g_gstrCommandRename = gstrBuf;
		}
    }
	if (gstrBuf==NULL){
		g_gstrCommandRename=g_string_new(DEFAULT_COMMAND_RENAME);
	}
	gstrBuf=NULL;
    	if (myFiles_getValueFromIdentifier(filestru, COMMAND_DELETE, 0) == 1){
        	gstrBuf = g_string_new(filestru->gstrValue->str);
        	cutSpacesFromGString(gstrBuf);
        	if (strlen(gstrBuf->str) == 0){   //not valid
        	    g_string_free(gstrBuf,TRUE);
            	    gstrBuf=NULL;
        }
		else{
			g_string_assign(gstrBuf,filestru->gstrValue->str);
	        	g_gstrCommandRemove = gstrBuf;
		}
    }
	if (gstrBuf==NULL){
		g_gstrCommandRemove=g_string_new(DEFAULT_COMMAND_DELETE);
	}
	gstrBuf=NULL;
    	if (myFiles_getValueFromIdentifier(filestru, COMMAND_MAKEDIR, 0) == 1){
        	gstrBuf = g_string_new(filestru->gstrValue->str);
        	cutSpacesFromGString(gstrBuf);
        	if (strlen(gstrBuf->str) == 0){   //not valid
        	    g_string_free(gstrBuf,TRUE);
            	    gstrBuf=NULL;
        }
		else{
			g_string_assign(gstrBuf,filestru->gstrValue->str);
	        	g_gstrCommandMakedir = gstrBuf;
		}
   	}
	if (gstrBuf==NULL){
		g_gstrCommandMakedir=g_string_new(DEFAULT_COMMAND_MAKEDIR);
	}

   	myFiles_closeFile(filestru);

	//load from savefile:
	gstrBuf = g_string_sized_new(10);
	if (1 == myFiles_SaveFileSimpleGetValue(ALWAYS_SHOW_HIDDEN, gstrBuf)){
		if (0==strcmp(gstrBuf->str, "true")){
			g_int_AlwaysShowHidden=1;
		}
		else{
			g_int_AlwaysShowHidden=0;
		}
	}
	g_string_free(gstrBuf, TRUE);

   	TRACEIT(10,"loadGlobals		end");
}


void savePathes(){
	TRACEIT(10,"savePathes		start");
	GString *PathesLeft = g_string_sized_new(10);
	GString *StartPath = g_string_sized_new(10);

    struct myFiles_struct *filestru=NULL;
	filestru = myFiles_openConfigTypesFile("r");
	if (filestru == NULL){
		TRACEIT(8,"savePathes		configFile NOT found, do not sve pathes");
		g_string_free(PathesLeft,TRUE);
		g_string_free(StartPath,TRUE);
		TRACEIT(10,"savePathes		ends");
		return;
	}
	if (myFiles_getValueFromIdentifier(filestru, SAVEPATHESONEXIT, 0) == 1){
	    if (myFiles_SeparateMultiValue(filestru, StartPath, NULL, 0) == 1){
	        cutSpacesFromGString(StartPath);
			if (strcmp (StartPath->str,"true") == 0 || strcmp (StartPath->str,"True") == 0 || strcmp (StartPath->str,"TRUE") == 0){
                struct  SideObjectList *Object = NULL;
                guint i;
                int i_NoteBookTabs;
				guint guint_NoteBookTabs=0;


				//save left pathes and attributes
				i_NoteBookTabs = gtk_notebook_get_n_pages ((GtkNotebook *)Notebooks[SIDE_LEFT]);
                if (i_NoteBookTabs > 0){
                    guint_NoteBookTabs = i_NoteBookTabs;
                }
                for (i=0; i<guint_NoteBookTabs; i++){
                    if ( 0== SideObjectList_GetObjectByPageNumber((GtkNotebook *)Notebooks[SIDE_LEFT], &Object, i)){
						//PATH
						g_string_printf(PathesLeft, LASTPATHLEFTID, i);
						g_string_append(PathesLeft,TYPESEPARATOR);
                        g_string_append(PathesLeft,Object->gstrPath->str);
						myFiles_SaveFileSimpleSave(PathesLeft->str, "a+");
						//HIDDEN FLAG
						if (Object->showHiddenFiles){
							g_string_printf(PathesLeft, LASTPATHLEFTHIDDENID, i);
							g_string_append(PathesLeft,TYPESEPARATOR);
							g_string_append(PathesLeft,"true");
							myFiles_SaveFileSimpleSave(PathesLeft->str, "a+");
						}
                    }
                }
				//save right pathes and attributes
				guint_NoteBookTabs=0;
                i_NoteBookTabs = gtk_notebook_get_n_pages ((GtkNotebook *)Notebooks[SIDE_RIGHT]);
                if (i_NoteBookTabs > 0){
                    guint_NoteBookTabs = i_NoteBookTabs;
                }
                for (i=0; i<guint_NoteBookTabs; i++){
                    if ( 0== SideObjectList_GetObjectByPageNumber((GtkNotebook *)Notebooks[SIDE_RIGHT], &Object, i)){
						//PATH
						g_string_printf(PathesLeft, LASTPATHRIGHTID, i);
						g_string_append(PathesLeft,TYPESEPARATOR);
                        g_string_append(PathesLeft,Object->gstrPath->str);
						myFiles_SaveFileSimpleSave(PathesLeft->str, "a+");
						//HIDDEN FLAG
						if (Object->showHiddenFiles){
							g_string_printf(PathesLeft, LASTPATHRIGHTHIDDENID, i);
							g_string_append(PathesLeft,TYPESEPARATOR);
							g_string_append(PathesLeft,"true");
							myFiles_SaveFileSimpleSave(PathesLeft->str, "a+");
						}
                    }
                }
			}
		}
	}
    myFiles_closeFile(filestru);

	g_string_free(PathesLeft,TRUE);
	g_string_free(StartPath,TRUE);
	TRACEIT(10,"savePathes		ends");
}


void loadStartPathes(){
	TRACEIT(10,"loadStartPathes		start");
	int done_pathloaded=0;
	int LoadLastPathes = 0;
	int i=0;
	int firstItem=0;
	struct SideObjectList *Object=NULL;

	GString *StartPath = g_string_sized_new(30);
	GString *gstrIdentifier = g_string_sized_new(20);
	GString *gstrLastPathesLeft = g_string_sized_new(50);
	GString *gstrLastPathesRight = g_string_sized_new(50);
	GString *gstrStandartDirCommand = g_string_sized_new(10);
	GString *gstrStandartDirCommandName = g_string_sized_new(10);

    struct myFiles_struct *Savefilestru=NULL;
    struct myFiles_struct *filestru=NULL;
	filestru = myFiles_openConfigTypesFile("r");
	//fall back, no configfile found, load homedir and exit
	if (filestru == NULL){
		TRACEIT(8,"loadStartPathes		configFile NOT found");

		getStandardStartDirectory(gstrStandartDirCommand, gstrStandartDirCommandName);
		SideObjectList_StartWithObjectList((GtkNotebook *)Notebooks[SIDE_LEFT], gstrStandartDirCommand->str);
		SideObjectList_CreateNewViewWithPath((GtkNotebook *)Notebooks[SIDE_RIGHT], gstrStandartDirCommand->str,NULL);

		g_string_free(StartPath,TRUE);
		g_string_free(gstrLastPathesLeft,TRUE);
		g_string_free(gstrLastPathesRight,TRUE);
		g_string_free(gstrStandartDirCommand,TRUE);
		g_string_free(gstrStandartDirCommandName,TRUE);
		g_string_free(gstrIdentifier, TRUE);
		TRACEIT(10,"loadStartPathes		ends");
		return;
	}

	//check for 'save pathes on exit' property in configfile
	if ( myFiles_getValueFromIdentifier(filestru, SAVEPATHESONEXIT, 0) == 1){
		if (myFiles_SeparateMultiValue(filestru, StartPath, NULL, 0) == 1){
		    cutSpacesFromGString(StartPath);
			if (strcmp (StartPath->str,"true") == 0 || strcmp (StartPath->str,"True") == 0 || strcmp (StartPath->str,"TRUE") == 0){
				LoadLastPathes=1;
			}
		}
	}

	Savefilestru = myFiles_openSaveFile("r");

	firstItem=0;
	if (LoadLastPathes==1 && Savefilestru!= NULL){// && 1==myFiles_getValueFromIdentifier(Savefilestru, LASTPATHESLEFTKEY, 0)){
		//lets get it on and load the saved pathes from savefile
		i=0;
		while (1){
			//PATH
			g_string_printf(gstrIdentifier, LASTPATHLEFTID, i);
			if ( 1 == myFiles_getValueFromIdentifier(Savefilestru, gstrIdentifier->str, 0) ){
				done_pathloaded = 1;
				if (0 == firstItem){
					SideObjectList_StartWithObjectList((GtkNotebook *)Notebooks[SIDE_LEFT], Savefilestru->gstrValue->str);
					firstItem=1;
				}
				else
					SideObjectList_CreateNewViewWithPath((GtkNotebook *)Notebooks[SIDE_LEFT], Savefilestru->gstrValue->str, NULL);
			}
			else{
				break;
			}
			SideObjectList_GetActiveObject((GtkNotebook *)Notebooks[SIDE_LEFT], &Object);
			//HIDDENFLAG
			g_string_printf(gstrIdentifier, LASTPATHLEFTHIDDENID, i);
			if ( 1 == myFiles_getValueFromIdentifier(Savefilestru, gstrIdentifier->str, 0) ){
				if (strcmp(Savefilestru->gstrValue->str, "true")==0){
					Object->showHiddenFiles=TRUE;
					SideObjectList_UpdateObject(Object);
					updateViewWithNewFolder(Object,NULL);
				}
			}
			i++;
		}
	}
	//fallback, load standard start dirs from startdirectory property from configfile
	if (done_pathloaded==0 && myFiles_getValueFromIdentifier(filestru, STARTDIRECTORIESLEFTKEY, 0) == 1){
		//Standardstart dirs are not the saved one, they are in the configfile
		TRACEIT(11,"loadStartPathes		left side Found");
		while (myFiles_SeparateMultiValue(filestru, StartPath, NULL, 0)==1){
			TRACEIT(11,"loadStartPathes		Entry left side Found");
			cutLeadingSpacesFromGString(StartPath);
			if (done_pathloaded == 0){
				SideObjectList_StartWithObjectList((GtkNotebook *)Notebooks[SIDE_LEFT], StartPath->str);
				done_pathloaded=1;
			}
			else{
				SideObjectList_CreateNewViewWithPath((GtkNotebook *)Notebooks[SIDE_LEFT], StartPath->str,NULL);
			}
		}
	}
	// fall back, just load standard start directory (one) or at least the homedir
	if(done_pathloaded == 0){
		TRACEIT(11,"loadStartPathes		left side NOT Found");
		getStandardStartDirectory(gstrStandartDirCommand, gstrStandartDirCommandName);
		SideObjectList_StartWithObjectList((GtkNotebook *)Notebooks[SIDE_LEFT], gstrStandartDirCommand->str);
	}


	//RIGHT
	done_pathloaded=0;
	if (LoadLastPathes==1 && Savefilestru!= NULL){// && 1==myFiles_getValueFromIdentifier(Savefilestru, LASTPATHESLEFTKEY, 0)){
		//lets get it on and load the saved pathes from savefile
		i=0;
		while (1){
			//PATH
			g_string_printf(gstrIdentifier, LASTPATHRIGHTID, i);
			if ( 1 == myFiles_getValueFromIdentifier(Savefilestru, gstrIdentifier->str, 0) ){
				done_pathloaded = 1;
				SideObjectList_CreateNewViewWithPath((GtkNotebook *)Notebooks[SIDE_RIGHT], Savefilestru->gstrValue->str, NULL);
			}
			else{
				break;
			}
			SideObjectList_GetActiveObject((GtkNotebook *)Notebooks[SIDE_RIGHT], &Object);
			//HIDDENFLAG
			g_string_printf(gstrIdentifier, LASTPATHRIGHTHIDDENID, i);
			if ( 1 == myFiles_getValueFromIdentifier(Savefilestru, gstrIdentifier->str, 0) ){
				if (strcmp(Savefilestru->gstrValue->str, "true")==0){
					Object->showHiddenFiles=TRUE;
					SideObjectList_UpdateObject(Object);
					updateViewWithNewFolder(Object,NULL);
				}
			}
			i++;
		}
	}
	//fallback, load standard start dirs from startdirectory property from configfile
	if (done_pathloaded==0 && myFiles_getValueFromIdentifier(filestru, STARTDIRECTORIESRIGHTKEY, 0) == 1){
		//Standardstart dirs are not the saved one, they are in the configfile
		TRACEIT(11,"loadStartPathes		left side Found");
		while (myFiles_SeparateMultiValue(filestru, StartPath, NULL, 0)==1){
			TRACEIT(11,"loadStartPathes		Entry left side Found");
			cutLeadingSpacesFromGString(StartPath);
			SideObjectList_CreateNewViewWithPath((GtkNotebook *)Notebooks[SIDE_RIGHT], StartPath->str,NULL);
			done_pathloaded=1;
		}
	}
	// fall back, just load standard start directory (one) or at least the homedir
	if(done_pathloaded == 0){
		getStandardStartDirectory(gstrStandartDirCommand, gstrStandartDirCommandName);
		SideObjectList_CreateNewViewWithPath((GtkNotebook *)Notebooks[SIDE_RIGHT], gstrStandartDirCommand->str,NULL);
    }


	//clean up
    myFiles_closeFile(filestru);
    myFiles_closeFile(Savefilestru);
	g_string_free(StartPath,TRUE);
	g_string_free(gstrLastPathesLeft,TRUE);
	g_string_free(gstrLastPathesRight,TRUE);
	g_string_free(gstrStandartDirCommand,TRUE);
	g_string_free(gstrStandartDirCommandName,TRUE);
	g_string_free(gstrIdentifier, TRUE);
	TRACEIT(10,"loadStartPathes		ends");
}


void bringAllToTheRightOrder(){
	TRACEIT(10,"bringAllToTheRightOrder		start");

	//PathEntry, 1UP Button
	gtk_box_pack_start(GTK_BOX(HBoxForButtonsAndPathEntry[SIDE_LEFT]),GTK_WIDGET(PathEntryBox[SIDE_LEFT]),TRUE,TRUE,1);
	gtk_box_pack_start(GTK_BOX(HBoxForButtonsAndPathEntry[SIDE_LEFT]),GTK_WIDGET(OnePathUpButton[SIDE_LEFT]),FALSE,FALSE,1);
	gtk_box_pack_end(GTK_BOX(HBoxForButtonsAndPathEntry[SIDE_RIGHT]),GTK_WIDGET(PathEntryBox[SIDE_RIGHT]),TRUE,TRUE,1);
	gtk_box_pack_end(GTK_BOX(HBoxForButtonsAndPathEntry[SIDE_RIGHT]),GTK_WIDGET(OnePathUpButton[SIDE_RIGHT]),FALSE,FALSE,1);

	//Bring components of each side toghether
	gtk_box_pack_start(GTK_BOX(VBox[SIDE_LEFT]),GTK_WIDGET(HBoxForButtonsAndPathEntry[SIDE_LEFT]),FALSE,FALSE,1);
	gtk_box_pack_start(GTK_BOX(VBox[SIDE_LEFT]),GTK_WIDGET(Notebooks[SIDE_LEFT]),TRUE,TRUE,1);

	gtk_box_pack_start(GTK_BOX(VBox[SIDE_RIGHT]),GTK_WIDGET(HBoxForButtonsAndPathEntry[SIDE_RIGHT]),FALSE,FALSE,1);
	gtk_box_pack_start(GTK_BOX(VBox[SIDE_RIGHT]),GTK_WIDGET(Notebooks[SIDE_RIGHT]),TRUE,TRUE,1);

	//Bring the two sides together
	gtk_paned_pack1(GTK_PANED(HPanedLeftRight),GTK_WIDGET(VBox[SIDE_LEFT]),TRUE,TRUE);
	gtk_paned_pack2(GTK_PANED(HPanedLeftRight),GTK_WIDGET(VBox[SIDE_RIGHT]),TRUE,TRUE);

	//There is one more pane
	gtk_paned_pack1(GTK_PANED(VPanedForFileShelf),GTK_WIDGET(HPanedLeftRight),TRUE,TRUE);

	//Connect it with mainwindow
	gtk_container_add (GTK_CONTAINER(win),VPanedForFileShelf);

	TRACEIT(10,"bringAllToTheRightOrder		ends");
}


int AddPathesToNotebook(GtkNotebook *Notebook, GString *gstrPathes, int AllreadyStarted){
	// gets one path and add this path to the note
	TRACEIT(10,"AddPathesToNotebook		start");
	int WeStarted=0;
	const char sep[] = PROGRAMSEPERATOR;
	char *cOnePath=NULL;
	GString *gstrOnePath=g_string_sized_new(10);

	cOnePath = strtok(gstrPathes->str,sep);
	if (cOnePath == NULL){
		TRACEIT(7,"AddPathesToNotebook		ends, NOT A PATH");
		return -1;
	}
	while(cOnePath != NULL){
	    g_string_assign(gstrOnePath, cOnePath);
	    cutLeadingSpacesFromGString(gstrOnePath);
		if (AllreadyStarted == 0 && WeStarted == 0){
			SideObjectList_StartWithObjectList(Notebook, gstrOnePath->str);
			WeStarted = 1;
		}
		else{
			SideObjectList_CreateNewViewWithPath(Notebook, gstrOnePath->str, NULL);
		}
		cOnePath = strtok(NULL,sep);
	};
	TRACEIT(10,"AddPathesToNotebook		ends");
	return 1;
}


void updatePathEntryBox(GtkNotebook *notebook, guint num){
	TRACEIT(10,"updatePathEntryBox		start");
	struct SideObjectList *Object=NULL;
	SideObjectList_GetObjectByPageNumber(notebook,&Object,(int)num);
	if (Object == NULL){
		TRACEIT(2,"updatePathEntryBox		ends, No Object??");
		return;
	}

	int leftORright = (Object->notebook == (GtkNotebook *)Notebooks[SIDE_LEFT])?SIDE_LEFT:SIDE_RIGHT;
	g_object_set(PathEntryBox[leftORright],"text",Object->gstrPath->str,NULL);
	TRACEIT(10,"updatePathEntryBox		ends");
}


gboolean onePageSwitched(GtkNotebook *notebook, GtkNotebookPage *page, guint page_num, gpointer user_data){
	TRACEIT(10,"onePageSwitched		start");
	updatePathEntryBox(notebook,page_num);

	struct SideObjectList *Object=NULL;
	if (gint_Starting == 0){
	    SideObjectList_GetObjectByPageNumber(notebook, &Object, page_num);
	    if (Object->bUpdateFlag_UpdateOnTabSwitch){
	        Object->bUpdateFlag_F6=FALSE;
            updateView(Object);
            Object->bUpdateFlag_UpdateOnTabSwitch=FALSE;
	    }
        //updateViewWithNewFolder(Object, NULL);
	}
	TRACEIT(10,"onePageSwitched		ends");
	return FALSE;
}


gboolean oneMouseButtonPressedOnNotebook(GtkWidget *notebook, GdkEventButton *event, gpointer data){
	TRACEIT(10,"oneMouseButtonPressedOnNotebook		start");

	int leftORrightOrFileshelf = GPOINTER_TO_INT(data);

	//event->button = 2 is the middle mousebutton, I've tried many things but the problem, that the
	//tab, the mouse is over, will be deleted only once still was there. All further klicks on the
	//middle mouse button delete just the tab which is currently active, without activating the one
	//the mouse is over. So I decided to forget this feature. However, now it is possible to close a
	//tab via double click with the left mouse button
	//IT SEEMS THIS WAS A BUG in a earlier release in compination with FreeBSD or something like
	//that, however, now it works just great and from now on, we close the tabs via the middle mouse button.
	if (event->type == GDK_BUTTON_PRESS  &&  (event->button == 3 /*|| event->button==2*/)){
	    //contextMenu
		//If the user makes a right click on an unselected Tab we want the notbook to select the Tab the mouse is over.
		//So we sent an left click event to the notebook and it will make the work for us
		GdkEventButton newEvent;
		newEvent.type = event->type;
		newEvent.window = event->window;
		newEvent.send_event = event->send_event;
		newEvent.time = event->time+1;
		newEvent.x = event->x;
		newEvent.y = event->y;
		newEvent.axes = event->axes;
		newEvent.state = event->state;
		newEvent.button = 1;
		newEvent.device = event->device;
		newEvent.x_root = event->x_root;
		newEvent.y_root = event->y_root;

		gboolean ret;

		g_signal_emit_by_name (notebook,"button-press-event",&newEvent,&ret);
		newEvent.type= GDK_BUTTON_RELEASE;
		g_signal_emit_by_name (notebook,"button-press-event",&newEvent,&ret);

		//if (event->button==3){
			if (leftORrightOrFileshelf <= SIDE_BOTH){
				openTabContextMenu(notebook,event,data);	//Look near the end of the file
			}
			else if(leftORrightOrFileshelf == SIDE_FILESHELF){
				openFileShelfTabContextMenu(notebook,event,data);
			}
		//}

		TRACEIT(10,"oneMouseButtonPressedOnNotebook		ends");
		return TRUE;
	}/*
	else if(event->type == GDK_2BUTTON_PRESS &&  event->button == 1){
	    //close tab
		if (leftORrightOrFileshelf <= SIDE_BOTH){
			SideObjectList_DeleteActiveObject((GtkNotebook *)notebook);
		}
		else if(leftORrightOrFileshelf == SIDE_FILESHELF){
			FileShelf_DeleteActiveTab();
		}
		return TRUE;
	}*/
	else if (event->type == GDK_BUTTON_PRESS  &&  (event->button==2)){
	    //close tab
		//If the user makes a right click on an unselected Tab we want the notbook to select the Tab the mouse is over.
		//So we sent an left click event to the notebook and it will make the work for us
		GdkEventButton newEvent;
		newEvent.type = event->type;
		newEvent.window = event->window;
		newEvent.send_event = event->send_event;
		newEvent.time = event->time+1;
		newEvent.x = event->x;
		newEvent.y = event->y;
		newEvent.axes = event->axes;
		newEvent.state = event->state;
		newEvent.button = 1;
		newEvent.device = event->device;
		newEvent.x_root = event->x_root;
		newEvent.y_root = event->y_root;

		gboolean ret;

		g_signal_emit_by_name (notebook,"button-press-event",&newEvent,&ret);
		newEvent.type= GDK_BUTTON_RELEASE;
		g_signal_emit_by_name (notebook,"button-press-event",&newEvent,&ret);

        if (leftORrightOrFileshelf <= SIDE_BOTH){
			SideObjectList_DeleteActiveObject((GtkNotebook *)notebook);
		}
		else if(leftORrightOrFileshelf == SIDE_FILESHELF){
			FileShelf_DeleteActiveTab();
		}

		return TRUE;
	}

	TRACEIT(10,"oneMouseButtonPressedOnNotebook		ends");
	return FALSE;
}


void onePageAddedToNotebook(GtkNotebook *notebook, GtkWidget *child, guint page_num, gpointer data){
	TRACEIT(10,"onePageAddedToNotebook		start");
	struct SideObjectList *Object=NULL;
	SideObjectList_GetObjectByPageNumber(notebook,&Object,page_num);
	if (Object == NULL){
		TRACEIT(10,"onePageAddedToNotebook		ends");
		return;
	}

	gtk_notebook_set_current_page(notebook,page_num);

	updateViewWithNewFolder(Object,Object->gstrPath);   //dont change this, we need the the newPath here for moitoring, look updateViewWithNewFolder
	TRACEIT(10,"onePageAddedToNotebook		ends");
}


gboolean oneMouseButtonPressed(GtkWidget *treeview, GdkEventButton *event, gpointer data){
	TRACEIT(10,"oneMouseButtonPressed		start");
    GdkEventButton newEvent;
	struct SideObjectList *Object=(struct SideObjectList *)data;

    //dragndrop - related
    //I want to explain the following lines till //END-EXPLAINLINES:
    // This lines are here for the dragndrop thing. When marking more than one item and we want them to drag and drop we have to
    // catch this mousebutton event (this is the first if statement).
    // But we also have to unselect all the others when a simple mousebutten event on one item occurs. This is the second if statement.
    // We define an area in which we onyl select the item the mousepointer is over.
	GtkTreeSelection *selection=NULL;
    selection  = gtk_tree_view_get_selection((GtkTreeView *)treeview);
    guint modifiers;
	modifiers = gtk_accelerator_get_default_mod_mask ();
    static double x=0;
    static double y=0;
    GtkTreePath *path=NULL;
	if (gtk_tree_selection_count_selected_rows(selection)  > 1 ){   //onyl catch this if more than one item is selected
        if (event->type == GDK_BUTTON_PRESS  &&  event->button == 1){   //and it is the 1st mouse button
            if ((event->state & modifiers) == 0){                       //and no modifiers (such as ctrl or alt) are pressed.
                //when we have an event not over an selected Path we ignore the event
                gtk_tree_view_get_path_at_pos ( (GtkTreeView *)treeview, (gint) event->x, (gint) event->y, &path, NULL, NULL, NULL);
                if (path != NULL){  //may be NULL if the area which is clicked has no item
                    if (TRUE == gtk_tree_selection_path_is_selected (selection, path)){
                        gtk_tree_path_free (path);
                        x=event->x;
                        y=event->y;
                        return TRUE;
                    }
                    gtk_tree_path_free (path);
                }
                else{
                    gtk_tree_selection_unselect_all(selection); //dont waste time and unmark the items
                }
            }
		}
	}
    if (gtk_tree_selection_count_selected_rows(selection)  > 1 ){
        if (event->type == GDK_BUTTON_RELEASE  &&  event->button == 1){
            if ((event->state & modifiers) == 0){
                if (x-event->x < 6.0 && y-event->y < 6.0){
                    gtk_tree_selection_unselect_all(selection);
                    x=0;
                    y=0;
                    if (event->window == gtk_tree_view_get_bin_window ((GtkTreeView *)treeview)){
                        gtk_tree_view_get_path_at_pos ( (GtkTreeView *)treeview, (gint) event->x, (gint) event->y, &path, NULL, NULL, NULL);
                        if (path != NULL){  //may be NULL if the area which is clicked has no item
                            gtk_tree_selection_select_path (selection,  path);
                            gtk_tree_path_free (path);
                        }
                    }
                    return TRUE;
                }
            }
		}
	}
    //END-EXPLAINLINES (dragndrop - related)

	if (event->type == GDK_BUTTON_PRESS  &&  event->button == 3){
		openContextMenu(treeview,event,data);	//Look near the end of the file
		TRACEIT(10,"oneMouseButtonPressed		ends");
		return TRUE;
	}
	if (event->type == GDK_BUTTON_PRESS  &&  event->button == 2){ //we mark all items of the view which have the same endings as the one allready marked
	    //we fire an mousebutton 1 event to the same position to get the item selected the mouse is over
        newEvent.type = event->type;
		newEvent.window = event->window;
		newEvent.send_event = event->send_event;
		newEvent.time = event->time+1;
		newEvent.x = event->x;
		newEvent.y = event->y;
		newEvent.axes = event->axes;
		newEvent.state = event->state;
		newEvent.button = 1;
		newEvent.device = event->device;
		newEvent.x_root = event->x_root;
		newEvent.y_root = event->y_root;

		gboolean ret;

		g_signal_emit_by_name (treeview,"button-press-event",&newEvent,&ret);
		newEvent.type= GDK_BUTTON_RELEASE;
		g_signal_emit_by_name (treeview,"button-press-event",&newEvent,&ret);

		markItemsWithSameType((GtkTreeView *)Object->listView, COL_FILETYPE);
		TRACEIT(10,"oneMouseButtonPressed		ends");
		return TRUE;
	}
	TRACEIT(10,"oneMouseButtonPressed		ends");
	return FALSE;
}


gboolean oneContextMenuReplied(GtkWidget *treeview, gpointer data){
	TRACEIT(10,"oneContextMenuReplied		start");
	openContextMenu(treeview,NULL, data);	//Look near the end of the file
	TRACEIT(10,"oneContextMenuReplied		ends");
	return TRUE;
}


gboolean oneNoteBookContextMenuReplied(GtkWidget *treeview, gpointer data){
    TRACEIT(10,"oneNoteBookContextMenuReplied		start");
	openTabContextMenu(treeview,NULL, NULL);	//Look near the end of the file
	TRACEIT(10,"oneNoteBookContextMenuReplied		ends");
	return TRUE;
}


gboolean oneKeyPressedOnNotebook(GtkWidget *widget, GdkEventKey *event, gpointer data){
    //data = SIDE_LEFT || SIDE_RIGHT
    //We pass key events to the view (SideObjects AND Fileshelf)
	TRACEIT(10,"oneKeyPressedOnNotebook		start");
	struct SideObjectList *SideObject=NULL;
	struct FileShelfObjectList *ShelfObject=NULL;
	int leftORrightOrFileshelf = GPOINTER_TO_INT(data);
    gboolean bRet = FALSE;

    if (leftORrightOrFileshelf <= SIDE_BOTH){
        SideObjectList_GetActiveObject((GtkNotebook *)Notebooks[leftORrightOrFileshelf], &SideObject);
        if (SideObject == NULL){
            TRACEIT(3,"oneKeyPressedOnNotebook		end, No Object found");
            return FALSE;
        }
        bRet = oneKeyPressedInView(NULL, event, (void *)SideObject);
	}
	else if(leftORrightOrFileshelf == SIDE_FILESHELF){
        FileShelfObjectList_GetActiveObject(&ShelfObject);
        if (ShelfObject == NULL){
            TRACEIT(3,"oneKeyPressedOnNotebook		end, No Object found");
            return FALSE;
        }
        bRet = oneFileShelfKeyPressedInView(NULL, event, (void *)ShelfObject);
    }

	TRACEIT(10,"oneKeyPressedOnNotebook		end");
	return bRet; //if we do not handle it return FALSE
}


gboolean oneKeyPressedInView(GtkWidget *widget, GdkEventKey *event, gpointer data){
    //Be aware of using widget, as this function is called when a key is pressed on a notebook (tab) too
    //data = struct SideObjectList
	TRACEIT(10,"oneKeyPressedInView		start");
	guint modifiers;

	modifiers = gtk_accelerator_get_default_mod_mask ();
	struct SideObjectList *Object = (struct SideObjectList *)data;
    int leftORright = (Object->notebook == (GtkNotebook *)Notebooks[SIDE_LEFT])?SIDE_LEFT:SIDE_RIGHT;

	if ( (event->keyval == GDK_Delete)){
	    //Delete selected files with 'del-key'
		mayDeleteSelectedRows(NULL, data);
		TRACEIT(10,"oneKeyPressedInView		ends");
		return TRUE;
	}
	else if ( (event->keyval == GDK_Return)){
        //go to directory or start userprogram with marked items
        oneRowActivated_SideObjectWrap(NULL, NULL, NULL, data);
        return TRUE;
	}
	else if (event->keyval == GDK_BackSpace){
	    //One path up with backspace
        oneOnePathUpButtonClicked(NULL, (void *)leftORright);
        return TRUE;
	}
	else if (event->keyval == GDK_F2){
        //rename selected
        renameItems(NULL, data);
        return TRUE;
	}
    else if (event->keyval == GDK_F3){
	    //create New Directory 'F4'
        mayNewDirectory(NULL, data);
        return TRUE;
	}
    else if (event->keyval == GDK_F4){
	    //open Terminal 'F4'
        getTerminal();
        if (TheTerminalStruct.UserCommand != NULL && TheTerminalStruct.UserCommandName != NULL){
            TheTerminalStruct.Object = (struct SideObjectList *)data;
            startItemsWithUserCommand_WraperforSideObject(NULL, &TheTerminalStruct);
        }
        return TRUE;
	}
	else if (event->keyval == GDK_F5){
	    //Update view with 'F5'
        //updateViewWithNewFolder(Object, NULL);
        //updateView(Object);
        updateViewWithNewFolder_UserAdvice(Object, NULL);
        return TRUE;
	}
	else if (event->keyval == GDK_F6){
	    //Update view with 'F6'
	    //updateViewWithNewFolder(Object, NULL);
	    //updateView(Object); //we do not need this any longer, because of our automatic update
        Object->bUpdateFlag_F6=TRUE;
	    struct AllInformationAllUseStruct *stru = malloc (sizeof(struct AllInformationAllUseStruct));
	    if (stru == NULL){
            TRACEIT(1,"oneKeyPressedInView		error allocating memory");
            return TRUE;
	    }
        stru->source=SOURCE_SIDEOBJECT;
        stru->Info_1 = data;
        stru->Info_2 = NULL;
        stru->Info_3 = NULL;
        stru->Info_4 = NULL;
        stru->Info_5 = NULL;

        Object->iRecursiveSizeCalculation=0;
        calcDirectorySizeInView_wrap(stru);

        return TRUE;
	}

	else if ((event->keyval == 'c' || event->keyval == 'C') && (event->state & modifiers) == GDK_CONTROL_MASK){
        //Copy Paste // here is copy
        CopyPasteCreateList_SideObject(data, 1);
        return TRUE;
	}
	else if ((event->keyval == 'x' || event->keyval == 'X') && (event->state & modifiers) == GDK_CONTROL_MASK){
        //Copy Paste // here is cut
        CopyPasteCreateList_SideObject(data, 2);
        return TRUE;
	}
	else if ((event->keyval == 'v' || event->keyval == 'V') && (event->state & modifiers) == GDK_CONTROL_MASK){
        //Copy Paste // here is paste
        CopyPasteProcessList_SideObject(data);
        return TRUE;
	}
	else if ((event->keyval == 'n' || event->keyval == 'N') && (event->state & modifiers) == GDK_CONTROL_MASK){
        //new page
        addNewPage(NULL, Object->notebook);
        return TRUE;
	}
	else if ((event->keyval == 'i' || event->keyval == 'I') && (event->state & modifiers) == GDK_CONTROL_MASK){
        //size of selected
        sizeOfSelectedItemsRecursive (NULL, data);
        return TRUE;
	}
	else if ((event->keyval == 'h' || event->keyval == 'H') && (event->state & modifiers) == GDK_CONTROL_MASK){
        //show hidden files
        showHiddenFilesInActivePage(NULL, Object->notebook);
        return TRUE;
	}
	else if( event->keyval == 'a' && (event->state & modifiers) == GDK_CONTROL_MASK){
	    //select all
        mySelectAllFunction((GtkTreeView *)Object->listView, (void *)Object);
        return TRUE;
	}
	else if ((event->keyval == 's' || event->keyval == 'S') && (event->state & modifiers) == GDK_CONTROL_MASK){
	    //Add selected items to active fileshelf
		MenuAddItemToFileshelf(NULL, data);
		return TRUE;
	}
	else if ((event->keyval == 'd' || event->keyval == 'D') && (event->state & modifiers) == GDK_CONTROL_MASK){
	    //Add selected items to new fileshelf
		MenuAddToNewFileshelf(NULL, data);
		return TRUE;
	}
	else if ((event->keyval == 'f' || event->keyval == 'F') && (event->state & modifiers) == GDK_MOD1_MASK){
        //my search function
        searchStringInAndHighlightItems_WraperforSideObject(NULL, Object->listView);
        return TRUE;
	}
	else if ((event->keyval == 'c' || event->keyval == 'C') && (event->state & modifiers) == GDK_MOD1_MASK){
        //copy selected to other side
        copyToOtherPannel(NULL, data);
        return TRUE;
	}
	else if ((event->keyval == 'x' || event->keyval == 'X') && (event->state & modifiers) == GDK_MOD1_MASK){
        //move selected to other side
        moveToOtherPannel(NULL, data);
        return TRUE;
	}
	/*
	else if (event->keyval == GDK_F8){
        CursorToWait(Object->ScrollWindow);

        return TRUE;
	}
	else if (event->keyval == GDK_F9){
        CursorToNormal(Object->ScrollWindow);
        return TRUE;
	}
    */

	TRACEIT(10,"oneKeyPressedInView		ends");
	return FALSE;
}


void oneOnePathUpButtonClicked(GtkButton *button, gpointer data){
	TRACEIT(10,"oneOnePathUpButtonClicked		start");
	int leftORright = GPOINTER_TO_INT(data);

	struct SideObjectList *Object=NULL;

	SideObjectList_GetActiveObject(GTK_NOTEBOOK(Notebooks[leftORright]), &Object);
	if (Object == NULL){
		TRACEIT(10,"oneOnePathUpButtonClicked		ends");
		return;
	}
    GString *gstrPath = g_string_new(Object->gstrPath->str);

	checkPathForLastChar(gstrPath);
	g_string_append(gstrPath,"..");
	g_object_set(PathEntryBox[leftORright],"text",gstrPath->str,NULL);
	gtk_widget_activate(GTK_WIDGET(PathEntryBox[leftORright]));
    g_string_free(gstrPath, TRUE);
	TRACEIT(10,"oneOnePathUpButtonClicked		ends");
}


void oneColumnWasClicked(GtkTreeViewColumn *Column, gpointer data){
	TRACEIT(10,"oneColumnWasClicked		start");
	struct SideObjectList *Object=(struct SideObjectList *)data;
	Object->actualSortCol = Column;
	TRACEIT(10,"oneColumnWasClicked		ends");
}

void oneRowActivated_SideObjectWrap(GtkTreeView *treeview, GtkTreePath *TreePath, GtkTreeViewColumn *col, gpointer data){
    struct AllInformationAllUseStruct stru;

    stru.source = SOURCE_SIDEOBJECT;
    stru.Info_1 = data; //SideObject
    stru.Info_2 = NULL;
    stru.Info_3 = NULL;
    stru.Info_4 = NULL;
    stru.Info_5 = NULL;

    //oneRowActivated (treeview, TreePath, col, (void *)&stru);
    oneRowActivated (&stru);

}


void oneRowActivated(struct AllInformationAllUseStruct *stru){
    GtkTreeSelection *selection=NULL;
    int i_rowsSelected=0;
    int i_oneIsDirectory=0;
    int i_oneIsPoints=0;
    GtkWidget *ListView=NULL;
    struct SideObjectList *SideObject=NULL;
    struct FileShelfObjectList *FlShlfObject=NULL;
    GList *list=NULL;
    GtkTreeModel *model;
    GtkTreeIter iter;
	gchar *name=NULL;
	gchar *path=NULL;
	gint type_d;
	GString *NewPath=g_string_sized_new(20);
	int side=stru->source;
	struct AllInformationAllUseStruct info;

    info.source = side;
    if (stru->source == SOURCE_SIDEOBJECT){
        SideObject=(struct SideObjectList *)stru->Info_1;
    }
    else{
        FlShlfObject = (struct FileShelfObjectList *)stru->Info_1;
        //FileShelfObjectList_GetActiveObject(&Object);
	}
	if ( (side==SOURCE_SIDEOBJECT && SideObject==NULL) || (side==SOURCE_FILESHELF && FlShlfObject== NULL) ){
	    TRACEIT(2,"oneRowActivated		end, found exception");
		return;
	}
	if (side==SOURCE_SIDEOBJECT){
	    info.Info_1 = (void *)SideObject->listView;
        ListView = SideObject->listView;
        i_oneIsDirectory = checkIfOneSelectionIsPath(ListView, COL_TYPE_D);
        i_oneIsPoints = checkIfOneSelectionIsPoints(ListView, COL_NAME);
	}
    else{
        info.Info_1 = (void *)FlShlfObject->listView;
	    ListView = FlShlfObject->listView;
	    i_oneIsDirectory = checkIfOneSelectionIsPath(ListView, COL_FLSHLF_TYPE_D);
	    i_oneIsPoints = checkIfOneSelectionIsPoints(ListView, COL_FLSHLF_NAME);
    }

	selection  = gtk_tree_view_get_selection((GtkTreeView *)ListView);
    i_rowsSelected = gtk_tree_selection_count_selected_rows(selection);

    if (i_rowsSelected > 1 && (i_oneIsDirectory!=0 || i_oneIsPoints!=0)){   //We do not handle this!!, e.g. more than one directory selected, or normal items and directories are selected
        //TODO!!!!!!! error message in stutusbar
        if (side==SOURCE_SIDEOBJECT){
            gtk_statusbar_pop(SideObject->StatusBar,0);
            gtk_statusbar_push(SideObject->StatusBar,0,"There is more than one directory selected... can't do anything.");
        }
        return;
    }
    else if (i_rowsSelected != 0 && i_oneIsDirectory!=0){   //Its ONE directory we want to go to
        list = gtk_tree_selection_get_selected_rows (selection, &model);
        gtk_tree_model_get_iter (model, &iter, (GtkTreePath *)list->data);

        if (side == SOURCE_SIDEOBJECT){
            gtk_tree_model_get(model, &iter,COL_NAME,&name,COL_TYPE_D,&type_d, -1);
        }
        else{
            gtk_tree_model_get(model, &iter,COL_FLSHLF_NAME,&name,COL_FLSHLF_TYPE_D,&type_d,COL_FLSHLF_PATH,&path, -1);
        }
        if ((type_d==4 || type_d==10) && strcmp(name,".")!=0){	//Folder!
            if (side==SOURCE_SIDEOBJECT){
                g_string_assign(NewPath, SideObject->gstrPath->str);
                checkPathForLastChar(NewPath);
                g_string_append(NewPath,name);
                formatPathString(NewPath);
                updateViewWithNewFolder_UserAdvice(SideObject,NewPath);
            }
            else{
                g_string_assign(NewPath,path);
                checkPathForLastChar(NewPath);
                g_string_append(NewPath,name);
                SideObjectList_CreateNewViewWithPath(NULL,NewPath->str,NULL);
            }
        }
        g_list_foreach (list, (GFunc)gtk_tree_path_free, NULL);
        g_list_free (list);
    }
    else if (i_oneIsDirectory==0 && i_oneIsPoints==0){  //one or more items to call
        freeTypesAndUserProgrammArrays();
        getTypesOfSelectedItems(&info);
        getUserProgramsForSelectedItems(NULL);

        struct UserDataList *UserData = UserDataList_GiveMeFirstItem();

        if (UserData){
            if (side==SOURCE_SIDEOBJECT){
                UserData->Object = SideObject;
                startItemsWithUserCommand_WraperforSideObject(NULL,(void *)UserData);
            }
            else{
                UserData->Object = NULL;
                startItemsWithUserCommand_WraperforFileShelf(NULL,(void *)UserData);
            }
        }
    }
    if (name)
        g_free(name);
    if (path)
        g_free(path);
    g_string_free(NewPath,TRUE);

}


gboolean oneKeyPressed_PathEntry(GtkWidget *widget, GdkEventKey *event, gpointer data){
    TRACEIT(10,"oneKeyPressed_PathEntry		start");
    char *completed=NULL;
    char *cpPath=NULL;
    int iCurrentPosition=0;
    int ret=0;

    if ( (event->keyval == GDK_Tab)){   //PATH COMPLETION
        g_object_get(widget,"text",&cpPath,NULL);
        if (cpPath != NULL){
            ret = completePath(cpPath, &completed);
            if (completed){
                g_object_set(widget,"text",completed,NULL);
                gtk_editable_set_position ( (GtkEditable *)widget, -1); //sets the cursor to the end
                iCurrentPosition = gtk_editable_get_position ((GtkEditable *)widget);
                if (ret == 2){  //directory is valid
                    gtk_editable_insert_text ( (GtkEditable *)widget, "/", -1, &iCurrentPosition );
                    gtk_editable_set_position ( (GtkEditable *)widget, -1); //sets the cursor to the end
                }
                free(completed);
            }
            free(cpPath);
        }
        TRACEIT(10,"oneKeyPressed_PathEntry		end");
        return TRUE;
    }
    TRACEIT(10,"oneKeyPressed_PathEntry		end");
    return FALSE;
}


void onePathChanged(GtkEntry *entry, gpointer g){
	TRACEIT(10,"onePathChanged		start");
	gchar *NewPath=NULL;

	int leftORright = GPOINTER_TO_INT(g);
	if (leftORright == SIDE_LEFT)
		g_object_get(PathEntryBox[SIDE_LEFT], "text", &NewPath, NULL);
	else
		g_object_get(PathEntryBox[SIDE_RIGHT], "text", &NewPath, NULL);

	//Test if NewPath exists
	struct SideObjectList *Object=NULL;
	SideObjectList_GetActiveObject(GTK_NOTEBOOK(Notebooks[leftORright]), &Object);
	if (Object==NULL){
	    if (NewPath)
            g_free(NewPath);
		return;
	}
	GString *gstrbuf = g_string_new(NewPath);
	formatPathString(gstrbuf);
	if (-1 == checkDirectory(Object,gstrbuf)){
		g_string_free(gstrbuf,TRUE);
		if (NewPath)
            g_free(NewPath);
		TRACEIT(10,"onePathChanged		ends");
		return;
	}
	updateViewWithNewFolder_UserAdvice(Object, gstrbuf);

	g_string_free(gstrbuf,TRUE);
	if (NewPath)
        g_free(NewPath);
	TRACEIT(10,"onePathChanged		ends");
}


static void sizeOfSelected_Helper (GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"sizeOfSelected_Helper		start");
	struct SideObjectList *Object = (struct SideObjectList *)data;

	guint64 isize;
	gint type_d;
	gchar *name=NULL;

	GString *Path= g_string_new(Object->gstrPath->str);

	if (gtk_tree_model_get_iter(model, iter, path)){
		gtk_tree_model_get(model, iter, COL_SIZE, &isize, COL_NAME, &name, COL_TYPE_D, &type_d, -1);
		if ( strcmp(name,".")!=0 && strcmp(name,"..")!=0){
			Object->guint64sizeOfSelectedItems+=isize;
		}
	}

	g_string_free(Path,TRUE);
	if (name)
		g_free(name);

	TRACEIT(10,"sizeOfSelected_Helper		ends");
}


void updateStatusBar(struct SideObjectList *Object){
    GtkTreeSelection	*treeselection;
	char buf[266];
	int len;
	GString *gstrBuf;
	void *data = (void *)Object;

	treeselection  = gtk_tree_view_get_selection((GtkTreeView *)Object->listView);
	Object->guint64sizeOfSelectedItems=0;
	gtk_tree_selection_selected_foreach(treeselection, sizeOfSelected_Helper, data);
	snprintf(buf,265,"%lld",Object->guint64sizeOfSelectedItems);

	gstrBuf = g_string_new(buf);
	len = strlen(gstrBuf->str)-3;

	while (len>0){
		g_string_insert_c(gstrBuf,len,'.');
		len -=3;
	};

	strcpy(buf,gstrBuf->str);
	g_string_sprintf(gstrBuf,"%d Items selected: %s bytes",gtk_tree_selection_count_selected_rows(treeselection),buf);

	gtk_statusbar_pop(Object->StatusBar,0);
	gtk_statusbar_push(Object->StatusBar,0,gstrBuf->str);

	g_string_free(gstrBuf,TRUE);
}


void oneSelectionChanged(GtkTreeSelection *treeselection, gpointer data){
	TRACEIT(10,"oneSelectionChanged		start");
	struct SideObjectList *Object = (struct SideObjectList *)data;

    updateStatusBar(Object);
	TRACEIT(10,"oneSelectionChanged		ends");
}

/*
static void count_foreach_helper (GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"count_foreach_helper		start");
	int *count = (gint *)data;
	*count += 1;
	TRACEIT(10,"count_foreach_helper		ends");
}


gint  my_tree_selection_count_selected_rows (GtkTreeSelection *selection){
	TRACEIT(10,"my_tree_selection_count_selected_rows		start");
	int count = 0;

	gtk_tree_selection_selected_foreach(selection, count_foreach_helper, &count);

	TRACEIT(10,"my_tree_selection_count_selected_rows		ends");
	return count;
}
*/

void formatPathString(GString *NewPath){
	TRACEIT(10,"formatPathString		start");
	char *path = NewPath->str;
	int len = strlen(path);

	char *EndString;
	char *buf;
	int Anzahl1=0;
	int Anzahl2=0;
	int i;

	EndString = malloc(sizeof(char) * len + 20);
	if (EndString == NULL){
		TRACEIT(10,"formatPathString		ends");
		return;
	}

	//Wieviele "/.."
	buf = path;
	while(buf != NULL){
		buf = strstr(buf,"/..");
		if (buf != NULL){
			Anzahl1++;
			buf++;
		}
	}
	//Wieviele "/."
	buf = path;
	while(buf != NULL){
		buf = strstr(buf,"/.");
		if (buf != NULL){
			Anzahl2++;
			buf++;
		}
	}
	Anzahl2 = Anzahl2-Anzahl1;
	if (Anzahl2 == 0 && Anzahl1 == 0){
		free(EndString);
		TRACEIT(10,"formatPathString		ends");
		return;
	}
	int Anzahl3=0;
	EndString[0] = '\0';
	const char sep[] = "/";
	for (buf = strtok(path,sep); buf; buf=strtok(NULL,sep)){
		if (strcmp(buf,".") != 0 && strcmp(buf,"..") != 0){
			strcat(EndString,"/");
			strcat(EndString,buf);
			Anzahl3++;
		}
	}
	if (Anzahl1 >= Anzahl3){
		sprintf(EndString,"/");
		g_string_assign(NewPath,EndString);
		free(EndString);
		TRACEIT(10,"formatPathString		ends");
		return;
	}
	path = malloc(sizeof(char) * strlen(EndString) + 20);
	if (path == NULL){
		free(EndString);
		TRACEIT(10,"formatPathString		ends");
		return;
	}

	strcpy(path,EndString);
	EndString[0] = '\0';
	i=0;
	for (buf = strtok(path,sep); buf && (Anzahl3-Anzahl1) > i; buf=strtok(NULL,sep) ){
		i++;
		strcat(EndString,sep);
		strcat(EndString,buf);
	}

	g_string_assign(NewPath,EndString);

	free(path);
	free(EndString);

	TRACEIT(10,"formatPathString		ends");
}


gboolean updateViewsFolder_Helper (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, struct AllInformationAllUseStruct *infostru){
	//WARNING, not only used from udateFolder, but also from within the fileshelf (interseption...)
	TRACEIT(11,"updateViewsFolder_Helper		start");
	gchar *Name=NULL;
	gchar *Path=NULL;
	struct updateList **itemlist= (struct updateList **)infostru->Info_1;

	int *columnToSearch=(int *)infostru->Info_2;
	int *columnToUseToo=(int *)infostru->Info_3;

	if (columnToUseToo){
		gtk_tree_model_get(model, iter, *columnToSearch, &Name, *columnToUseToo, &Path, -1);
	}
	else{
		gtk_tree_model_get(model, iter, *columnToSearch, &Name, -1);
	}
	updateList_addItem(itemlist, Name, Path, gtk_tree_row_reference_new(model, path), 0);

	if (Name)
		g_free(Name);
	if (Path)
		g_free(Path);
	TRACEIT(11,"updateViewsFolder_Helper		ends");
	return FALSE;
}

/*
gboolean RemoveInternalMarkedItems_Helper (GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, GList **rowref_list){
	TRACEIT(11,"RemoveInternalMarkedItems_Helper		start");
	g_assert ( rowref_list != NULL );
	int i_InternalUse=0;
	GtkTreeRowReference  *rowref;

	gtk_tree_model_get (model, iter, COL_INTERNAL, &i_InternalUse, -1);

	if (1 == i_InternalUse){
		rowref = gtk_tree_row_reference_new(model, path);
		*rowref_list = g_list_append(*rowref_list, rowref);
	}
	TRACEIT(11,"RemoveInternalMarkedItems_Helper		end");
	return FALSE; //go to the next item in list
}


void RemoveInternalMarkedItems (struct SideObjectList *ActiveObject){
	TRACEIT(10,"RemoveInternalMarkedItems		start");
//	struct SideObjectList *ActiveObject = (struct SideObjectList *)data;
	GList *rr_list = NULL;    // list of GtkTreeRowReferences to remove
	GList *node;
	GtkTreeIter  iter;
	GtkTreePath *path;

	gtk_tree_model_foreach(GTK_TREE_MODEL(ActiveObject->listStore),(GtkTreeModelForeachFunc) RemoveInternalMarkedItems_Helper,&rr_list);

	for ( node = rr_list;  node != NULL;  node = node->next ){
		path = gtk_tree_row_reference_get_path((GtkTreeRowReference*)node->data);

		if (path){
			if (gtk_tree_model_get_iter(GTK_TREE_MODEL(ActiveObject->listStore), &iter, path)){
				gtk_list_store_remove(ActiveObject->listStore, &iter);
			}
		// FIXME/CHECK: Do we need to free the path here?
		}
	}

	g_list_foreach(rr_list, (GFunc) gtk_tree_row_reference_free, NULL);
	g_list_free(rr_list);
	TRACEIT(10,"RemoveInternalMarkedItems		end");
}
*/


void updateViewWithNewFolder(struct SideObjectList *Object, GString *NewPath){
	//NewPath may be NULL
	TRACEIT(10,"updateViewWithNewFolder		start");
	if (Object == NULL){
		TRACEIT(2,"updateViewWithNewFolder		ends. ERROR, Object=NULL");
		return;
	}

	if (Object->iPreventFromUpdating == 1 && NewPath == NULL){
	    TRACEIT(10,"updateViewWithNewFolder		ends, No Update");
	    SideObjectList_UpdateObject(Object);
        return;
	}


    //SET UPDATEING FLAG
    if (Object->bUpdateFlag_CurrentlyUpdating==TRUE){
        TRACEIT(10,"updateViewWithNewFolder		ends, No Update 2");
        return;
    }
    Object->bUpdateFlag_CurrentlyUpdating=TRUE;


	struct updateList *updateItemlist=NULL;
	struct updateList *firstUpdateItemList=NULL;
    GtkTreeIter iter;
    GtkTreePath *path;
    int BrandNewStore=0;
    GString *OldName=NULL;
    GString *Ending=NULL;
    GString *Starting=NULL;

	struct AllInformationAllUseStruct infostru;
	int columnToSearch=COL_NAME;

	infostru.Info_1=(void *)&updateItemlist;
	infostru.Info_2=(void *)&columnToSearch;
	infostru.Info_3=NULL;
	infostru.Info_4=NULL;
	infostru.Info_5=NULL;

    Object->iRecursiveSizeCalculation=-1;
    //CursorToWait(win);
	TRACEIT(10,"updateViewWithNewFolder		check point 1");
	int leftORright = (Object->notebook == (GtkNotebook *)Notebooks[SIDE_LEFT])?SIDE_LEFT:SIDE_RIGHT;
	if (NewPath == NULL && Object->listStore != NULL){
        TRACEIT(10,"updateViewWithNewFolder		just update view");
        gtk_tree_model_foreach(GTK_TREE_MODEL(Object->listStore),(GtkTreeModelForeachFunc) updateViewsFolder_Helper,&infostru);
        //When we try to update the view, while the folder was not available the function foreach did not do anything
        firstUpdateItemList = updateItemlist;

        makeLists(Object, &updateItemlist);

        updateItemlist = firstUpdateItemList;
        TRACEIT(10,"updateViewWithNewFolder		check point 1.1");
        while (updateItemlist){
            if (updateItemlist->found == 0){
                path = gtk_tree_row_reference_get_path(updateItemlist->rowref);
                if (path){
                    if (gtk_tree_model_get_iter(GTK_TREE_MODEL(Object->listStore), &iter, path)){
                        //gtk_list_store_set (Object->listStore, &iter, COL_INTERNAL, 1,-1);    //what the **CK!! why setting a value, when all the information for deleting this row is already there?
                        gtk_list_store_remove(Object->listStore, &iter);
                    }
                }
            }
            updateItemlist = updateItemlist->NextItem;
        };
        TRACEIT(10,"updateViewWithNewFolder		check point 1.2");
        if (updateItemlist != NULL){
            updateList_deleteList(&firstUpdateItemList);
        }
        //RemoveInternalMarkedItems(Object);    //what the **CK!! why calling another function, when all the information for deleting this row is already there?
        updateStatusBar(Object);
        // SideObjectList_UpdateObject(Object);    //TODO: check if we need thi, This has come ot here because we change the tenotebooktab text as long as we do not change the mouse curosr
        SideObjectList_UpdateObject(Object);	//sets the tabs label
        checkDirectory(Object,NewPath);	//sets the status bar
	}
	else{
		TRACEIT(10,"updateViewWithNewFolder		new view");
	    if (NewPath != NULL){	//we expect a completly new path, no update
            g_object_set(PathEntryBox[leftORright],"text",NewPath->str,NULL);
            OldName = g_string_new(Object->gstrPath->str);
            g_string_assign(Object->gstrPath,NewPath->str);

            //printf("OldName=%s\nNewPath=%s\n",OldName->str,NewPath->str);

            //stop old monitor and start new one
            if (strcmp (OldName->str, NewPath->str) != 0){  //on creating Both are the same and we dont do anything
                autoUpdateList_RemoveMonitor(OldName->str);
                autoUpdateList_AddMonitor(NewPath->str);
            }
	    }
        if (NULL == Object->listStore){
            //firstly I thought we can use this on startup and create a new monitor, but this fails when copying, moving, dublicating a tab
            //in this cases NewPath is NULL but never the less we have to catch it.
            //such events are now catched where they should be, in the sideObjectList_* functions
            //autoUpdateList_AddMonitor(NewPath->str);
            BrandNewStore=1;
        }
        Object->guint64sizeOfSelectedItems=0;

        //start reading the directory and fill items in list
        makeLists(Object, NULL);
        if (BrandNewStore==1){  //then we have to connect the new list to the obejct
            connectListToView(Object);
        }
		TRACEIT(10,"updateViewWithNewFolder		check point 2.1");
        if (BrandNewStore != 1  && NewPath != NULL){  //its a new folder to load, but maybe we come from a lower one... lets look for this
            Ending = g_string_sized_new(10);
            Starting = g_string_sized_new(10);

            //g_string_assign(Ending, OldName->str);
            g_string_assign(Starting, OldName->str);
            checkPathForLastCharOtherwise(Starting);
            checkPathForLastCharOtherwise(NewPath);
            if (NULL != strstr (Starting->str, NewPath->str)){  //then we can mark and scroll to the folder we just came from
                while(strlen(NewPath->str) <= strlen(Starting->str)){
                    g_string_assign(Ending, Starting->str);

                    getLastStringInPath(Ending);
                    GetPathFromPathWithName(Starting, 1);
                    checkPathForLastCharOtherwise(Starting);

                    if (strcmp(NewPath->str, Starting->str)==0){
                        scrollListStoreToName((GtkTreeView *)Object->listView, Object->listStore, Ending, COL_NAME);
                        break;
                    }
                }
            }
            else {  //We do not come from a lower path, the scrollpoint is sewt to root position
                //we have to realkize the tree view before we can use scroll to point
                gtk_widget_realize(Object->listView);   //Beacuse the BrandnewStore cant be 1 in here, we are sure to realize an item already shown.
                gtk_tree_view_scroll_to_point ((GtkTreeView *)Object->listView, -1, 0);
            }
			TRACEIT(10,"updateViewWithNewFolder		check point 2.2");
            g_string_free(Ending, TRUE);
            g_string_free(Starting, TRUE);
        }
        if (OldName)
            g_string_free(OldName, TRUE);
		TRACEIT(10,"updateViewWithNewFolder		check point 3.1");
        SideObjectList_UpdateObject(Object); //sets the tabs label
        checkDirectory(Object,NewPath);	//sets the status bar
		TRACEIT(10,"updateViewWithNewFolder		check point 3.2");
	}

    //set Some updateflags:
    Object->bUpdateFlag_UpdateOnTabSwitch=FALSE;


    Object->bUpdateFlag_CurrentlyUpdating=FALSE;
    //CursorToNormal(win);
	TRACEIT(10,"updateViewWithNewFolder		ends");
}


void updateViewWithNewFolder_UserAdvice(struct SideObjectList *Object, GString *NewPath){

    Object->bUpdateFlag_UserWantsToUpdate=TRUE;
    while (Object->bUpdateFlag_CurrentlyUpdating){
        usleep(100000);
    }
    Object->bUpdateFlag_F6=FALSE;
    updateViewWithNewFolder(Object, NewPath);

    Object->bUpdateFlag_UserWantsToUpdate=FALSE;
}


void updateObjectsViewingFolder(char *Folder, gboolean automaticTriggered){
    //automaticTriggered:   TRUE: comming from a monitor event, FALSE: userevent
    TRACEIT(10,"updateObjectsViewingFolder		start");
    GString *gstrFolder=g_string_sized_new(10);
    GString *gstrObjectFolder=g_string_sized_new(10);

    if (Folder == NULL){
        TRACEIT(10,"updateObjectsViewingFolder		ends");
        g_string_free(gstrFolder, TRUE);
        g_string_free(gstrObjectFolder, TRUE);
        return;
    }

    struct SideObjectList *Objects = SideObjectList_getFirstObject();
    g_string_assign(gstrFolder, Folder);
    checkPathForLastCharOtherwise(gstrFolder);

    //Set bUpdateFlag_UserWantsToUpdate
    while (Objects){
        g_string_assign(gstrObjectFolder, Objects->gstrPath->str);
        checkPathForLastCharOtherwise(gstrObjectFolder);
        if ( 0==strcmp(gstrFolder->str, gstrObjectFolder->str)){
            //updateViewWithNewFolder(Objects, NULL);
            Objects->bUpdateFlag_UpdateOnTabSwitch=TRUE;
        }
        Objects = Objects->NextItem;
    };


    SideObjectList_GetActiveObject((GtkNotebook *)Notebooks[SIDE_LEFT], &Objects);
    g_string_assign(gstrObjectFolder, Objects->gstrPath->str);
    checkPathForLastCharOtherwise(gstrObjectFolder);
    if ( 0==strcmp(gstrFolder->str, gstrObjectFolder->str)){
        //updateViewWithNewFolder(Objects, NULL);
        if (automaticTriggered==TRUE && Objects->bUpdateFlag_UserWantsToUpdate==FALSE){  //prefent automatic update when user want an update, think of big directories changing often
            updateView(Objects);
        }
    }

    SideObjectList_GetActiveObject((GtkNotebook *)Notebooks[SIDE_RIGHT], &Objects);
    g_string_assign(gstrObjectFolder, Objects->gstrPath->str);
    checkPathForLastCharOtherwise(gstrObjectFolder);
    if ( 0==strcmp(gstrFolder->str, gstrObjectFolder->str)){
       // updateViewWithNewFolder(Objects, NULL);
       if (automaticTriggered==TRUE && Objects->bUpdateFlag_UserWantsToUpdate==FALSE){  //prefent automatic update when user want an update, think of big directories changing often
            updateView(Objects);
       }
    }


    g_string_free(gstrFolder, TRUE);
    g_string_free(gstrObjectFolder, TRUE);
    TRACEIT(10,"updateObjectsViewingFolder		ends");
}


void updateActiveViews(){
    struct SideObjectList *Objects = SideObjectList_getFirstObject();

	SideObjectList_GetActiveObject((GtkNotebook *)Notebooks[SIDE_LEFT], &Objects);
	updateView(Objects);

    SideObjectList_GetActiveObject((GtkNotebook *)Notebooks[SIDE_RIGHT], &Objects);
    updateView(Objects);
}


void updateView(struct SideObjectList *Object){
    //if (1==checkIfFolderNeedsUpdate(Object)){
        updateViewWithNewFolder(Object, NULL);
    //}
}

/*
The idea: I thought that the timestamp from a directory changed when a file within this directory changed. And therefore
we could check this before we update the whole list. But after I wrote this, I saw that this does not work like this.
This means this code is useless. F*SADIOSASASA'*'*SPDO
int checkIfFolderNeedsUpdate(struct SideObjectList *Object){
    //returnvalues: 1:update needed.    0:no update needed
    struct FileAttributs attribs;
    GtkTreeIter iter;
    int viewsTimeStamp=-2;
    int filesTimeStamp=-1;
    gchar *name=NULL;
    GString *gstrNames = g_string_sized_new(20);
    DIR *Directory;
    struct dirent *dirzeiger;
	int DirectoryOpened=0;

    GtkTreeModel *tree_model = gtk_tree_view_get_model ((GtkTreeView *)Object->listView);

    if (TRUE == gtk_tree_model_get_iter_first (tree_model, &iter)){
        do{
            gtk_tree_model_get(tree_model, &iter, COL_NAME, &name, -1);
            if (name){
                if (strcmp(name,".") == 0){
                    gtk_tree_model_get(tree_model, &iter, COL_TIMESTAMPCHANGED, &viewsTimeStamp, -1);
                    g_free(name);
                    break;
                }
                g_free(name);
            }
        }while(TRUE == gtk_tree_model_iter_next(tree_model, &iter) );
    }
    if (viewsTimeStamp == -2){
        g_string_free(gstrNames,TRUE);
        return 1;
    }

    openDirectory(&Directory, &DirectoryOpened, Object->gstrPath);
    if (DirectoryOpened != 0){
        do{
            getNextListItem(Directory, &dirzeiger, DirectoryOpened, gstrNames);
            if ( 0 == strstr(gstrNames->str, ".") ){
                if (0==fileAttributesGet(dirzeiger, DirectoryOpened, &attribs, Object->gstrPath->str, gstrNames->str)){
                    filesTimeStamp = attribs.utchanged;
                }
                break;
            }
        }while(strlen(gstrNames->str));
    }
    closeDirectory(&Directory);
	g_string_free(gstrNames,TRUE);

	if (filesTimeStamp > viewsTimeStamp)
        return 1;
    else
        return 0;

}
*/

void connectListToView(struct SideObjectList *Object){
	TRACEIT(10,"connectListToView		start");

	gtk_tree_view_set_model (GTK_TREE_VIEW(Object->listView), GTK_TREE_MODEL(Object->listStore));
	gtk_tree_view_column_clicked(Object->actualSortCol);

	TRACEIT(10,"connectListToView		ends");
}


int makeLists(struct SideObjectList *Object, struct updateList **itemlist){
	TRACEIT(10,"makeLists		start");
	GtkTreeIter iter;
    GtkTreeRowReference *rowref=NULL;
    int done=0;
    GtkTreePath *path;
	struct FileAttributs attribs;
	GString *gstrNames = g_string_sized_new(20);

 	DIR *Directory;
	struct dirent *dirzeiger;
	int DirectoryOpened=0;
	int BrandNewStore=0;

	if (itemlist == NULL ){
	    if (NULL == Object->listStore){
            Object->listStore = gtk_list_store_new(NUM_COLS,COLTYPES);
            BrandNewStore=1;
	    }
        else
             gtk_list_store_clear (Object->listStore);
	}
	openDirectory(&Directory, &DirectoryOpened, Object->gstrPath);
	getNextListItem(Directory, &dirzeiger, DirectoryOpened, gstrNames);
	while ( strlen(gstrNames->str) != 0/*gstrNames != NULL*/ ){
		fileAttributesGet(dirzeiger, DirectoryOpened, &attribs, Object->gstrPath->str, gstrNames->str);
		if (!(!Object->showHiddenFiles && attribs.hiddenfile) || Object->alwaysShowHiddenFiles){
            if (itemlist != NULL && *itemlist != NULL){
                rowref = updateList_checkForItem(itemlist, gstrNames->str);
                if (rowref){
                    path = gtk_tree_row_reference_get_path(rowref);
                    if (path){
                        if (gtk_tree_model_get_iter(GTK_TREE_MODEL(Object->listStore), &iter, path)){
                            done=1;
                        }
                    }
                }
            }
            if (done == 0){
                gtk_list_store_append(Object->listStore,&iter);
            }
			gtk_list_store_set (Object->listStore, &iter,
				COL_NAME, gstrNames->str,
				COL_FILETYPE, attribs.type,
				/*COL_SIZE, attribs.size,*/
				COL_OWNER, attribs.owner,
				COL_GROUP, attribs.group,
				COL_PERMISSION, attribs.permission,
				COL_ACCESSED, attribs.accessed,
				COL_CHANGED, attribs.changed,
				COL_TYPE_D, attribs.type_d,
				COL_TIMESTAMPACCESSED, attribs.utaccessed,
				COL_TIMESTAMPCHANGED, attribs.utchanged,
				COL_COLOR,(attribs.type_d==4)?g_gstrColorDirs->str:(attribs.type_d==10)?g_gstrColorLinks->str:g_gstrColorItems->str,
//				COL_INTERNAL, 0,
				-1);
            if (attribs.type_d!=4 || (attribs.type_d==4 && (Object->bUpdateFlag_F6==FALSE || done==0))){  //size of newly added items have to be set.
                gtk_list_store_set (Object->listStore, &iter,COL_SIZE, attribs.size, -1);
            }
            if (attribs.gstrLinkTarget){
                gtk_list_store_set (Object->listStore, &iter, COL_TARGET, attribs.gstrLinkTarget->str, COL_COLOR, g_gstrColorLinks->str,-1);
                g_string_free(attribs.gstrLinkTarget, TRUE);
            }
            done = 0;
		}
		getNextListItem(Directory, &dirzeiger, DirectoryOpened, gstrNames);
	}
	//Subern:
	closeDirectory(&Directory);
	g_string_free(gstrNames,TRUE);

    if (BrandNewStore==1){ //Connect SortFunctions
        gtk_tree_sortable_set_sort_func(GTK_TREE_SORTABLE(Object->listStore),COL_NAME,mysortfunctionforNamesLeft,Object->listStore,NULL);
        gtk_tree_sortable_set_sort_func(GTK_TREE_SORTABLE(Object->listStore),COL_FILETYPE,mysortfunctionforText,GINT_TO_POINTER(COL_FILETYPE),NULL);
        gtk_tree_sortable_set_sort_func(GTK_TREE_SORTABLE(Object->listStore),COL_PERMISSION,mysortfunctionforText,GINT_TO_POINTER(COL_PERMISSION),NULL);
        gtk_tree_sortable_set_sort_func(GTK_TREE_SORTABLE(Object->listStore),COL_ACCESSED,mysortfunctionforNumbers,GINT_TO_POINTER(COL_TIMESTAMPACCESSED),NULL);
        gtk_tree_sortable_set_sort_func(GTK_TREE_SORTABLE(Object->listStore),COL_CHANGED,mysortfunctionforNumbers,GINT_TO_POINTER(COL_TIMESTAMPCHANGED),NULL);
        gtk_tree_sortable_set_sort_func(GTK_TREE_SORTABLE(Object->listStore),COL_SIZE,mysortfunctionforBigNumbers,GINT_TO_POINTER(COL_SIZE),NULL);
        gtk_tree_sortable_set_sort_func(GTK_TREE_SORTABLE(Object->listStore),COL_OWNER,mysortfunctionforNumbers,GINT_TO_POINTER(COL_OWNER),NULL);
        gtk_tree_sortable_set_sort_func(GTK_TREE_SORTABLE(Object->listStore),COL_GROUP,mysortfunctionforNumbers,GINT_TO_POINTER(COL_GROUP),NULL);
    }

	TRACEIT(10,"makeLists		ends");
	//gtk_widget_queue_draw((GtkWidget *)win);
	return 0;
}


int predefine_Main_Objects(){
	TRACEIT(10,"predefine_Main_Objects		start");
//Defining EntrieyBoxes
	gdk_threads_enter();
	PathEntryBox[SIDE_LEFT] = gtk_entry_new();
	PathEntryBox[SIDE_RIGHT] = gtk_entry_new();
	gtk_entry_set_max_length(GTK_ENTRY(PathEntryBox[SIDE_LEFT]),MAXENTRYBOX);
	gtk_entry_set_max_length(GTK_ENTRY(PathEntryBox[SIDE_RIGHT]),MAXENTRYBOX);
	gtk_editable_set_editable(GTK_EDITABLE(PathEntryBox[SIDE_LEFT]),TRUE);
	gtk_editable_set_editable(GTK_EDITABLE(PathEntryBox[SIDE_RIGHT]),TRUE);

//Defining VBoxes
	VBox[SIDE_LEFT] = g_object_new(GTK_TYPE_VBOX, "spacing", 5, "homogeneous", FALSE, NULL);
	VBox[SIDE_RIGHT] = g_object_new(GTK_TYPE_VBOX, "spacing", 5, "homogeneous", FALSE, NULL);

//Defining SideObject Pane
	HPanedLeftRight = gtk_hpaned_new();

//Defining Pane for SideObject(Pane) and Fileshelf
	VPanedForFileShelf = gtk_vpaned_new();

//Defining HBoxes
	HBoxForButtonsAndPathEntry[SIDE_LEFT] = g_object_new(GTK_TYPE_HBOX, "spacing", 5, "homogeneous", FALSE, NULL);
	HBoxForButtonsAndPathEntry[SIDE_RIGHT] = g_object_new(GTK_TYPE_HBOX, "spacing", 5, "homogeneous", FALSE, NULL);

//Defining Buttons
	OnePathUpButton[SIDE_LEFT] = (GtkButton *)gtk_button_new_with_label("1up");
	OnePathUpButton[SIDE_RIGHT] = (GtkButton *)gtk_button_new_with_label("1up");

//Defining NoteBooks
	Notebooks[SIDE_LEFT]=g_object_new(GTK_TYPE_NOTEBOOK, "show-border",TRUE,"scrollable",TRUE,NULL);	//Different show-border properties, but no effect seen
	Notebooks[SIDE_RIGHT]=g_object_new(GTK_TYPE_NOTEBOOK, "show-border",FALSE,"scrollable",TRUE,NULL);
	gdk_threads_leave();
	TRACEIT(10,"predefine_Main_Objects		ends");
	return 0;
}


int predefine_NotebookTaps_Objects(struct SideObjectList *Object){
	TRACEIT(10,"predefine_NotebookTaps_Objects		start");

// Defining Lists
	GtkTreeViewColumn   *col;
	GtkCellRenderer     *renderer;
	GtkTreeSelection	*selection;
  	int i;

	Object->listView = gtk_tree_view_new();
	prepareWidgetForDragnDrop (Object->listView);
	gtk_tree_view_set_rules_hint ((GtkTreeView *)Object->listView, TRUE);

	selection  = gtk_tree_view_get_selection((GtkTreeView *)Object->listView);
	gtk_tree_selection_set_mode(selection, GTK_SELECTION_MULTIPLE);
	//gtk_tree_selection_set_mode(selection, GTK_SELECTION_SINGLE);

	g_signal_connect(selection, "changed", G_CALLBACK(oneSelectionChanged),Object);

	for (i=0; i<NUM_COLS ;i++){
		col=gtk_tree_view_column_new();

		//gtk_tree_view_column_set_alignment(col,1.0);	//only for text in header-buttons
		gtk_tree_view_column_set_resizable(col,TRUE);
		gtk_tree_view_column_set_sort_column_id(col,i);
		gtk_tree_view_column_set_reorderable(col,TRUE);
		gtk_tree_view_column_set_title(col, Names[i]);
		gtk_tree_view_append_column(GTK_TREE_VIEW(Object->listView),col);
		renderer = gtk_cell_renderer_text_new();
		gtk_tree_view_column_pack_start(col, renderer, TRUE);
		gtk_tree_view_column_add_attribute(col,renderer,"text",i);
		gtk_tree_view_column_add_attribute(col,renderer,"foreground",COL_COLOR);

		g_signal_connect (col, "clicked",G_CALLBACK(oneColumnWasClicked),Object);

		if (i==COL_NAME)
			Object->actualSortCol = col;
		if (i >= COL_TIMESTAMPACCESSED  )
			gtk_tree_view_column_set_visible(col,FALSE);
	}

//Defining scrollWindows
	Object->ScrollWindow = gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(Object->ScrollWindow),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);

//Defining VBoxes
	Object->VBox = g_object_new(GTK_TYPE_VBOX, "spacing", 5, "homogeneous", FALSE, NULL);

//Defining Statusbars
	Object->StatusBar = (GtkStatusbar *)gtk_statusbar_new();
	gtk_statusbar_set_has_resize_grip(Object->StatusBar, FALSE);

//Defiging Label
	Object->label = gtk_label_new(NULL);

	TRACEIT(10,"predefine_NotebookTaps_Objects		ends");
	return 0;
}


int connectSignalsToNotebookTapObject(struct SideObjectList *Object){
	TRACEIT(10,"connectSignalsToNotebookTapObject		start");
	g_signal_connect (Object->listView,"row-activated",G_CALLBACK(oneRowActivated_SideObjectWrap),Object);
	g_signal_connect (Object->listView,"key-press-event",G_CALLBACK(oneKeyPressedInView),Object);
	g_signal_connect (Object->listView,"button-press-event",G_CALLBACK(oneMouseButtonPressed),Object);
	g_signal_connect (Object->listView,"button-release-event",G_CALLBACK(oneMouseButtonPressed),Object);
	g_signal_connect (Object->listView,"popup-menu",G_CALLBACK(oneContextMenuReplied),Object);
	//g_signal_connect (Object->listView,"select-all",G_CALLBACK(mySelectAllFunction),Object);  //we tried to catch this signal and to handle this by our own. HTe problem was, we came up just before the gtk selects all and we could not prefent this (return value)
	TRACEIT(10,"connectSignalsToNotebookTapObject		ends");
	return 0;
}


int mysortfunctionshelperForCaseInsensitiveComparission(gchar *string1, gchar *string2, GtkSortType sortOrder){
    TRACEIT(12,"mysortfunctionshelperForCaseInsensitiveComparission		start");

    int ret=0;
    gchar *str1converted=NULL;
	gchar *str2converted=NULL;
	gchar *str1converted_=NULL;
	gchar *str2converted_=NULL;
	gsize read,write;
	//GString *ReportToUser=NULL;
	GError *err=NULL;

    if (sortOrder == 0)
        sortOrder = GTK_SORT_ASCENDING;

    if (strcmp(string1, ".") == 0){
        ret = (sortOrder == GTK_SORT_ASCENDING)?-1:1;
    }
    else if (strcmp(string2, ".") == 0){
        ret = (sortOrder == GTK_SORT_ASCENDING)?1:-1;
    }
    else if ( /*strcmp(string1, ".") != 0 && */strcmp(string2, "..") == 0){
        ret = (sortOrder == GTK_SORT_ASCENDING)?1:-1;
    }
    else if ( /*strcmp(string2, ".") != 0 && */strcmp(string1, "..") == 0){
        ret = (sortOrder == GTK_SORT_ASCENDING)?-1:1;
    }
    else{
        TRACEIT(12,"mysortfunctionshelperForCaseInsensitiveComparission		g_utf8_collate");

        str1converted = g_locale_to_utf8(string1,-1,&read,&write, &err);
        if (!str1converted && err){
            TRACEIT(6,"mysortfunctionshelperForCaseInsensitiveComparission: error in g_locale_to_utf8:");
            TRACEIT(6,err->message);
            TRACEIT(6,string1);
            g_error_free (err);
            err = NULL;
            str1converted = g_filename_to_utf8 (string1,-1,&read,&write,&err);
            TRACEIT(9,"g_filename_to_utf8 returns:");
            TRACEIT(9,str1converted);
            if (err){
                TRACEIT(6,"mysortfunctionshelperForCaseInsensitiveComparission: error in g_filename_to_utf8:");
                TRACEIT(6,err->message);
                TRACEIT(6,string1);
                g_error_free (err);
                err = NULL;

                //Report problem to user.
                //I don't know this exactly but I think if this error occoures there is also a Pango-Warning
                //everytime you hit (no pressbutton) the line with the mouse. And I think this error is because
                //the system layout can also not handle one or more characters in this name. So g_locale_to_utf8
                //is supposed to fail - isn't it?
                //ReportToUser = g_string_sized_new(20);
                //g_string_printf(ReportToUser, "displaying the name '%s' results into errors.",string1);
                //gtk_statusbar_pop(Object->StatusBar,0);
                //gtk_statusbar_push(Object->StatusBar,0,ReportToUser->str);
                //g_string_free(ReportToUser, TRUE);
            }
        }
        str2converted = g_locale_to_utf8(string2,-1,&read,&write, &err);
        if (!str2converted && err){
            TRACEIT(6,"mysortfunctionshelperForCaseInsensitiveComparission: error in g_locale_to_utf8:");
            TRACEIT(6,err->message);
            TRACEIT(6,string1);
            g_error_free (err);
            err = NULL;
            str2converted = g_filename_to_utf8 (string2,-1,&read,&write,&err);
                    if (err){
                TRACEIT(6,"mysortfunctionshelperForCaseInsensitiveComparission: error in g_filename_to_utf8:");
                TRACEIT(6,err->message);
                TRACEIT(6,string2);
                g_error_free (err);
                err = NULL;

                //Report problem to user
                //READ in the section above!
                //ReportToUser = g_string_sized_new(20);
                //g_string_printf(ReportToUser, "displaying the name '%s' results into errors.",string2);
                //gtk_statusbar_pop(Object->StatusBar,0);
                //gtk_statusbar_push(Object->StatusBar,0,ReportToUser->str);
                //g_string_free(ReportToUser, TRUE);
            }
        }
        if (str1converted != NULL && str2converted != NULL){
            str1converted_ = g_utf8_casefold (str1converted,strlen(str1converted));
            g_free(str1converted);
            str1converted = g_utf8_normalize (str1converted_,strlen(str1converted_),G_NORMALIZE_DEFAULT);
            g_free(str1converted_);
            str1converted_ = NULL;

            str2converted_ = g_utf8_casefold (str2converted,strlen(str2converted));
            g_free(str2converted);
            str2converted = g_utf8_normalize (str2converted_,strlen(str2converted_),G_NORMALIZE_DEFAULT);
            g_free(str2converted_);
            str2converted_ = NULL;

            ret = g_utf8_collate(str1converted, str2converted);

/*            if (strstr(str2converted, "sterben")!=NULL){
                char *test = g_filename_display_name (string2);
                printf("string2 = %s     str2converted = %s\n",string2, str2converted);
                printf("test=%s\n",test);

//                printf("single chars:\n");
                char *buf=str2converted;
                unsigned int in;
//                for (;*buf!='\0';buf++){
                    //in = *buf;
                    in = 0;
                    in = '';
//                    printf("char=%c val=%u\n",*buf,in);
 //               }

            }
*/
        }
        else{
            TRACEIT(6,"mysortfunctionshelperForCaseInsensitiveComparission		end, there still is a problem with one string");
            ret = (sortOrder == GTK_SORT_ASCENDING)?-1:1;
        }
        if (str1converted)
            g_free (str1converted);
        if (str2converted)
            g_free (str2converted);
    }

    TRACEIT(12,"mysortfunctionshelperForCaseInsensitiveComparission		end");
    return ret;
}


int mysortfunctionforNamesLeft(GtkTreeModel *model, GtkTreeIter *a, GtkTreeIter *b, gpointer userdata){
    //usrdata is supposed to be of kind listStore
	TRACEIT(12,"mysortfunctionforNamesLeft		start");
	int ret=0;
	gchar *string1=NULL;
	gchar *string2=NULL;
	int type_d_1, type_d_2;
	gint sortedColumnId;
	GtkSortType sortOrder;

	gtk_tree_model_get(model, a, COL_NAME, &string1, COL_TYPE_D, &type_d_1, -1);
	gtk_tree_model_get(model, b, COL_NAME, &string2, COL_TYPE_D, &type_d_2, -1);

	//struct SideObjectList *Object=(struct SideObjectList *)userdata;
	GtkListStore *listStore = (GtkListStore *)userdata;
	if (string1 == NULL || string2 == NULL){
		if (string1 == NULL && string2 == NULL){
			TRACEIT(12,"mysortfunctionforNamesLeft		ends ERRORSTRING");
			return ret;
		}
		ret = (string1 == NULL)?-1:1;
	}
	else{
		TRACEIT(12,"mysortfunctionforNamesLeft		strdown");
		gtk_tree_sortable_get_sort_column_id(GTK_TREE_SORTABLE(listStore),&sortedColumnId,&sortOrder);
		if (type_d_1 == 4 && type_d_2 != 4){
			if (sortOrder == GTK_SORT_ASCENDING)
				ret = -1;
			else
				ret = 1;
		}
		else if (type_d_1 != 4 && type_d_2 == 4){
			if (sortOrder == GTK_SORT_ASCENDING)
				ret = 1;
			else
				ret = -1;
		}
		else{
            ret = mysortfunctionshelperForCaseInsensitiveComparission(string1, string2, sortOrder);
		}
	}
	if (string1)
		g_free (string1);
	if (string2)
		g_free (string2);

	TRACEIT(12,"mysortfunctionforNamesLeft		ends");
	return ret;
}


int mysortfunctionforText(GtkTreeModel *model, GtkTreeIter *a, GtkTreeIter *b, gpointer userdata){
	TRACEIT(10,"mysortfunctionforText		start");
	int ret=0;
	gchar *string1=NULL;
	gchar *string2=NULL;

	gtk_tree_model_get(model, a, GPOINTER_TO_INT(userdata), &string1, -1);
	gtk_tree_model_get(model, b, GPOINTER_TO_INT(userdata), &string2, -1);

	if (string1 == NULL || string2 == NULL){
		if (string1 == NULL && string2 == NULL){
			TRACEIT(10,"mysortfunctionforText		ends");
			return ret;
		}
		ret = (string1 == NULL)?-1:1;
	}
	else{
	    ret = mysortfunctionshelperForCaseInsensitiveComparission(string1, string2, 0);
		//ret = g_utf8_collate(string1,string2);
	}
	g_free(string1);
	g_free(string2);
	TRACEIT(10,"mysortfunctionforText		ends");
	return ret;
}


int mysortfunctionforNumbers(GtkTreeModel *model, GtkTreeIter *a, GtkTreeIter *b, gpointer userdata){
	TRACEIT(10,"mysortfunctionforNumbers		start");
	int ret=0;
	int number1, number2;

	gtk_tree_model_get(model, a, GPOINTER_TO_INT(userdata), &number1, -1);
	gtk_tree_model_get(model, b, GPOINTER_TO_INT(userdata), &number2, -1);

	if(number1 > number2)
		ret=-1;
	else if(number2 > number1)
		ret=1;
	TRACEIT(10,"mysortfunctionforNumbers		ends");
	return ret;
}


int mysortfunctionforBigNumbers(GtkTreeModel *model, GtkTreeIter *a, GtkTreeIter *b, gpointer userdata){
	TRACEIT(10,"mysortfunctionforBigNumbers		start");
	int ret=0;
	guint64 number1, number2;

	gtk_tree_model_get(model, a, GPOINTER_TO_INT(userdata), &number1, -1);
	gtk_tree_model_get(model, b, GPOINTER_TO_INT(userdata), &number2, -1);

	if(number1 > number2)
		ret=-1;
	else if(number2 > number1)
		ret=1;
	TRACEIT(10,"mysortfunctionforBigNumbers		ends");
	return ret;
}


int checkDirectory(struct SideObjectList *Object, GString *NewPath){
	//sets the status bar if necessary
	TRACEIT(10,"checkDirectory		start");
	GString *buf = g_string_sized_new(20);
	GString *buf2 = g_string_sized_new(10);
	DIR *Directory;
	int DirectoryOpened=0;

	if (NewPath == NULL){
        g_string_assign(buf2, Object->gstrPath->str);
	}
	else{
        g_string_assign(buf2, NewPath->str);
	}

	if (openDirectory(&Directory, &DirectoryOpened, buf2) != 0){
		g_string_sprintf(buf,"unable to load directory: %s",buf2->str);
		gtk_statusbar_pop(Object->StatusBar,0);
		gtk_statusbar_push(Object->StatusBar,0,buf->str);
		TRACEIT(9,"checkDirectory		unable to load directory:");
		TRACEIT(9,buf2->str);
		g_string_free(buf,TRUE);
		g_string_free(buf2,TRUE);
		TRACEIT(10,"checkDirectory		ends -1");
		return -1;
	}
	closeDirectory(&Directory);

	g_string_free(buf,TRUE);
	g_string_free(buf2,TRUE);
	TRACEIT(10,"checkDirectory		ends");
	return 1;
}


struct SideObjectList *getOtherSideObject(struct SideObjectList *ThisSideObject){
	TRACEIT(12,"getOtherSideObject		start");
	struct SideObjectList *otherObject=NULL;
	int otherSide=((GtkNotebook *)Notebooks[SIDE_LEFT]==ThisSideObject->notebook)?SIDE_RIGHT:SIDE_LEFT;
	SideObjectList_GetActiveObject((GtkNotebook *)Notebooks[otherSide], &otherObject);
	TRACEIT(12,"getOtherSideObject		ends");
	return otherObject;
}



static void deleteSelectedRowsHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"deleteSelectedRowsHelper		start");
	gchar *Name=NULL;
	GString *WholeName=g_string_sized_new(300);
	struct SideObjectList *Object=(struct SideObjectList *)data;

	if (Object->data == NULL){
		g_string_free(WholeName,TRUE);
		TRACEIT(8,"deleteSelectedRowsHelper		end, data=NULL");
		return;
	}
	struct CopyReMoveList **FirstItem = (struct CopyReMoveList **)Object->data;

	if (gtk_tree_model_get_iter(model, iter, path)){
		gtk_tree_model_get(model, iter, COL_NAME, &Name, -1);
		if (!(strcmp(Name, "..")==0 || strcmp(Name,".")==0)){
			g_string_assign(WholeName,Name);
			cutSpacesFromGString(WholeName);
			if (strlen (WholeName->str) == 0){
				if (Name)
					g_free(Name);
				g_string_free(WholeName,TRUE);
				TRACEIT(10,"deleteSelectedRowsHelper		end 1");
				return;
			}
			g_string_assign(WholeName,Object->gstrPath->str);
			checkPathForLastChar(WholeName);
			g_string_append(WholeName,Name);
			CopyReMoveList_AddItem ( FirstItem, WholeName->str, NULL, Object, NULL, NULL);
		}
	}
	if (Name)
		g_free(Name);
	g_string_free(WholeName,TRUE);
	TRACEIT(10,"deleteSelectedRowsHelper		ends");
}


void mayDeleteSelectedRows(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"mayDeleteSelectedRows		start");
	GtkWidget *dialog, *label;
	GtkTreeSelection	*selection;
	struct SideObjectList *Object=(struct SideObjectList *)data;
	struct CopyReMoveList *FirstItem=NULL;
	Object->data = (void *)&FirstItem;
	dialog = CreateMyDialog("Are you absolutly sure?", win, 2, "Cancel",GTK_RESPONSE_REJECT,"Ok",GTK_RESPONSE_ACCEPT, FALSE);
	label = gtk_label_new("Do you realy want to delete\nthe selected Items?");
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label);
	gtk_widget_show_all(dialog);
	if (gtk_dialog_run(GTK_DIALOG(dialog))== GTK_RESPONSE_ACCEPT){
		selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(Object->listView));
		gtk_tree_selection_selected_foreach(selection, deleteSelectedRowsHelper, data);
		gtk_widget_destroy(dialog);
		if (FirstItem == NULL){
			TRACEIT(10,"mayDeleteSelectedRows		ends, FirstItem = NULL");
			return;
		}
		ProcessItemsViaListWrap(FirstItem, 3);
	}
	else{
		gtk_widget_destroy(dialog);
	}

	TRACEIT(10,"mayDeleteSelectedRows		ends");
}


static void copySelectedToAnOtherPannelRowsHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"copySelectedToAnOtherPannelRowsHelper		start");
	if (data == NULL){
        TRACEIT(2,"copySelectedToAnOtherPannelRowsHelper		end, parameter NULL");
        return;
	}
	struct AllInformationAllUseStruct *stru = (struct AllInformationAllUseStruct *)data;

	struct SideObjectList *Object = (struct SideObjectList *)stru->Info_1;
	struct SideObjectList *otherObject = (struct SideObjectList *)stru->Info_2;

	if (Object == NULL){
		TRACEIT(2,"copySelectedToAnOtherPannelRowsHelper		ends, NO OBJECT (NULL)");
		return;
	}
	if (otherObject == NULL){   //this function is used for the copy-paste thing too. And therefore the otherObject can be NLL
        otherObject=getOtherSideObject(Object); //but we need an otherObject.
	}
	if (otherObject == NULL){
		TRACEIT(2,"copySelectedToAnOtherPannelRowsHelper		ends, NO OTHEROBJECT (NULL)");
		return;
	}

	gchar *Name = NULL;
	GString *source = g_string_sized_new(100);
	GString *dest = g_string_new(otherObject->gstrPath->str);

	if (Object->data == NULL){
		g_string_free(source,TRUE);
		g_string_free(dest,TRUE);
		TRACEIT(2,"copySelectedToAnOtherPannelRowsHelper		ends, data NULL ItemList for copy...");
		return;
	}
	struct CopyReMoveList **FirstItem = (struct CopyReMoveList **)Object->data;

	//if (gtk_tree_model_get_iter(model, iter, path)){
        gtk_tree_model_get(model, iter, COL_NAME, &Name, -1);
		g_string_assign(source,Object->gstrPath->str);
		checkPathForLastChar(source);
		if (!(strcmp(Name, "..")==0 || strcmp(Name,".")==0)){
			g_string_append(source,Name);
			checkPathForLastCharOtherwise(source);
			checkPathForLastCharOtherwise(dest);
			if (!g_string_equal(source,dest)){  //this is a simple one and not a complete check, to prevent copying a underlying directory to one inherrited by that one
				CopyReMoveList_AddItem ( FirstItem, source->str, dest->str, Object, otherObject, NULL);
			}
		}
	//}

	if (Name)
		g_free(Name);
	g_string_free(source,TRUE);
	g_string_free(dest,TRUE);
	TRACEIT(10,"copySelectedToAnOtherPannelRowsHelper		ends");
}

void copyReMoveToAnOtherObject_ListCreate(struct SideObjectList *sourceObject, struct SideObjectList *destObject){
    //creates the list CopyReMoveList at sourceObject->Data to use with ProcessItemsViaListWrap
    TRACEIT(10,"copyReMoveToAnOtherObject_ListCreate		start");
    if (sourceObject == NULL || destObject == NULL){
        TRACEIT(2,"copyReMoveToAnOtherObject_ListCreate		ends, parameter NULL");
		return;
	}
    GtkTreeSelection	*selection;
    struct AllInformationAllUseStruct stru;
    stru.Info_1 = (void *)sourceObject;
    stru.Info_2 = (void *)destObject;

	struct CopyReMoveList *FirstItem=NULL;
    sourceObject->data = (void *)&FirstItem;

	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(sourceObject->listView));

	gtk_tree_selection_selected_foreach(selection, copySelectedToAnOtherPannelRowsHelper, (void *)&stru);

    sourceObject->data = (void *)FirstItem; //FirstItem becomes invalid after this function quits, but its value must be saved, its the list
                                            //even it is NULL, its allmost better than pointing to a varibale which does not exist
	if (FirstItem == NULL){
		TRACEIT(2,"copyReMoveToAnOtherObject_ListCreate		ends, no list created");
		return;
	}

    TRACEIT(10,"copyReMoveToAnOtherObject_ListCreate		ends");
}

void copyToAnOtherPannel(struct SideObjectList *sourceObject, struct SideObjectList *destObject){
    if (sourceObject == NULL || destObject == NULL){
        TRACEIT(2,"copyToAnOtherPannel		ends, parameter NULL");
		return;
	}
	copyReMoveToAnOtherObject_ListCreate (sourceObject, destObject);

    if (sourceObject->data == NULL){
		TRACEIT(10,"copyToAnOtherPannel		ends, -1");
		return;
	}
    ProcessItemsViaListWrap((struct CopyReMoveList *)sourceObject->data, 1);
    TRACEIT(10,"copyToAnOtherPannel		ends");
}


void copyToOtherPannel(GtkWidget *menuitem, gpointer data){
    //gets an sideObject as data, searches the Object on the other side and continues with copyReMoveToAnOtherObject_ListCreate
	TRACEIT(10,"copyToOtherPannel		start");
	if (data == NULL){
        TRACEIT(2,"copyToOtherPannel		ends, parameter NULL");
		return;
	}
	struct SideObjectList *Object=(struct SideObjectList *)data;

    struct SideObjectList *otherObject=getOtherSideObject(Object);
	if (otherObject == NULL){
		TRACEIT(2,"copyToOtherPannel		ends, No other Objectfound");
		return;
	}

    copyToAnOtherPannel (Object, otherObject);

	TRACEIT(10,"copyToOtherPannel		ends");
}


void moveToOtherPannel(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"moveToOtherPannel		start");
	struct SideObjectList *Object=(struct SideObjectList *)data;
	//GtkTreeSelection	*selection;

    struct SideObjectList *otherObject=getOtherSideObject(Object);
	if (otherObject == NULL){
		TRACEIT(2,"copyToOtherPannel		ends, No other Objectfound");
		return;
	}
    copyReMoveToAnOtherObject_ListCreate (Object, otherObject);
	//struct CopyReMoveList *FirstItem=NULL;
	//Object->data = (void *)&FirstItem;

	//selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(Object->listView));

	//gtk_tree_selection_selected_foreach(selection, copySelectedToOtherPannelRowsHelper, data);

	if (Object->data == NULL){
		TRACEIT(10,"moveToOtherPannel		ends, -1");
		return;
	}
	ProcessItemsViaListWrap((struct CopyReMoveList *)Object->data, 2);

	TRACEIT(10,"moveToOtherPannel		ends");
}


void CopyPasteCreateList_SideObject(struct SideObjectList *Object, int CopyOrMove){
    TRACEIT(10,"CopyPasteCreateList_SideObject		start");
    if (Object == NULL){
        TRACEIT(10,"CopyPasteCreateList_SideObject		ends");
		return;
    }
    GtkTreeSelection	*selection;

    if (g_CopyPasteShortcutStruct != NULL){
        CopyReMoveList_DeleteList(g_CopyPasteShortcutStruct);
        g_CopyPasteShortcutStruct = NULL;
    }
    Object->data = (void *)&g_CopyPasteShortcutStruct;

    struct AllInformationAllUseStruct stru;
    stru.Info_1 = (void *)Object;
    stru.Info_2 = NULL;

    selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(Object->listView));

	gtk_tree_selection_selected_foreach(selection, copySelectedToAnOtherPannelRowsHelper, (void *)&stru);

	if (g_CopyPasteShortcutStruct != NULL){
        g_CopyPasteShortcutStruct->CopyMoveOrRemove = CopyOrMove;
	}

    TRACEIT(10,"CopyPasteCreateList_SideObject		ends");
}


void CopyPasteProcessList_SideObject(struct SideObjectList *Object){
    TRACEIT(10,"CopyPasteProcessList_SideObject		start");
    struct CopyReMoveList *buflist=NULL;

    if (g_CopyPasteShortcutStruct == NULL || Object == NULL){
        TRACEIT(10,"CopyPasteProcessList_SideObject		ends");
        return;
    }
    buflist = g_CopyPasteShortcutStruct;
    while (buflist){
        buflist->DestObject = Object;
        if (buflist->string2){
            g_string_assign(buflist->string2, Object->gstrPath->str);
        }
        else{
            buflist->string2 = g_string_new(Object->gstrPath->str);
        }
        buflist = buflist->NextItem;
    }
    //The copyPasteShortcutStruct will be freed every time a new one is created and on shutdown
    //The list given to ProcessItemsViaListWrap is deleted after completion, therefore the copy
    CopyReMoveList_CopyList (&buflist, g_CopyPasteShortcutStruct);
    ProcessItemsViaListWrap(buflist, g_CopyPasteShortcutStruct->CopyMoveOrRemove);
    if (g_CopyPasteShortcutStruct->CopyMoveOrRemove == 2){    //2 = move
        CopyReMoveList_DeleteList(g_CopyPasteShortcutStruct);
        g_CopyPasteShortcutStruct = NULL;
    }
//    updateObjectsViewingFolder(Object->gstrPath->str);

    TRACEIT(10,"CopyPasteProcessList_SideObject		ends");
}


static void openInNewPannelHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"openInNewPannelHelper		start");
	struct SideObjectList *Object=(struct SideObjectList *)data;

	struct SideObjectList *otherObject=getOtherSideObject(Object);

	if (otherObject == NULL){
		TRACEIT(10,"openInNewPannelHelper		ends");
		return;
	}

	gchar *Name = NULL;
	int type_d=0;
	GString *NewPath = g_string_sized_new(100);

	if (gtk_tree_model_get_iter(model, iter, path)){
		gtk_tree_model_get(model, iter, COL_NAME, &Name,COL_TYPE_D, &type_d, -1);
		g_string_assign(NewPath,Object->gstrPath->str);
		checkPathForLastChar(NewPath);
		if (!(strcmp(Name, "..")==0 || strcmp(Name,".")==0) && type_d == 4){
			g_string_append(NewPath,Name);
			SideObjectList_CreateNewViewWithPath(otherObject->notebook, NewPath->str,Object);
		}
	}

	if (Name)
		g_free(Name);
	g_string_free(NewPath,TRUE);
	TRACEIT(10,"openInNewPannelHelper		ends");
}


void openInNewPannel(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"openInNewPannel		start");
	struct SideObjectList *Object=(struct SideObjectList *)data;
	GtkTreeSelection	*selection;

	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(Object->listView));

	gtk_tree_selection_selected_foreach(selection, openInNewPannelHelper, data);

	TRACEIT(10,"openInNewPannel		ends");
}


void updatePannels(GtkWidget *menuitem, gpointer data){	//Updates just one Pannel now
	TRACEIT(10,"updatePannels		start");
	//updateViewWithNewFolder((struct SideObjectList *)data,NULL);
	updateViewWithNewFolder_UserAdvice((struct SideObjectList *)data, NULL);
	TRACEIT(10,"updatePannels		ends");
}


void sizeOfSelectedItemsRecursive (GtkWidget *menuitem, gpointer data){	//Get size if selected Items, directories are searched recursivly
	TRACEIT(10,"sizeOfSelectedItemsRecursive		start");

	struct SideObjectList *Object=(struct SideObjectList *)data;
	GtkTreeSelection	*selection;

	if( !g_thread_supported() ){
		g_thread_init(NULL);
     		//gdk_threads_init();                   // Called to initialize internal mutex "gdk_threads_mutex".
	}
	struct RecursiveSizeStructure *stru=malloc(sizeof(struct RecursiveSizeStructure));
	stru->mainWin = win;

	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(Object->listView));

	//Get all selected items
	stru->gstrPath=g_string_new(Object->gstrPath->str);
	stru->gstrDPItems=NULL;
	stru->intPSizes = NULL;
	stru->intPTypes = NULL;
	stru->ItemStringCounter=0;
	stru->ItemCounter=0;
	stru->SideObjectOrFileshelfItem=SOURCE_SIDEOBJECT; //SideObject Identifier
	gtk_tree_selection_selected_foreach(selection, getSizeOfSelectedItemsRecursive_getItems,(void *) stru);

	g_thread_create((GThreadFunc)getSizeOfSelectedItemsRecursive_dialog, (void *)stru , FALSE, NULL);
	TRACEIT(10,"sizeOfSelectedItemsRecursive		end");
}


static void getSizeOfSelectedItemsRecursive_getItems (GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"getSizeOfSelectedItemsRecursive_getItems		start");

	struct RecursiveSizeStructure *stru = (struct RecursiveSizeStructure *)data;
	gchar *name=NULL;
	gint type_d;
	GString *gstrBuf = g_string_sized_new(20);
	int ret=0;
	guint64 isize;

	if (gtk_tree_model_get_iter(model, iter, path)){
		gtk_tree_model_get(model, iter, COL_SIZE, &isize, COL_NAME, &name, COL_TYPE_D, &type_d, -1);
		if (name != NULL && strcmp(name,".")!=0 && strcmp(name,"..")!=0){
			g_string_assign(gstrBuf,name);
			ret =  AddNewGStringToDPointer(&(stru->gstrDPItems),stru->ItemCounter, gstrBuf);
			if (ret == 0){
				stru->ItemStringCounter++;
				ret += AddNewGUInt64ToPointerArray(&(stru->intPSizes), stru->ItemCounter, isize);
			}
			if (ret == 0){
				ret += AddNewGUInt64ToPointerArray(&(stru->intPTypes), stru->ItemCounter, (guint64)type_d);
			}
			if (ret == 0){
				stru->ItemCounter++;
			}
		}
	}
	g_string_free(gstrBuf,TRUE);
	if (name)
		g_free(name);

	TRACEIT(10,"getSizeOfSelectedItemsRecursive_getItems		end");
}


void mayNewDirectory(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"mayNewDirectory		start");
	GString *buf = g_string_sized_new(10);
    GString *NewDir = g_string_new("New Directory");
	struct SideObjectList *Object=(struct SideObjectList *)data;


    while ( 0 == MyEasyInputWidget (win, "create directory", "name of the directory to create", NewDir)){

		cutSpacesFromGString(buf);
		if (strcmp(NewDir->str,".")==0 || strcmp(NewDir->str,"..")==0 || strlen(NewDir->str)==0 || strstr(NewDir->str,"/..")!=NULL  ){
		    MyMessageWidget(win, "not possible", "Iam not allowed to create this Directory.\nThis means me, the programm, not the user.");
		}
		else{
			g_string_assign(buf,Object->gstrPath->str);
			checkPathForLastChar(buf);
			g_string_append(buf,NewDir->str);
			makeDirectory(buf->str,1,NULL);
			//updateView(Object);
			break;
		}
	}

	g_string_free(buf,TRUE);
	g_string_free(NewDir,TRUE);
	TRACEIT(10,"mayNewDirectory		ends");
}


//void renameItemsHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
void renameItemsHelper(GtkTreeSelection	*selection, struct AllInformationAllUseStruct *info){
	TRACEIT(10,"renameItemsHelper		start");
	//struct AllInformationAllUseStruct *info = (struct AllInformationAllUseStruct *)data;
	if (selection==NULL || info==NULL){
		TRACEIT(2,"renameItemsHelper		end, PARAMETER NULL");
		return;
	}
    GtkTreeModel *model;
    GList *selList = gtk_tree_selection_get_selected_rows (selection,&model);// = NULL; //
	if (selList == NULL){
		TRACEIT(4,"renameItemsHelper		end, nothing selected?");
		return;
	}
	GList *buflist=selList;
	struct SideObjectList *Object=NULL;
    GtkTreeIter iter;
	int ibreakall=0;
	int ret=0;
	gchar *Name = NULL;
	gchar *Path = NULL;
	int sort_column_id;
    GtkSortType order;
    GtkListStore *listStore = NULL;

	GString *source = g_string_sized_new(20);
	GString *dest = g_string_sized_new(20);
	GString *buf = g_string_sized_new(20);
	GString *NewName = g_string_sized_new(20);

	if (info->source == SOURCE_SIDEOBJECT){
		Object= (struct SideObjectList *)info->Info_1;
        listStore=Object->listStore;
        Object->iPreventFromUpdating = 1;
	}
	else{
        listStore = (GtkListStore *)info->Info_1;
	}
    //selList = gtk_tree_selection_get_selected_rows (selection,&model);
    //Whenever working with Pathlists avoid reordering or updating the treeview.
    gtk_tree_sortable_get_sort_column_id (GTK_TREE_SORTABLE(listStore), &sort_column_id, &order);
    gtk_tree_sortable_set_sort_column_id (GTK_TREE_SORTABLE(listStore),GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID, order);

    while(buflist){
        if (ibreakall==1){
            break;
        }
        if (TRUE != gtk_tree_model_get_iter (model, &iter, (GtkTreePath *)buflist->data)){
            break;
        }

        if (info->source == SOURCE_SIDEOBJECT){
            gtk_tree_model_get(model, &iter, COL_NAME, &Name, -1);
        }
        else{
            gtk_tree_model_get(model, &iter, COL_FLSHLF_PATH, &Path, COL_FLSHLF_NAME, &Name, -1);
        }
        if ((strcmp(Name, "..")==0 || strcmp(Name,".")==0)){
            if (Name){
                g_free(Name);
                Name = NULL;
            }
            if (Path){
                g_free(Path);
                Path=NULL;
            }

            buflist=buflist->next;
            continue;
        }
        if (info->source == SOURCE_SIDEOBJECT){
            g_string_assign(source,Object->gstrPath->str);
            g_string_assign(dest,Object->gstrPath->str);
        }
        else{
            g_string_assign(source,Path);
            g_string_assign(dest,Path);
        }
        checkPathForLastChar(source);
        checkPathForLastChar(dest);
        g_string_append(source,Name);

		g_string_assign(NewName,Name);
		while (1){  //Rename one item - loop
			ret = MyEasyInputWidget_Two (win, "rename", Name, NewName, NULL, NULL, "Ok", "Cancel all", "cancel", NULL);
			if (1 == ret){	//Cancel all
                ibreakall=1;
                break;
            }
            else if (ret != 0){
                //printf("break inner while, ret=%d\n",ret);
                break;	//user pressed cancel
            }

			g_string_assign(buf, NewName->str);
			cutSpacesFromGString(buf);

			if (strcmp(buf->str,".")==0 || strcmp(buf->str,"..")==0 || strlen(buf->str)==0 || strstr(buf->str,"/..")!=NULL  ){
				MyMessageWidget(win, "not possible", "Iam not allowed to rename to this!\nThis means me, the programm, not the user.");
				continue;
			}

            g_string_assign(buf, dest->str);
            checkPathForLastChar(buf);
			g_string_append(buf,NewName->str);

            //g_printf("source: %s\ndest: %s\n",source->str, dest->str);
			if (strcmp(source->str,buf->str)==0){  //makes no sence to rename
			    //printf("source and destination are equal\n");
                continue;
			}

            if (TRUE == g_file_test(buf->str,G_FILE_TEST_EXISTS)){ //ask for permission to overwrite
                if (0 != MyEasyInputWidget_Two ((GtkWindow *)win, "overwrite", "There is allready an item with the\nsame name in the destination directory.\nDo you want t ooverwrite it?\n", NULL, NULL, NULL, "Overwrite", "Cancel", NULL, NULL)){
                    continue;
                }
            }

            //if (0 == g_rename(source->str,dest->str)){
            if (0 == moveItems(source->str,buf->str)){
                if (TRUE == g_file_test(dest->str,G_FILE_TEST_EXISTS)){
                    if (info->source == SOURCE_FILESHELF){	//change name on the fileshelf, or the old filename will be marked as missing
                        gtk_list_store_set (listStore, &iter, COL_FLSHLF_NAME, NewName->str, -1);
                        //updateObjectsViewingFolder(Path);
                    }
                    else{   //change the name in the listview manually
                        gtk_list_store_set (listStore, &iter, COL_NAME, NewName->str, -1);
                        //updateObjectsViewingFolder(Object->gstrPath->str);    //do not make an update when using pathlists and editing items!
                    }
                }
                break;	//file was renamed, next marked item to come.
            }
            //else{
            //    g_string_printf(buf, "Renaming item %s returned error:\n%s",Name, strerror(errno));
            //    MyMessageWidget(win, "Error renaming", buf->str);
            //}
		}//while (1)
		if (Name){
            g_free(Name);
            Name = NULL;
        }
        if (Path){
            g_free(Path);
            Path=NULL;
        }
		buflist=buflist->next;
	}//while (buflist)

	gtk_tree_sortable_set_sort_column_id (GTK_TREE_SORTABLE(listStore),sort_column_id, order);

    if (info->source == SOURCE_SIDEOBJECT){
        Object->iPreventFromUpdating = 0;
	}

	if (Name){
        g_free(Name);
        Name = NULL;
    }
    if (Path){
        g_free(Path);
        Path=NULL;
    }
	g_string_free(source,TRUE);
	g_string_free(dest,TRUE);
	g_string_free(buf,TRUE);
	g_string_free(NewName,TRUE);

	if (selList){
		g_list_foreach (selList,(GFunc) gtk_tree_path_free, NULL);
		g_list_free (selList);
	}

	TRACEIT(10,"renameItemsHelper		ends");
}


void renameItems(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"renameItems		start");
	struct SideObjectList *Object=(struct SideObjectList *)data;
	GtkTreeSelection	*selection;
	struct AllInformationAllUseStruct info;

	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(Object->listView));
	info.source = SOURCE_SIDEOBJECT;
	info.Info_1 = (void *)data;
	info.Info_2 = NULL;
	info.Info_3 = NULL;
	//gtk_tree_selection_selected_foreach(selection, renameItemsHelper, (void *)&info);
	renameItemsHelper(selection, &info);
	//updateView(Object);
	TRACEIT(10,"renameItems		ends");
}


void MenuAddItemToFileshelfHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"MenuAddItemToFileshelfHelper		start");
	struct SideObjectList *Object=(struct SideObjectList *)data;
	gchar *Name = NULL;

	if (gtk_tree_model_get_iter(model, iter, path)){
		gtk_tree_model_get(model, iter, COL_NAME, &Name, -1);
		if ((strcmp(Name, "..")==0 || strcmp(Name,".")==0)){
			g_free(Name);

			TRACEIT(10,"MenuAddItemToFileshelfHelper		ends");
			return;
		}
		AddItemToFileshelf(NULL, Name, Object->gstrPath->str, FALSE);

		if (Name)
			g_free(Name);

	}
	TRACEIT(10,"MenuAddItemToFileshelfHelper		ends");
}


void MenuAddItemToFileshelf(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"MenuAddItemToFileshelf		start");
	struct SideObjectList *Object=(struct SideObjectList *)data;
	GtkTreeSelection	*selection;

	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(Object->listView));

	gtk_tree_selection_selected_foreach(selection, MenuAddItemToFileshelfHelper, data);

	TRACEIT(10,"MenuAddItemToFileshelf		ends");
}


void MenuAddToNewFileshelf(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"MenuAddToNewFileshelf		start");
	if (0==NewFileShelf(NULL)){
        MenuAddItemToFileshelf(menuitem, data);
	}
	TRACEIT(10,"MenuAddToNewFileshelf		ends");
}

void MenuAddNewFileshelf(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"MenuAddNewFileshelf		start");
	NewFileShelf(NULL);
	TRACEIT(10,"MenuAddNewFileshelf		ends");
}


void searchStringInAndHighlightItemsHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"searchStringInAndHighlightItemsHelper		starat");
	struct AllInformationAllUseStruct *info=(struct AllInformationAllUseStruct *)data;
	struct SearchItemStruct *theStruct = (struct SearchItemStruct *)info->Info_2;
	gchar *Name=NULL;

	if (gtk_tree_model_get_iter(model, iter, path)){
		if (info->source == SOURCE_SIDEOBJECT){
			gtk_tree_model_get(model, iter, COL_NAME, &Name, -1);
		}
		else{
			gtk_tree_model_get(model, iter, COL_FLSHLF_NAME, &Name, -1);
		}
		if ((strcmp(Name, "..")==0 || strcmp(Name,".")==0)){
			gtk_tree_selection_unselect_iter(theStruct->selection, iter);
			if (Name)
				g_free(Name);
			TRACEIT(10,"searchStringInAndHighlightItemsHelper		ends");
			return;
		}
		if (strcasestr(Name,theStruct->gstrSearchString->str) == NULL){	//strcasestr returns charpointer
			gtk_tree_selection_unselect_iter(theStruct->selection, iter);
		}
	}
	if (Name)
		g_free(Name);
	TRACEIT(10,"searchStringInAndHighlightItemsHelper		ends");
	return;
}


void searchStringInAndHighlightItems(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"searchStringInAndHighlightItems		start");
	struct AllInformationAllUseStruct *info=(struct AllInformationAllUseStruct *)data;
	struct SearchItemStruct theStruct;
	GtkTreeSelection	*selection;
	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(info->Info_1));
	GString *SearchString = g_string_sized_new(10);
	GString *buf = g_string_sized_new(10);
	theStruct.gstrSearchString = g_string_sized_new(100);

    while (0 == MyEasyInputWidget (win, "search", "\nSearches all selected Items for the string you enter.\n", SearchString)){
		g_string_assign(buf, SearchString->str);

		cutSpacesFromGString(buf);
		if (strlen(buf->str)==0 || /*strcmp(buf->str,".")==0 || strcmp(buf->str,"..")==0 || */ strstr(buf->str,"/..")!=NULL  ){
		    MyMessageWidget(win, "not possible", "Makes not much sense to search for this! Haeah!?");
		}
		else{
			theStruct.selection = selection;
			g_string_assign(theStruct.gstrSearchString, SearchString->str);
			info->Info_2=(void *)&theStruct;
			gtk_tree_selection_selected_foreach(selection, searchStringInAndHighlightItemsHelper, (void *)info);
			break;
		}
	}

	g_string_free(theStruct.gstrSearchString,TRUE);
	g_string_free(SearchString,TRUE);
	g_string_free(buf,TRUE);

	TRACEIT(10,"searchStringInAndHighlightItems		ends");
}


void searchStringInAndHighlightItems_WraperforSideObject(GtkWidget *menuitem, gpointer data){
    TRACEIT(10,"searchStringInAndHighlightItems_WraperforSideObject		start");
	struct AllInformationAllUseStruct info;
	info.source = SOURCE_SIDEOBJECT;
	info.Info_1 = (void *)data;
	searchStringInAndHighlightItems(menuitem, (void *)&info);
	TRACEIT(10,"searchStringInAndHighlightItems_WraperforSideObject		start");
}


void searchStringInDirectoryRecursive_SideObject(GtkWidget *menuitem, struct SideObjectList *Object){
	TRACEIT(10,"searchStringInDirectoryRecursive_SideObject		start");
	find_simple(Object->gstrPath->str);
	TRACEIT(10,"searchStringInDirectoryRecursive_SideObject		start");
}


void callAllWithHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"callAllWithHelper		start");
	struct AllInformationAllUseStruct *info= (struct AllInformationAllUseStruct *)data;
	GString *FileList = (GString *)info->Info_2;
	GString *FileListWithPath = (GString *)info->Info_5;
	gchar *Name=NULL;
	gchar *Path=NULL;
	struct UserDataList *TheStruct = info->Info_1;

	GString *gstrPath = g_string_sized_new(10);
	GString *gstrInfo_4GString = (GString *)info->Info_4; //just holds the pointer to this GString, which holds the source-path for callItemsToSystemsWrap

	if (gtk_tree_model_get_iter(model, iter, path)){
		if (info->source == SOURCE_SIDEOBJECT){
			gtk_tree_model_get(model, iter, COL_NAME, &Name, -1);
		}
		else{
			gtk_tree_model_get(model, iter, COL_FLSHLF_PATH, &Path, COL_FLSHLF_NAME, &Name, -1);
		}
		if ((strcmp(Name, "..")==0 || strcmp(Name,".")==0)){
			if (Name)
				g_free(Name);
			if (Path)
				g_free(Path);
			g_string_free(gstrPath,TRUE);
			TRACEIT(10,"callAllWithHelper		ends");
			return;
		}
		if (strlen(FileList->str) > 0){
			g_string_append(FileList," ");	//if we erase the '"' in the future tfor he new usercommand-thing then the last name has a space at the end which is not correct
			g_string_append(FileListWithPath," ");
		}
		if (info->source == SOURCE_SIDEOBJECT){
			g_string_append(FileList,"\"");
			g_string_append(FileList,Name);
			g_string_append(FileList,"\"");

			g_string_append(FileListWithPath,"\"");
			g_string_append(FileListWithPath, TheStruct->Object->gstrPath->str);
			checkPathForLastChar(FileListWithPath);
			g_string_append(FileListWithPath,Name);
			g_string_append(FileListWithPath,"\"");
		}
		else{
			g_string_assign(gstrPath,Path);
			checkPathForLastChar(gstrPath);
			g_string_append(FileList,"\"");
			g_string_append(FileList,gstrPath->str);
			g_string_append(FileList,Name);
			g_string_append(FileList,"\"");

            //Das brauchen wir hier doch gar nicht
			//g_string_assign(FileListWithPath,FileList->str); // TODO : jedesmal ein assign, das geht doch nicht!
			if (strlen(gstrInfo_4GString->str) == 0){	//We want this being done just once!!
				checkPathForLastCharOtherwise(gstrPath);
				g_string_assign(gstrInfo_4GString,gstrPath->str);
			}
		}
	}
	if (Name)
		g_free(Name);
	if (Path)
		g_free(Path);
	g_string_free(gstrPath,TRUE);
	TRACEIT(10,"callAllWithHelper		ends");
	return;
}


void callAllWith (GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"callAllWith		start");
	struct AllInformationAllUseStruct *info= (struct AllInformationAllUseStruct *)data;
	struct SideObjectList *Object=NULL;
	if (info->source == SOURCE_SIDEOBJECT){
		Object=(struct SideObjectList *)info->Info_1;
	}
	GtkTreeSelection	*selection;
	GString *ItemList=g_string_sized_new(10);
	GString *buf = g_string_sized_new(10);
	GString *command = g_string_sized_new(10);
	GString *HomeDir=g_string_sized_new(20);
	GString *ItemListWithPath = g_string_sized_new(10);
	info->Info_5 = (void *)ItemListWithPath;

	GString *gstrInfo_4Path = g_string_sized_new(20);
	info->Info_4 = (void *)gstrInfo_4Path;

    while (0 == MyEasyInputWidget (win, "open all with", "type in with which command you want to\nexecute the selected files.\nThey will be added to the end on one single line.", command)){
		g_string_assign(buf, command->str);

		cutSpacesFromGString(buf);
		if (strcmp(buf->str,".")==0 || strcmp(buf->str,"..")==0 || strlen(buf->str)==0 || strstr(buf->str,"/..")!=NULL  ){
			MyMessageWidget(win, "not possible", "Iam not allowed to call this!\nThis means me, the programm, not the user");
		}
		else{
			if (info->source == SOURCE_SIDEOBJECT){
				TRACEIT(6,"callAllWith		SideObject");
				selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(Object->listView));
			}
			else{
				TRACEIT(6,"callAllWith		Not a SideObject");
				selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(info->Info_1));
			}
			info->Info_2 = (void *)ItemList;
			gtk_tree_selection_selected_foreach(selection, callAllWithHelper, info);
			if (info->source == SOURCE_SIDEOBJECT){
				callItemsToSystemWrap(command, ItemList, ItemListWithPath, Object->gstrPath, (getOtherSideObject(Object))->gstrPath, NULL, TRUE);
			}
			else{
				getHomeDirectory(&HomeDir);
				callItemsToSystemWrap(command, ItemList, ItemList, HomeDir, HomeDir, NULL, TRUE);
			}

			break;
		}
	}

	g_string_free( ItemList ,TRUE);
	g_string_free( buf ,TRUE);
	g_string_free( command ,TRUE);
	g_string_free(HomeDir,TRUE);
	g_string_free(gstrInfo_4Path,TRUE);
	TRACEIT(10,"callAllWith		ends");
}


void callAllWith_WraperforSideObject(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"callAllWith_WraperforSideObject		start");
	struct AllInformationAllUseStruct info;
	info.source = SOURCE_SIDEOBJECT;
	info.Info_1 = (void *)data;
	callAllWith(menuitem, (void *)&info);
	TRACEIT(10,"callAllWith_WraperforSideObject		ends");
}


void callEachWith_ListHelper (GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data) {
    //collecting item names with gtk_tree_selection_selected_foreach
    //gets a AllInformationAllUseStruct as data
    //Info_1 = **udateList
    //Info_2 = column1
    //Info_3 = column2  (filled when comming from FileShelf)

    struct AllInformationAllUseStruct *info = (struct AllInformationAllUseStruct *)data;
    struct updateList **itemList = (struct updateList **) info->Info_1;
    int column1=*(int *)info->Info_2;
    int column2=0;
    if (info->source == SOURCE_FILESHELF)
        column2=*(int *)info->Info_3;

    gchar *Path=NULL;
    gchar *Name=NULL;

    gtk_tree_model_get(model, iter, column1, &Name, -1);
    if (info->source == SOURCE_FILESHELF){
        gtk_tree_model_get(model, iter, column2, &Path, -1);
    }
    if ((strcmp(Name, "..")!=0 && strcmp(Name,".")!=0)){
        updateList_addItem(itemList, Name, Path, NULL, 0);
    }


    if (Path)
        g_free(Path);
    if (Name)
        g_free(Name);

}

void callEachWith(struct updateList *List, struct AllInformationAllUseStruct *info) {
    //keep in mind, that this function is called from other places than the function callEachWith too!
	TRACEIT(10,"callEachWithHelper		start");
	if (/*model==NULL || */List==NULL || info==NULL){
		TRACEIT(1,"callEachWithHelper		end, Parameter == NULL, THIS SHOULD NOT HAPPEN INFORM THE DEVELOPER");
		return;
	}

	struct updateList *buflist = List;
	struct SideObjectList *Object=NULL;
	if (info->source == SOURCE_SIDEOBJECT){
		Object=(struct SideObjectList *)info->Info_1;
	}
	GString *command = (GString *)info->Info_2;
	GString *gstrName = g_string_sized_new(10);
	GString *gstrPath = g_string_sized_new(10);
	GString *HomeDir = g_string_sized_new(10);
	GString *FileWithPath = g_string_sized_new(10);

	while(buflist){
        g_string_assign(gstrName, "\"");
        g_string_append(gstrName, buflist->gstrName->str);
        g_string_append(gstrName, "\"");

        if (info->source == SOURCE_SIDEOBJECT){
            g_string_assign(FileWithPath, Object->gstrPath->str);
            checkPathForLastChar(FileWithPath);
            g_string_append(FileWithPath,buflist->gstrName->str);
            g_string_prepend(FileWithPath, "\"");
            g_string_append(FileWithPath, "\"");

            callItemsToSystemWrap(command, gstrName, FileWithPath, Object->gstrPath, (getOtherSideObject(Object))->gstrPath, NULL, TRUE);
        }
        else{
            getHomeDirectory(&HomeDir);
            checkPathForLastCharOtherwise(HomeDir);

            g_string_assign(gstrPath, buflist->gstrPath->str);

            g_string_assign(FileWithPath, buflist->gstrPath->str);
            checkPathForLastChar(FileWithPath);
            g_string_append(FileWithPath,buflist->gstrName->str);
            g_string_prepend(FileWithPath, "\"");
            g_string_append(FileWithPath, "\"");

            callItemsToSystemWrap(command, gstrName, FileWithPath, gstrPath, HomeDir, NULL, TRUE);
        }
        buflist=buflist->NextItem;
    }

	g_string_free(gstrName,TRUE);
	g_string_free(gstrPath,TRUE);
	g_string_free(HomeDir,TRUE);
	g_string_free(FileWithPath, TRUE);

	TRACEIT(10,"callEachWithHelper		ends");
	return;
}


void callEachWith_WraperforSideObject(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"callEachWith_WraperforSideObject		start");
	struct AllInformationAllUseStruct info;
	info.source = SOURCE_SIDEOBJECT;
	info.Info_1 = (void *)data;
	callEachWith_Menuitem(menuitem, (void *)&info);
	TRACEIT(10,"callEachWith_WraperforSideObject		ends");
}


void callEachWith_Menuitem(GtkWidget *menuitem, gpointer data){
    //this should only be called from within the contextmenu because we do ask for a command
	TRACEIT(10,"callEachWith_Menuitem		start");
	struct AllInformationAllUseStruct *info= (struct AllInformationAllUseStruct *)data;
	struct SideObjectList *Object=NULL;
	if (info->source == SOURCE_SIDEOBJECT){
		Object=(struct SideObjectList *)info->Info_1;
	}
	GString *buf = g_string_sized_new(10);
	GString *command = g_string_sized_new(10);

	GtkTreeSelection	*selection;
    struct updateList *updateList_List=NULL;
    struct updateList *updateList_BufList=NULL; //
    struct AllInformationAllUseStruct info_foreachlist;
    info_foreachlist.source = info->source;
    info_foreachlist.Info_1 = (void *)&updateList_List;
    int column1 = 0;
    int column2 = 0;
    info_foreachlist.Info_2 = (void *)&column1;
    info_foreachlist.Info_3 = (void *)&column2;

    while (0==MyEasyInputWidget (win, "open each with", "type in with which command you want to execute the selected files.\nEach item is called with the command for its own.\nThis means that you will have as many instances of\nyour program as many items you have selected.", command)){

		g_string_assign(buf, command->str);

		cutSpacesFromGString(buf);
		if (strcmp(buf->str,".")==0 || strcmp(buf->str,"..")==0 || strlen(buf->str)==0 || strstr(buf->str,"/..")!=NULL  ){
			MyMessageWidget(win, "not possible", "Iam not allowed to call this!\nThis means me, the programm, not the user");
		}
		else{
			if (info->source == SOURCE_SIDEOBJECT){
				selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(Object->listView));
				column1 = COL_NAME;
			}
			else{   //Fileshelf
				selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(info->Info_1));
				column1 = COL_FLSHLF_NAME;
				column2 = COL_FLSHLF_PATH;
			}
			gtk_tree_selection_selected_foreach(selection, callEachWith_ListHelper, (void *)&info_foreachlist);

			info->Info_2 = (void *)command;

            //make the name variable of the list inheriting the path
            //We do this in the case we call each because of:
            //when the command is very fast (e.g. chmod) and you remember that we change the working directory before and after
            //we call the command to the shell, it is possible that the second change (changing back to home directory) appears
            //between the first change (to items directory) and the function call giving the command to the shell, what leads to
            //errors on the existance of the items as they can not be found within the home directory.
            //REMEBER that this does NOT have any influence to the newUserCommand, this means, that it is more save to use <MIWP>
            //variables in the newUserCommand.
            updateList_BufList = updateList_List;
			updateList_getFirstItem(&updateList_BufList);
            while(updateList_BufList){
                if (info->source == SOURCE_SIDEOBJECT){
                    g_string_assign(buf,Object->gstrPath->str);
                }
                else{   //fileshelf
                    g_string_assign(buf,updateList_BufList->gstrPath->str);

                }
                checkPathForLastChar(buf);
                g_string_prepend(updateList_BufList->gstrName, buf->str);
                updateList_BufList = updateList_BufList->NextItem;
            }
            //

			callEachWith(updateList_List, info);
			break;
		}
	}
	g_string_free( buf ,TRUE);
	g_string_free( command ,TRUE);

    updateList_deleteList(&updateList_List);

	TRACEIT(10,"callEachWith_Menuitem		ends");
}


void checkIfOneSelectionIsPathHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"checkIfOneSelectionIsPathHelper		start");
	int type_d;
	struct AllInformationAllUseStruct *stru = (struct AllInformationAllUseStruct *)data;
	gint *TheInfo = (gint *)stru->Info_1;
	int *Coloumn = (int *)stru->Info_2;

    gtk_tree_model_get(model, iter, *Coloumn, &type_d, -1);
    if (type_d==4 || type_d==10){
        *TheInfo = *TheInfo + 1;
        TRACEIT(10,"checkIfOneSelectionIsPathHelper		ends");
        return;
    }

	TRACEIT(10,"checkIfOneSelectionIsPathHelper		ends");
	return;
}


int checkIfOneSelectionIsPath(gpointer data, int ColoumnToUse){
	TRACEIT(10,"checkIfOneSelectionIsPath		start");
	GtkTreeSelection	*selection;
	gint IsPath=0;
	struct AllInformationAllUseStruct stru;
	stru.Info_1 = &IsPath;
	stru.Info_2 = &ColoumnToUse;

	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(data));
	gtk_tree_selection_selected_foreach(selection, checkIfOneSelectionIsPathHelper, &stru);

	TRACEIT(10,"checkIfOneSelectionIsPath		ends");
	return IsPath;
}


void checkIfOneSelectionIsPointsHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"checkIfOneSelectionIsPointsHelper		start");
	struct AllInformationAllUseStruct *stru = (struct AllInformationAllUseStruct *)data;
	gint *TheInfo = (gint *)stru->Info_1;
	int *Coloumn = (int *)stru->Info_2;

	gchar *name=NULL;

	if (gtk_tree_model_get_iter(model, iter, path)){
		gtk_tree_model_get(model, iter, *Coloumn, &name, -1);
		if (strcmp(name,".")==0 || strcmp(name,"..")==0){
			*TheInfo = *TheInfo + 1;

			if (name)
				g_free(name);
			TRACEIT(10,"checkIfOneSelectionIsPointsHelper		ends");
			return;
		}
	}
	if (name)
		g_free(name);
	TRACEIT(10,"checkIfOneSelectionIsPointsHelper		ends");
	return;
}


int checkIfOneSelectionIsPoints(gpointer data, int ColoumnToUse){
	TRACEIT(10,"checkIfOneSelectionIsPoints		start");
	GtkTreeSelection	*selection;
	gint IsPath=0;
    struct AllInformationAllUseStruct stru;
	stru.Info_1 = &IsPath;
	stru.Info_2 = &ColoumnToUse;

	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(data));
	gtk_tree_selection_selected_foreach(selection, checkIfOneSelectionIsPointsHelper, &stru);

	TRACEIT(10,"checkIfOneSelectionIsPoints		ends");
	return IsPath;
}


void getTypesOfSelectedItemsHelper(GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"getTypesOfSelectedItemsHelper		start");
	gchar *type=NULL;
	struct AllInformationAllUseStruct *info = (struct AllInformationAllUseStruct *)data;
	struct TypesOfSelectedItemsList *bufitem=NULL;

	if (gtk_tree_model_get_iter(model, iter, path)){
		if (info->source == SOURCE_SIDEOBJECT){
			gtk_tree_model_get(model, iter, COL_FILETYPE, &type, -1);
		}
		else{
			gtk_tree_model_get(model, iter, COL_FLSHLF_FILETYPE, &type, -1);
		}
		if (strcmp(type,"--")==0){
			TRACEIT(10,"getTypesOfSelectedItemsHelper		ends");
			return;
		}
		bufitem = TypesOfSelectedItemsList_GiveMeFirstItem();
		while (bufitem){
			if (strcmp(type, bufitem->gstrType->str)==0){
				if (type)
					g_free(type);
				TRACEIT(10,"getTypesOfSelectedItemsHelper		ends");
				return;
			}
			bufitem = bufitem->NextItem;
		};
		TypesOfSelectedItemsList_AddItem(type);

		if (type)
			g_free(type);
	}
	TRACEIT(10,"getTypesOfSelectedItemsHelper		ends");
	return;
}


void getTypesOfSelectedItems(gpointer data){
	TRACEIT(10,"getTypesOfSelectedItems		start");
	struct AllInformationAllUseStruct *info = (struct AllInformationAllUseStruct *)data;

	GtkTreeSelection	*selection;

	selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(info->Info_1));
	gtk_tree_selection_selected_foreach(selection, getTypesOfSelectedItemsHelper, data);
	TRACEIT(10,"getTypesOfSelectedItems		ends");
}


void getUserProgramsForSelectedItems(gpointer data){
	TRACEIT(10,"getUserProgramsForSelectedItems		start");
	int found = 0;
	GString *UserCommand = g_string_sized_new(30);
	GString *UserCommandName = g_string_sized_new(30);

    struct myFiles_struct *filestru=NULL;
	filestru = myFiles_openConfigTypesFile("r");
	if (filestru == NULL){
		g_string_free(UserCommand,TRUE);
		g_string_free(UserCommandName,TRUE);
		TRACEIT(10,"getUserProgramsForSelectedItems		ends");
		return;
	}
	struct TypesOfSelectedItemsList *TypesList = TypesOfSelectedItemsList_GiveMeFirstItem();
	struct UserDataList *UserData = NULL;

	while (TypesList){
		if (myFiles_getValueFromIdentifier(filestru, TypesList->gstrType->str, 0) == 1){	//Filetype found
			while(myFiles_SeparateMultiValue(filestru, UserCommandName, UserCommand, 1)==1 ){
				found = 0;
				UserData = UserDataList_GiveMeFirstItem();
				while (UserData){
					if (strcmp(UserData->UserCommand->str,UserCommand->str) == 0){
						found = 1;
						break;
					}
					UserData = UserData->NextItem;
				};
				if (found == 0){
					UserDataList_AddItem(UserCommand->str, UserCommandName->str);
				}
			}
		}
		TypesList = TypesList->NextItem;
	};

	myFiles_closeFile(filestru);
	g_string_free(UserCommand,TRUE);
	g_string_free(UserCommandName,TRUE);
	TRACEIT(10,"getUserProgramsForSelectedItems		ends");
}


void getUserProgramsForCountForAllItems(gpointer data){
	TRACEIT(10,"getUserProgramsForCountForAllItems		start");
	int found = 0;
	GString *UserCommand = g_string_sized_new(30);
	GString *UserCommandName = g_string_sized_new(30);

    struct myFiles_struct *filestru=NULL;
	filestru = myFiles_openConfigTypesFile("r");
	if (filestru == NULL){
		g_string_free(UserCommand,TRUE);
		g_string_free(UserCommandName,TRUE);
		TRACEIT(10,"getUserProgramsForCountForAllItems		ends");
		return;
	}
	struct UserDataList *UserData = NULL;
	if (myFiles_getValueFromIdentifier(filestru, COUNTSFORALLITEMSKEY, 0) == 1){	//found
		while(myFiles_SeparateMultiValue(filestru, UserCommandName, UserCommand, 1)==1 ){
			found = 0;
			UserData = UserDataList_GiveMeFirstItem();
			while (UserData){
				if (strcmp(UserData->UserCommand->str,UserCommand->str) == 0){
					found = 1;
					break;
				}
				UserData = UserData->NextItem;
			};
			if (found == 0){
				UserDataList_AddItem(UserCommand->str, UserCommandName->str);
			}
		};
	}

	myFiles_closeFile(filestru);
	g_string_free(UserCommand,TRUE);
	g_string_free(UserCommandName,TRUE);
	TRACEIT(10,"getUserProgramsForCountForAllItems		ends");
}


void getStandardEditor(){
	TRACEIT(10,"getStandardEditor		start");
	if (TheStandardEditorStruct.UserCommand != NULL){
		g_string_free(TheStandardEditorStruct.UserCommand,TRUE);
		TheStandardEditorStruct.UserCommand = NULL;
	}
	if (TheStandardEditorStruct.UserCommandName != NULL){
		g_string_free(TheStandardEditorStruct.UserCommandName,TRUE);
		TheStandardEditorStruct.UserCommandName = NULL;
	}

	GString *UserCommand = g_string_sized_new(30);
	GString *UserCommandName = g_string_sized_new(30);

    struct myFiles_struct *filestru=NULL;
	filestru = myFiles_openConfigTypesFile("r");
	if (filestru == NULL){
		g_string_free(UserCommand,TRUE);
		g_string_free(UserCommandName,TRUE);
		TRACEIT(10,"getStandardEditor		ends");
		return;
	}

	int ret=myFiles_getValueFromIdentifier(filestru, STANDARDEDITORKEY, 0);
	if ( ret== 1){	//found
		if (myFiles_SeparateMultiValue(filestru, UserCommandName, UserCommand, 1)==1){
			TheStandardEditorStruct.UserCommand = g_string_new(UserCommand->str);
			TheStandardEditorStruct.UserCommandName = g_string_new(UserCommandName->str);
		}
	}

	myFiles_closeFile(filestru);
	g_string_free(UserCommand,TRUE);
	g_string_free(UserCommandName,TRUE);
	TRACEIT(10,"getStandardEditor		ends");
}


void getTerminal(){
	TRACEIT(10,"getTerminal		start");
	if (TheTerminalStruct.UserCommand != NULL){
		g_string_free(TheTerminalStruct.UserCommand,TRUE);
		TheTerminalStruct.UserCommand=NULL;
	}
	if (TheTerminalStruct.UserCommandName != NULL){
		g_string_free(TheTerminalStruct.UserCommandName,TRUE);
		TheTerminalStruct.UserCommandName=NULL;
	}

	GString *UserCommand = g_string_sized_new(30);
	GString *UserCommandName = g_string_sized_new(30);

    struct myFiles_struct *filestru=NULL;
	filestru = myFiles_openConfigTypesFile("r");
	if (filestru == NULL){
		g_string_free(UserCommand,TRUE);
		g_string_free(UserCommandName,TRUE);
		TRACEIT(10,"getTerminal		ends");
		return;
	}

	int ret=myFiles_getValueFromIdentifier(filestru, TERMINALKEY, 0);
	if ( ret== 1){	//found
		if (myFiles_SeparateMultiValue(filestru, UserCommandName, UserCommand, 1)==1){
			TheTerminalStruct.UserCommand = g_string_new(UserCommand->str);
			TheTerminalStruct.UserCommandName = g_string_new(UserCommandName->str);
		}
	}

	myFiles_closeFile(filestru);
	g_string_free(UserCommand,TRUE);
	g_string_free(UserCommandName,TRUE);
	TRACEIT(10,"getTerminal		ends");
}


void getStandardStartDirectory(GString *gstrCommand, GString *gstrCommandName){
	TRACEIT(10,"getStandardStartDirectory		start");
	if (gstrCommand==NULL || gstrCommandName==NULL){
		TRACEIT(2,"getStandardStartDirectory		ends -1  fatal: parameter are NULL");
		return;
	}

    struct myFiles_struct *filestru=NULL;
	filestru = myFiles_openConfigTypesFile("r");
	if (filestru == NULL){
		getHomeDirectory(&gstrCommand);
		g_string_assign(gstrCommandName, "home");
		TRACEIT(10,"getStandardStartDirectory		ends -1");
		return;
	}

	if (myFiles_getValueFromIdentifier(filestru, STANDARDSTARTDIRECTORY, 0) == 1){
		if (!myFiles_SeparateMultiValue(filestru, gstrCommandName, gstrCommand, 1)){
			getHomeDirectory(&gstrCommand);
			g_string_assign(gstrCommandName,"home");
		}
		else{
            cutLeadingSpacesFromGString(gstrCommand);
		}
	}
	else{
		getHomeDirectory(&gstrCommand);
		g_string_assign(gstrCommandName,"home");
	}
	myFiles_closeFile(filestru);
	TRACEIT(10,"getStandardStartDirectory		ends");
}


static void MakeList_Helper (GtkTreeModel *model,GtkTreePath *path,GtkTreeIter *iter,gpointer data){
	TRACEIT(10,"MakeList_Helper		start");
	struct AllInformationAllUseStruct *info = (struct AllInformationAllUseStruct *)data;
	if (info == NULL){
		return;
	}
	gchar *Name = NULL;
	gchar *Path = NULL;
	GString *gstrSource = g_string_new(((GString *)info->Info_2)->str);
	GString *gstrDest = g_string_new(((GString *)info->Info_3)->str);
	struct CopyReMoveList **FirstItem = (struct CopyReMoveList **)info->Info_1;

	if (gtk_tree_model_get_iter(model, iter, path)){
		if (info->source == SOURCE_SIDEOBJECT){
			gtk_tree_model_get(model, iter, COL_NAME, &Name, -1);
			checkPathForLastChar(gstrSource);
			if (!(strcmp(Name, "..")==0 || strcmp(Name,".")==0)){
				g_string_append(gstrSource,Name);
				checkPathForLastCharOtherwise(gstrSource);
				g_string_prepend_c(gstrSource,'\"');
				g_string_append_c(gstrSource,'\"');
				checkPathForLastCharOtherwise(gstrDest);
				CopyReMoveList_AddItem ( FirstItem, gstrSource->str, gstrDest->str, NULL, NULL, NULL);
			}
		}
		else{
			gtk_tree_model_get(model, iter, COL_FLSHLF_NAME, &Name, COL_FLSHLF_PATH, &Path, -1);
			g_string_assign(gstrSource,Path);
			checkPathForLastChar(gstrSource);
			if (!(strcmp(Name, "..")==0 || strcmp(Name,".")==0)){
				g_string_append(gstrSource,Name);
				checkPathForLastCharOtherwise(gstrSource);
				g_string_prepend_c(gstrSource,'\"');
				g_string_append_c(gstrSource,'\"');
				checkPathForLastCharOtherwise(gstrDest);
				CopyReMoveList_AddItem ( FirstItem, gstrSource->str, gstrDest->str, NULL, NULL, NULL);
			}
		}
	}
	if (Name)
		g_free(Name);
	if (Path)
		g_free(Path);
	g_string_free(gstrSource,TRUE);
	g_string_free(gstrDest,TRUE);
	TRACEIT(10,"MakeList_Helper		ends");
}


int MakeList (int Source, struct CopyReMoveList **FirstItem, GtkTreeSelection *selection, GString *SourcePath, GString *gstrDestPath){
	TRACEIT(10,"MakeList		start");
	if (FirstItem == NULL || selection == NULL){
		return -1;
	}
	struct AllInformationAllUseStruct info;
	info.source = Source;
	info.Info_1 = (void *)FirstItem;
	info.Info_2 = (void *)SourcePath;
	info.Info_3 = (void *)gstrDestPath;

	gtk_tree_selection_selected_foreach(selection, MakeList_Helper, (void *)&info);

	if (*FirstItem == NULL){
		TRACEIT(3,"MakeList		end -1");
		return -1;
	}
	TRACEIT(10,"MakeList		end");
	return 0;
}


void startItemsWithUserCommand(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"startItemsWithUserCommand		start");
	GtkTreeSelection	*selection=NULL;
	struct AllInformationAllUseStruct *info=(struct AllInformationAllUseStruct *)data;
	struct UserDataList *TheStruct = info->Info_1;
	GString *ItemList=g_string_sized_new(100);
	GString *HomeDir = g_string_sized_new(20);
	info->Info_2=(void *)ItemList;
	GString *gstrInfo_4Path = g_string_sized_new(20);
	GString *FileListWithPath = g_string_sized_new(20);
	info->Info_4 = (void *)gstrInfo_4Path;
	info->Info_5 = (void *)FileListWithPath;
	GString *gstrCaption = NULL;
	GString *gstrLabel = NULL;
	GString *gstrCall = NULL;
	int i_CallType=USERCOMMAND_CALLAS_CALLALL;
	struct CopyReMoveList *FirstItem=NULL;
	int ret;
	GError *Error=NULL;
	//some data for the each section
	struct AllInformationAllUseStruct Each_Info;
	struct AllInformationAllUseStruct Each_Info_2;  //for the foreach call
	//GtkTreeModel *model;
    //GList *selList = NULL;
    struct updateList *updateList_List=NULL;
    Each_Info_2.source = info->source;
    Each_Info_2.Info_1 = (void *)&updateList_List;
    int column1 = 0;
    int column2 = 0;
    Each_Info_2.Info_2 = (void *)&column1;
    Each_Info_2.Info_3 = (void *)&column2;

	UserCommandCallType(TheStruct->UserCommand, &i_CallType, &gstrCaption, &gstrLabel, &gstrCall);

	getHomeDirectory(&HomeDir);
	checkPathForLastCharOtherwise(HomeDir);

	//EACH

	if (info->source == SOURCE_SIDEOBJECT/* && TheStruct != &TheTerminalStruct*/){
		TRACEIT(10,"startItemsWithUserCommand		SideObject");
		Each_Info.Info_1 = (void *)TheStruct->Object;
		selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(TheStruct->Object->listView));
		column1 = COL_NAME;
	}
	else if(info->source == SOURCE_FILESHELF /*&& TheStruct != &TheTerminalStruct*/){
		TRACEIT(10,"startItemsWithUserCommand		Fileshelf");
		Each_Info.Info_1 = NULL;
		selection  = gtk_tree_view_get_selection(GTK_TREE_VIEW(info->Info_3));
		column1 = COL_FLSHLF_NAME;
        column2 = COL_FLSHLF_PATH;
	}
	if (i_CallType == USERCOMMAND_CALLAS_CALLEACH){
		TRACEIT(10,"startItemsWithUserCommand		CallEach");
		Each_Info.source = info->source;
		Each_Info.Info_2 = (void *)TheStruct->UserCommand;

		gtk_tree_selection_selected_foreach(selection, callEachWith_ListHelper, (void *)&Each_Info_2);
		//selList = gtk_tree_selection_get_selected_rows (selection,&model);
		//if (selList != NULL){
        callEachWith( updateList_List, &Each_Info);
        updateList_deleteList(&updateList_List);
		//}
		//else{
		//	TRACEIT(4,"callEachWith		end, nothing selected?");
		//}
		//gtk_tree_selection_selected_foreach(selection, callEachWithHelper, &Each_Info);
	}
	//LIST
	else if (i_CallType == USERCOMMAND_CALLAS_LIST){
		TRACEIT(10,"startItemsWithUserCommand		CallViaList");
		if (info->source == SOURCE_SIDEOBJECT){
			ret = MakeList (info->source, &FirstItem, selection, TheStruct->Object->gstrPath, (getOtherSideObject(TheStruct->Object))->gstrPath) ;
		}
		else if  (info->source != SOURCE_SIDEOBJECT){
			ret = MakeList (info->source, &FirstItem, selection, gstrInfo_4Path, HomeDir);
		}
		if (0 == ret){	// all is good
			if( !g_thread_supported() ){
				g_thread_init(NULL);
			}
			FirstItem->UserCommand=g_string_new(TheStruct->UserCommand->str);
			if (gstrCaption)
				FirstItem->gstrCaption=g_string_new(gstrCaption->str);
			if (gstrLabel)
				FirstItem->gstrLabel=g_string_new(gstrLabel->str);

			g_thread_create((GThreadFunc)ProcessUserCommandViaList, (void *)FirstItem , FALSE, &Error);
			if (Error){
				TRACEIT(2,"ProcessItemsViaListWrap: error in g_thread_create:");
				TRACEIT(2,Error->message);
				g_error_free(Error);
				Error=NULL;
			}
		}
	}
	//ALL
	else{   //As fallback: CALLAS_ALL
		TRACEIT(10,"startItemsWithUserCommand		Call standard, all");
		gtk_tree_selection_selected_foreach(selection, callAllWithHelper, info);
		if (TheStruct == &TheTerminalStruct){
		    TRACEIT(10,"startItemsWithUserCommand		Terminal");
			g_string_assign(ItemList," ");
		}
		if (info->source == SOURCE_SIDEOBJECT){
			callItemsToSystemWrap(TheStruct->UserCommand, ItemList, FileListWithPath, TheStruct->Object->gstrPath, (getOtherSideObject(TheStruct->Object))->gstrPath, NULL, TRUE);
		}
		else{
			callItemsToSystemWrap(TheStruct->UserCommand, ItemList, ItemList, gstrInfo_4Path, HomeDir, NULL, TRUE);
		}
	}

	g_string_free( ItemList ,TRUE);
	g_string_free(gstrInfo_4Path,TRUE);
	g_string_free(HomeDir,TRUE);
	g_string_free(FileListWithPath, TRUE);
	if (gstrCaption)
		g_string_free(gstrCaption,TRUE);
	if (gstrLabel)
		g_string_free(gstrLabel,TRUE);
	if (gstrCall)
		g_string_free(gstrCall,TRUE);

	TRACEIT(10,"startItemsWithUserCommand		ends");
}


void startItemsWithUserCommand_WraperforSideObject(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"startItemsWithUserCommand_WraperforSideObject		start");
	struct AllInformationAllUseStruct info;
	info.source = SOURCE_SIDEOBJECT;
	info.Info_1 = (void *)data;	//data is from type userdatastruct
	startItemsWithUserCommand(menuitem, (void *)&info);
	TRACEIT(10,"startItemsWithUserCommand_WraperforSideObject		ends");
}


void freeTypesAndUserProgrammArrays(){
	TRACEIT(10,"freeTypesAndUserProgrammArrays		start");

	UserCommand_DeleteAllReservedThings();

	TRACEIT(10,"freeTypesAndUserProgrammArrays		ends");
}

#ifdef WORKING

void monitoredDirChanged (GFileMonitor *monitor, GFile *file, GFile *other_file, GFileMonitorEvent event_type, gpointer user_data){
    MyMessageWidget(NULL,"moitor","changed signal");
}


void workingMenuItem(GtkWidget *menuitem, gpointer data){
    MyMessageWidget(NULL,"etst","terste");
/*
    char buf[]= "/test1/test2/test3/test4";

    GString *gstrTest = g_string_new(buf);
    GetPathFromPathWithName(gstrTest, 1);

    printf("buf=%s  gstrTest=%s\n",buf,gstrTest->str);

    g_string_assign(gstrTest, buf);
    GetPathFromPathWithName(gstrTest, 1);
    printf("buf=%s  gstrTest=%s\n",buf,gstrTest->str);
*/
    //AUTOMATIC UPDATE TEST
    GFile *file = g_file_new_for_path ("/wurzel");

    GFileMonitor *monitor = g_file_monitor_directory (file,G_FILE_MONITOR_NONE,NULL,NULL);

    if (monitor == NULL){
        MyMessageWidget(NULL,"NOT", "NOT SUPPORTED");
    }

    g_signal_connect(monitor,"changed",G_CALLBACK(monitoredDirChanged),NULL);

    MyMessageWidget(NULL,"monitor", "Continuing when pressing on ok");

    if (TRUE == g_file_monitor_cancel ( monitor )){
        MyMessageWidget(NULL,"monitor", "canceling supported");
    }
    else{
        MyMessageWidget(NULL,"monitor", "canceling not supported");
    }

    g_object_unref(monitor);
    g_object_unref(file);


//copy test

/*    GString *gstrError=g_string_sized_new(10);
    GError *error=NULL;

    //GFile *Sourcefile = g_file_new_for_path ("/wurzel/TEMP/ttest/New");
    GFile *Sourcefile = g_file_new_for_path( "/wurzel/TEMP/ttest/New");

    GFile *Destfile = g_file_new_for_path ("/wurzel/TEMP/test/New");

    MyMessageWidget(NULL,"ready","ready to start copying");
    gboolean ret= g_file_copy (  Sourcefile,
                            Destfile,
                            G_FILE_COPY_OVERWRITE,
                            NULL,
                            NULL,
                            NULL,
                            &error);
    MyMessageWidget(NULL,"ready","copying finished");
    if (ret)
        MyMessageWidget(NULL,"ready","success");
    else{
        MyMessageWidget(NULL,"ready","fault");
        g_string_printf(gstrError, "Error: code: %d, message:%s",error->code, error->message);
        MyMessageWidget(NULL,"ready",gstrError->str);
    }
    g_object_unref(Sourcefile);
    g_object_unref(Destfile);

    updateObjectsViewingFolder("/wurzel/TEMP/test");
    g_string_free(gstrError, TRUE);
    */
}

#endif
/////////////////////////////////////////////////////////////////////////////////////
//////////////////////    CONTEXTMENU       /////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////


void openContextMenu(GtkWidget *treeview, GdkEventButton *event, gpointer data){
	TRACEIT(10,"openContextMenu		start");
	GtkWidget *menu, *menuitem;
	struct SideObjectList *Object=(struct SideObjectList *)data;
	menu = gtk_menu_new();
	struct AllInformationAllUseStruct info;
	info.source = SOURCE_SIDEOBJECT;
	info.Info_1 = (void *)Object->listView;
	GtkTreeSelection *selection;
	GtkWidget *sep1, *sep2, *sep3, *sep4, *sep5;
	int NumOfSelectedRows=0;

	freeTypesAndUserProgrammArrays();

	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
	if (gtk_tree_selection_count_selected_rows(selection)  <= 1 && event != NULL){   //Event can be NULL if the key for contextmenu is presed
		GtkTreePath *path;
        TRACEIT(11,"openContextMenu		mark the item coverd by mousepointer");
        if (gtk_tree_view_get_path_at_pos(GTK_TREE_VIEW(treeview), (gint) event->x, (gint) event->y, &path, NULL, NULL, NULL)){
			gtk_tree_selection_unselect_all(selection);
			gtk_tree_selection_select_path(selection, path);
			gtk_tree_path_free(path);
		}
	}
    NumOfSelectedRows = gtk_tree_selection_count_selected_rows(selection);

    TRACEIT(11,"openContextMenu		create seperator");
	sep1 = gtk_separator_menu_item_new ();
	sep2 = gtk_separator_menu_item_new ();
	sep3 = gtk_separator_menu_item_new ();
	sep4 = gtk_separator_menu_item_new ();
	sep5 = gtk_separator_menu_item_new ();

	menuitem = gtk_menu_item_new_with_label("update panel");
	g_signal_connect(menuitem,"activate",G_CALLBACK(updatePannels),data);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

    TRACEIT(11,"openContextMenu		checking of one selection is path");
	if (checkIfOneSelectionIsPath(Object->listView, COL_TYPE_D) != 0){
		menuitem = gtk_menu_item_new_with_label("open in new panel");
		g_signal_connect(menuitem,"activate", G_CALLBACK( openInNewPannel),data);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
	}

    TRACEIT(11,"openContextMenu		fill the terminal structure");
	getTerminal();
	if (TheTerminalStruct.UserCommand != NULL && TheTerminalStruct.UserCommandName != NULL){
		TheTerminalStruct.Object = (struct SideObjectList *)data;
		menuitem = gtk_menu_item_new_with_label(TheTerminalStruct.UserCommandName->str);
		g_signal_connect(menuitem,"activate",G_CALLBACK(startItemsWithUserCommand_WraperforSideObject),&TheTerminalStruct);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
	}

    menuitem = gtk_menu_item_new_with_label("search for...");
    g_signal_connect(menuitem, "activate", G_CALLBACK(searchStringInDirectoryRecursive_SideObject), Object);
    gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);


    if (NumOfSelectedRows >= 1){
        menuitem = gtk_menu_item_new_with_label("search highlighted...");
        g_signal_connect(menuitem,"activate",G_CALLBACK(searchStringInAndHighlightItems_WraperforSideObject),Object->listView);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

        menuitem = gtk_menu_item_new_with_label("size...");
        g_signal_connect(menuitem,"activate",G_CALLBACK(sizeOfSelectedItemsRecursive),Object);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
    }

	gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep1);

	//UserProgams/////////////////////////////////////////
	TRACEIT(11,"openContextMenu		starting with user command section");

	if (checkIfOneSelectionIsPath(Object->listView, COL_FLSHLF_TYPE_D) == 0 ){

		getStandardEditor();
		if (TheStandardEditorStruct.UserCommand != NULL && TheStandardEditorStruct.UserCommandName != NULL){
			TheStandardEditorStruct.Object = (struct SideObjectList *)data;
			menuitem = gtk_menu_item_new_with_label(TheStandardEditorStruct.UserCommandName->str);
			g_signal_connect(menuitem,"activate",G_CALLBACK(startItemsWithUserCommand_WraperforSideObject),&TheStandardEditorStruct);
			gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
		}

		getTypesOfSelectedItems(&info);
		getUserProgramsForSelectedItems(NULL);
	}
	if (checkIfOneSelectionIsPoints(Object->listView, COL_NAME) == 0){
		getUserProgramsForCountForAllItems(NULL);
	}

	UserCommand_CreateUserMenu(menu);

	struct UserDataList *UserData = UserDataList_GiveMeFirstItem();
	while (UserData){
		UserData->Object = (struct SideObjectList *)data;

		menuitem = gtk_menu_item_new_with_label(UserData->UserCommandName->str);
		g_signal_connect(menuitem,"activate",G_CALLBACK(startItemsWithUserCommand_WraperforSideObject),UserData);
		gtk_menu_shell_append(GTK_MENU_SHELL(UserData->MenuToAddTo), menuitem);
		UserData = UserData->NextItem;
	};

	UserCommand_AttachUserMenu();

    TRACEIT(11,"openContextMenu		end usercommand section");
	//EndUserPrograms/////////////////////////////////////

		gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep2);

    if (NumOfSelectedRows >= 1){
        menuitem = gtk_menu_item_new_with_label("open all with...");
        g_signal_connect(menuitem,"activate",G_CALLBACK(callAllWith_WraperforSideObject),data);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

        menuitem = gtk_menu_item_new_with_label("open each with...");
        g_signal_connect(menuitem,"activate",G_CALLBACK(callEachWith_WraperforSideObject),data);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
    }
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep3);

    if (NumOfSelectedRows >= 1){
        menuitem = gtk_menu_item_new_with_label("copy to other panel");
        g_signal_connect(menuitem,"activate", G_CALLBACK( copyToOtherPannel),data);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

        menuitem = gtk_menu_item_new_with_label("move to other panel");
        g_signal_connect(menuitem,"activate",G_CALLBACK(moveToOtherPannel),data);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

        menuitem = gtk_menu_item_new_with_label("rename...");
        g_signal_connect(menuitem,"activate",G_CALLBACK(renameItems),data);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
    }

	menuitem = gtk_menu_item_new_with_label("new directory...");
	g_signal_connect(menuitem,"activate",G_CALLBACK(mayNewDirectory),data);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

		gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep4);

    if (NumOfSelectedRows >= 1){
        menuitem = gtk_menu_item_new_with_label("add to fileshelf");
        g_signal_connect(menuitem,"activate",G_CALLBACK(MenuAddItemToFileshelf),data);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

        menuitem = gtk_menu_item_new_with_label("add to new fileshelf");
        g_signal_connect(menuitem,"activate",G_CALLBACK(MenuAddToNewFileshelf),data);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
    }

		gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep5);

    if (NumOfSelectedRows >= 1){
        menuitem = gtk_menu_item_new_with_label("remove");
        g_signal_connect(menuitem, "activate", G_CALLBACK( mayDeleteSelectedRows), data);
        gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
    }

	gtk_widget_show_all(menu);
	// Note: event can be NULL here when called from view_onPopupMenu;
	// gdk_event_get_time() accepts a NULL argument
	gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, (event != NULL) ? event->button : 0, gdk_event_get_time((GdkEvent*)event));


	TRACEIT(10,"openContextMenu		ends");
}


void openTabContextMenu(GtkWidget *notebook, GdkEventButton *event, gpointer data){
	TRACEIT(10,"openTabContextMenu		start");
	GtkWidget *menu, *menuitem, *menuNewBookmarks, *menuGoToBookmarks, *menuInternals;
	menu = gtk_menu_new();

	menuNewBookmarks = gtk_menu_new();
	menuGoToBookmarks = gtk_menu_new();
	menuInternals = gtk_menu_new();
	GtkWidget *sep1, *sep2, *sep3, *sep4, *sep5;

	sep1 = gtk_separator_menu_item_new ();
	sep2 = gtk_separator_menu_item_new ();
	sep3 = gtk_separator_menu_item_new ();
	sep4 = gtk_separator_menu_item_new ();
	sep5 = gtk_separator_menu_item_new ();

    struct SideObjectList *Object=NULL;
	SideObjectList_GetActiveObject((GtkNotebook *)notebook, &Object);

	struct bookmarklist *Bookmark=NULL;
	bookmarklist_LoadBookmarks();
	bookmarklist_GetFirstBookmark(&Bookmark);
	if (Bookmark != NULL){
		while(Bookmark!=NULL){
			menuitem = gtk_menu_item_new_with_label(Bookmark->BookMarkName->str);
			Bookmark->notebook =GTK_NOTEBOOK(notebook);
			g_signal_connect(menuitem,"activate",G_CALLBACK(addNewPageFromBookmarks),Bookmark);
			gtk_menu_shell_append(GTK_MENU_SHELL(menuNewBookmarks), menuitem);

			menuitem = gtk_menu_item_new_with_label(Bookmark->BookMarkName->str);
			g_signal_connect(menuitem,"activate",G_CALLBACK(goToFromBookmarks),Bookmark);
			gtk_menu_shell_append(GTK_MENU_SHELL(menuGoToBookmarks), menuitem);

			Bookmark = Bookmark->NextItem;
		}
		menuitem = gtk_menu_item_new_with_label("go to Bookmark");
		gtk_menu_item_set_submenu ((GtkMenuItem *)menuitem,menuGoToBookmarks);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);


		menuitem = gtk_menu_item_new_with_label("new page from Bookmark");
		gtk_menu_item_set_submenu ((GtkMenuItem *)menuitem,menuNewBookmarks);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
	}

	menuitem = gtk_menu_item_new_with_label("new page");
	g_signal_connect(menuitem,"activate",G_CALLBACK(addNewPage),notebook);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

		gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep1);

	menuitem = gtk_menu_item_new_with_label("dublicate active page");
	g_signal_connect(menuitem,"activate",G_CALLBACK(dublicateActivePage),notebook);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

	if (1<gtk_notebook_get_n_pages(GTK_NOTEBOOK(notebook))){
		menuitem = gtk_menu_item_new_with_label("move active page");
		g_signal_connect(menuitem,"activate",G_CALLBACK(moveActivePage),notebook);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
	}

	menuitem = gtk_menu_item_new_with_label("copy active page");
	g_signal_connect(menuitem,"activate",G_CALLBACK(copyActivePage),notebook);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

		gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep2);
	//INTERNAL MENU START
        menuitem = gtk_menu_item_new_with_label("current path as bookmark");
        g_signal_connect(menuitem,"activate",G_CALLBACK(internalSavePatheAsBookmark_wrap),Object->gstrPath->str);
        gtk_menu_shell_append(GTK_MENU_SHELL(menuInternals), menuitem);

        menuitem = gtk_menu_item_new_with_label("save pathes and FileShelfs");
        g_signal_connect(menuitem,"activate",G_CALLBACK(internalSavePathesAndShelfs),NULL);
        gtk_menu_shell_append(GTK_MENU_SHELL(menuInternals), menuitem);

        menuitem = gtk_menu_item_new_with_label("create simple conf file");
        g_signal_connect(menuitem,"activate",G_CALLBACK(internalMenuCreateConfigFile),NULL);
        gtk_menu_shell_append(GTK_MENU_SHELL(menuInternals), menuitem);

        gtk_menu_shell_append(GTK_MENU_SHELL(menuInternals), sep4);

        menuitem = gtk_menu_item_new_with_label("command history");
        g_signal_connect(menuitem,"activate",G_CALLBACK(internalMenuCommandHistory),NULL);
        gtk_menu_shell_append(GTK_MENU_SHELL(menuInternals), menuitem);

        gtk_menu_shell_append(GTK_MENU_SHELL(menuInternals), sep5);

        menuitem = gtk_menu_item_new_with_label("about Cat'sEyE");
        g_signal_connect(menuitem,"activate",G_CALLBACK(internalMenuAbout),NULL);
        gtk_menu_shell_append(GTK_MENU_SHELL(menuInternals), menuitem);

	menuitem = gtk_menu_item_new_with_label("internals");
	gtk_menu_item_set_submenu ((GtkMenuItem *)menuitem,menuInternals);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

	//INTERNAL MENU END

		gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep3);

    if (g_int_AlwaysShowHidden==0){
        menuitem = gtk_menu_item_new_with_label("always show hidden files (all tabs)");
    }
    else{
        menuitem = gtk_menu_item_new_with_label("do not show hidden files (all tabs)");
    }
    g_signal_connect(menuitem,"activate",G_CALLBACK(AlwaysShowHiddenfilesInAllTabs),NULL);
    gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

	if (Object != NULL){
		if (Object->showHiddenFiles){
			menuitem = gtk_menu_item_new_with_label("hide hidden files (this tab)");
		}
		else{
			menuitem = gtk_menu_item_new_with_label("show hidden files (this tab)");
		}
	}
	else{
		menuitem = gtk_menu_item_new_with_label("show hidden files");
	}

	g_signal_connect(menuitem,"activate",G_CALLBACK(showHiddenFilesInActivePage),notebook);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);


	if (1<gtk_notebook_get_n_pages(GTK_NOTEBOOK(notebook))){
		menuitem = gtk_menu_item_new_with_label("close active page");
		g_signal_connect(menuitem,"activate",G_CALLBACK(closeActivePage),notebook);
		gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);
	}

#ifdef WORKING
    menuitem = gtk_menu_item_new_with_label("Working item");
	g_signal_connect(menuitem,"activate",G_CALLBACK(workingMenuItem),NULL);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menuitem);

#endif


	gtk_widget_show_all(menu);
	// Note: event can be NULL here when called from view_onPopupMenu;
	// gdk_event_get_time() accepts a NULL argument
	gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, (event != NULL) ? event->button : 0, gdk_event_get_time((GdkEvent*)event));

	TRACEIT(10,"openTabContextMenu		ends");
}

//////////////////////    CONTEXTMENU       /////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

void internalSavePatheAsBookmark_wrap(GtkWidget *menuitem, gpointer data){
    internalSavePatheAsBookmark((char *)data);
}


void internalSavePathesAndShelfs(GtkWidget *menuitem, gpointer data){
    GtkWidget *dialog, *label;
    GString *gstrBuf = g_string_sized_new(10);

    g_string_sprintf(gstrBuf,"This will save the currently opened directories\nand FileShelfs to the standard file in your home directory:\n%s\n",SAVE_FILE);

    dialog = CreateMyDialog("Save Session", win, 2, "Ok",GTK_RESPONSE_ACCEPT,"Cancel",GTK_RESPONSE_REJECT, FALSE);
	label = gtk_label_new(gstrBuf->str);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox),label);
	gtk_widget_show_all(dialog);
	if (gtk_dialog_run(GTK_DIALOG(dialog))== GTK_RESPONSE_ACCEPT){
            saveThings();
	}
    gtk_widget_destroy(dialog);
    g_string_free(gstrBuf, TRUE);
}


void goToFromBookmarks(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"goToFromBookmarks		start");
	struct bookmarklist *Bookmark=(struct bookmarklist *)data;

	struct SideObjectList *Object=NULL;
	SideObjectList_GetActiveObject(Bookmark->notebook, &Object);
	if (Object == NULL){
		TRACEIT(10,"goToFromBookmarks		ends");
		return;
	}
	updateViewWithNewFolder(Object,Bookmark->BookMark);
	TRACEIT(10,"goToFromBookmarks		ends");
}


void addNewPageFromBookmarks(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"addNewPageFromBookmarks		start");
	struct bookmarklist *Bookmark=(struct bookmarklist *)data;
	SideObjectList_CreateNewViewWithPath(Bookmark->notebook, Bookmark->BookMark->str,NULL);
	TRACEIT(10,"addNewPageFromBookmarks		ends");
}


void AlwaysShowHiddenfilesInAllTabs(){
	TRACEIT(10,"AlwaysShowHiddenfilesInAllTabs		start");
	gboolean boolBuf=FALSE;
	if (1==g_int_AlwaysShowHidden){
		TRACEIT(11,"AlwaysShowHiddenfilesInAllTabs		hide");
		g_int_AlwaysShowHidden=0;
		boolBuf=FALSE;
	}
	else{
		TRACEIT(11,"AlwaysShowHiddenfilesInAllTabs		show");
		g_int_AlwaysShowHidden=1;
		boolBuf=TRUE;
	}

	struct SideObjectList *ObjectBuf = SideObjectList_getFirstObject();
	while (ObjectBuf != NULL){
		ObjectBuf->alwaysShowHiddenFiles=boolBuf;
		ObjectBuf->bUpdateFlag_F6=FALSE;
		//updating only the visible views is not enought, because we show a (h) in the tabs, when hidden flag is on
		SideObjectList_UpdateObject(ObjectBuf);
		ObjectBuf = SideObjectList_getNextObejct(ObjectBuf);
	}

	updateActiveViews();	//the tabs are updated within the while loop

	TRACEIT(10,"AlwaysShowHiddenfilesInAllTabs		end");
}


void showHiddenFilesInActivePage(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"showHiddenFilesInActivePage		start");
	struct SideObjectList *Object=NULL;
	SideObjectList_GetActiveObject((GtkNotebook *)data, &Object);
	if (Object == NULL){
		TRACEIT(10,"copyActivePage		ends");
		return;
	}
	Object->showHiddenFiles=!Object->showHiddenFiles;
	Object->bUpdateFlag_F6=FALSE;

	updateView(Object);
	TRACEIT(10,"showHiddenFilesInActivePage		ends");
}


void moveActivePage(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"moveActivePage		start");
	GtkNotebook *destNotebook = ( (GtkNotebook *)data == (GtkNotebook *)Notebooks[SIDE_LEFT])?(GtkNotebook *)Notebooks[SIDE_RIGHT]:(GtkNotebook *)Notebooks[SIDE_LEFT];
	SideObjectList_MoveActiveObject((GtkNotebook *)data, destNotebook);
	TRACEIT(10,"moveActivePage		ends");
}


void copyActivePage(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"copyActivePage		start");
	GtkNotebook *destNotebook = ( (GtkNotebook *)data == (GtkNotebook *)Notebooks[SIDE_LEFT])?(GtkNotebook *)Notebooks[SIDE_RIGHT]:(GtkNotebook *)Notebooks[SIDE_LEFT];
	struct SideObjectList *Object=NULL;
	SideObjectList_GetActiveObject((GtkNotebook *)data, &Object);
	if (Object == NULL){
		TRACEIT(10,"copyActivePage		ends");
		return;
	}
	SideObjectList_CreateNewViewWithPath(destNotebook, Object->gstrPath->str,Object);
	TRACEIT(10,"copyActivePage		ends");
}


void dublicateActivePage(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"dublicateActivePage		start");
	struct SideObjectList *Object=NULL;
	SideObjectList_GetActiveObject((GtkNotebook *)data, &Object);
	if (Object == NULL){
		TRACEIT(10,"dublicateActivePage		ends");
		return;
	}
	SideObjectList_CreateNewViewWithPath((GtkNotebook *)data, Object->gstrPath->str,Object);
	TRACEIT(10,"dublicateActivePage		ends");
}


void addNewPage(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"addNewPage		start");
	GString *gstrDirectory = g_string_sized_new(10);
	GString *gstrDirectoryName = g_string_sized_new(10);
	getStandardStartDirectory(gstrDirectory, gstrDirectoryName);
	SideObjectList_CreateNewViewWithPath((GtkNotebook *)data, gstrDirectory->str, NULL);
	g_string_free(gstrDirectory, TRUE);
	g_string_free(gstrDirectoryName, TRUE);
	TRACEIT(10,"addNewPage		ends");
}


void closeActivePage(GtkWidget *menuitem, gpointer data){
	TRACEIT(10,"closeActivePage		start");
	SideObjectList_DeleteActiveObject((GtkNotebook *)data);
	TRACEIT(10,"closeActivePage		ends");
}

