/*
    Copyright 2007, 2008, 2009 Geyer Klaus

    This file is part of Cat'sEyE.

    Cat'sEyE is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Cat'sEyE is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Cat'sEyE.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef USERDATA_H_
#define USERDATA_H_

void UserCommand_InitUserCommandStructOnStartup();
void UserCommand_DeleteAllReservedThings();
void UserCommand_CreateUserMenu(GtkWidget *rootmenu);
void UserCommand_AttachUserMenu();


/////////////////////////////////////////////////////////////////////////////////////////////////
///////////////// USER DATA LIST //////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////
struct UserDataList{
	GString *UserCommand;
	GString *UserCommandName;
	struct SideObjectList *Object;

	GtkWidget *MenuToAddTo; //pointer to a menue to which this item should be added

	struct UserDataList *PrevItem;
	struct UserDataList *NextItem;
};

void UserDataList_DeleteList();
void UserDataList_AddItem(char *UserCommand, char *UserCommandName);
struct UserDataList *UserDataList_GiveMeFirstItem();


/////////////////////////////////////////////////////////////////////////////////////////////////
///////////////// MENU OBJECT LIST //////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////
struct MenuObjectList{
	GtkWidget *submenu;
	GString *gstrName;
	GtkWidget *MenuToAddTo;

	struct MenuObjectList *PrevItem;
	struct MenuObjectList *NextItem;

};

void MenuObjectList_DeleteList();
void MenuObjectList_AddItem(char *Name, GtkWidget *submenu, GtkWidget *MenuToAddTo);
struct MenuObjectList *MenuObjectList_GiveMeFirstItem();

/////////////////////////////////////////////////////////////////////////////////////////////////
///////////////// TYPES OF SELECTED ITEMS LIST //////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////
struct TypesOfSelectedItemsList{
	GString *gstrType;	

	struct TypesOfSelectedItemsList *NextItem;
	struct TypesOfSelectedItemsList *PrevItem;
};

void TypesOfSelectedItemsList_DeleteList();
void TypesOfSelectedItemsList_AddItem(char *newItem);
struct TypesOfSelectedItemsList *TypesOfSelectedItemsList_GiveMeFirstItem();


#endif //USERDATA_H_

